﻿' This class is "generated" and will be overwritten.
' Your customizations should be made in EducationPeriodRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="EducationPeriodRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="EducationPeriodTable"></see> class.
''' </remarks>
''' <seealso cref="EducationPeriodTable"></seealso>
''' <seealso cref="EducationPeriodRecord"></seealso>

<Serializable()> Public Class BaseEducationPeriodRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As EducationPeriodTable = EducationPeriodTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub
	
	'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub EducationPeriodRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim EducationPeriodRec As EducationPeriodRecord = CType(sender,EducationPeriodRecord)
        Validate_Inserting()
        If Not EducationPeriodRec Is Nothing AndAlso Not EducationPeriodRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub EducationPeriodRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim EducationPeriodRec As EducationPeriodRecord = CType(sender,EducationPeriodRecord)
        Validate_Updating()
        If Not EducationPeriodRec Is Nothing AndAlso Not EducationPeriodRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub EducationPeriodRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim EducationPeriodRec As EducationPeriodRecord = CType(sender,EducationPeriodRecord)
        If Not EducationPeriodRec Is Nothing AndAlso Not EducationPeriodRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's EducationPeriod_.PeriodId field.
	''' </summary>
	Public Function GetPeriodIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.PeriodIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's EducationPeriod_.PeriodId field.
	''' </summary>
	Public Function GetPeriodIdFieldValue() As Byte
		Return CType(Me.GetValue(TableUtils.PeriodIdColumn).ToByte(), Byte)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's EducationPeriod_.PeriodId field.
	''' </summary>
	Public Sub SetPeriodIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PeriodIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's EducationPeriod_.PeriodId field.
	''' </summary>
	Public Sub SetPeriodIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.PeriodIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's EducationPeriod_.PeriodId field.
	''' </summary>
	Public Sub SetPeriodIdFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PeriodIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's EducationPeriod_.PeriodId field.
	''' </summary>
	Public Sub SetPeriodIdFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PeriodIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's EducationPeriod_.PeriodId field.
	''' </summary>
	Public Sub SetPeriodIdFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PeriodIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's EducationPeriod_.Period field.
	''' </summary>
	Public Function GetPeriodValue() As ColumnValue
		Return Me.GetValue(TableUtils.PeriodColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's EducationPeriod_.Period field.
	''' </summary>
	Public Function GetPeriodFieldValue() As String
		Return CType(Me.GetValue(TableUtils.PeriodColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's EducationPeriod_.Period field.
	''' </summary>
	Public Sub SetPeriodFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PeriodColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's EducationPeriod_.Period field.
	''' </summary>
	Public Sub SetPeriodFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PeriodColumn)
	End Sub



#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's EducationPeriod_.PeriodId field.
	''' </summary>
	Public Property PeriodId() As Byte
		Get 
			Return CType(Me.GetValue(TableUtils.PeriodIdColumn).ToByte(), Byte)
		End Get
		Set (ByVal val As Byte) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.PeriodIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PeriodIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PeriodIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PeriodIdDefault() As String
        Get
            Return TableUtils.PeriodIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's EducationPeriod_.Period field.
	''' </summary>
	Public Property Period() As String
		Get 
			Return CType(Me.GetValue(TableUtils.PeriodColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.PeriodColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PeriodSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PeriodColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PeriodDefault() As String
        Get
            Return TableUtils.PeriodColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
