﻿' This class is "generated" and will be overwritten.
' Your customizations should be made in SectionRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="SectionRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="SectionTable"></see> class.
''' </remarks>
''' <seealso cref="SectionTable"></seealso>
''' <seealso cref="SectionRecord"></seealso>

<Serializable()> Public Class BaseSectionRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As SectionTable = SectionTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub
	
	'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub SectionRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim SectionRec As SectionRecord = CType(sender,SectionRecord)
        Validate_Inserting()
        If Not SectionRec Is Nothing AndAlso Not SectionRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub SectionRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim SectionRec As SectionRecord = CType(sender,SectionRecord)
        Validate_Updating()
        If Not SectionRec Is Nothing AndAlso Not SectionRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub SectionRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim SectionRec As SectionRecord = CType(sender,SectionRecord)
        If Not SectionRec Is Nothing AndAlso Not SectionRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SectionId field.
	''' </summary>
	Public Function GetSectionIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.SectionIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SectionId field.
	''' </summary>
	Public Function GetSectionIdFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.SectionIdColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SectionId field.
	''' </summary>
	Public Sub SetSectionIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SectionIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SectionId field.
	''' </summary>
	Public Sub SetSectionIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.SectionIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SectionId field.
	''' </summary>
	Public Sub SetSectionIdFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SectionIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SectionId field.
	''' </summary>
	Public Sub SetSectionIdFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SectionIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SectionId field.
	''' </summary>
	Public Sub SetSectionIdFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SectionIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SectionName field.
	''' </summary>
	Public Function GetSectionNameValue() As ColumnValue
		Return Me.GetValue(TableUtils.SectionNameColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SectionName field.
	''' </summary>
	Public Function GetSectionNameFieldValue() As String
		Return CType(Me.GetValue(TableUtils.SectionNameColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SectionName field.
	''' </summary>
	Public Sub SetSectionNameFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SectionNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SectionName field.
	''' </summary>
	Public Sub SetSectionNameFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SectionNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SectionAbbvrName field.
	''' </summary>
	Public Function GetSectionAbbvrNameValue() As ColumnValue
		Return Me.GetValue(TableUtils.SectionAbbvrNameColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SectionAbbvrName field.
	''' </summary>
	Public Function GetSectionAbbvrNameFieldValue() As String
		Return CType(Me.GetValue(TableUtils.SectionAbbvrNameColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SectionAbbvrName field.
	''' </summary>
	Public Sub SetSectionAbbvrNameFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SectionAbbvrNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SectionAbbvrName field.
	''' </summary>
	Public Sub SetSectionAbbvrNameFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SectionAbbvrNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SectionEName field.
	''' </summary>
	Public Function GetSectionENameValue() As ColumnValue
		Return Me.GetValue(TableUtils.SectionENameColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SectionEName field.
	''' </summary>
	Public Function GetSectionENameFieldValue() As String
		Return CType(Me.GetValue(TableUtils.SectionENameColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SectionEName field.
	''' </summary>
	Public Sub SetSectionENameFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SectionENameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SectionEName field.
	''' </summary>
	Public Sub SetSectionENameFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SectionENameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.MarshallFull field.
	''' </summary>
	Public Function GetMarshallFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.MarshallFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.MarshallFull field.
	''' </summary>
	Public Function GetMarshallFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.MarshallFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MarshallFull field.
	''' </summary>
	Public Sub SetMarshallFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.MarshallFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MarshallFull field.
	''' </summary>
	Public Sub SetMarshallFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.MarshallFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MarshallFull field.
	''' </summary>
	Public Sub SetMarshallFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MarshallFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MarshallFull field.
	''' </summary>
	Public Sub SetMarshallFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MarshallFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MarshallFull field.
	''' </summary>
	Public Sub SetMarshallFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MarshallFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.MarShall field.
	''' </summary>
	Public Function GetMarShallValue() As ColumnValue
		Return Me.GetValue(TableUtils.MarShallColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.MarShall field.
	''' </summary>
	Public Function GetMarShallFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.MarShallColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MarShall field.
	''' </summary>
	Public Sub SetMarShallFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.MarShallColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MarShall field.
	''' </summary>
	Public Sub SetMarShallFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.MarShallColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MarShall field.
	''' </summary>
	Public Sub SetMarShallFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MarShallColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MarShall field.
	''' </summary>
	Public Sub SetMarShallFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MarShallColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MarShall field.
	''' </summary>
	Public Sub SetMarShallFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MarShallColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.GeneralFull field.
	''' </summary>
	Public Function GetGeneralFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.GeneralFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.GeneralFull field.
	''' </summary>
	Public Function GetGeneralFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.GeneralFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.GeneralFull field.
	''' </summary>
	Public Sub SetGeneralFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.GeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.GeneralFull field.
	''' </summary>
	Public Sub SetGeneralFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.GeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.GeneralFull field.
	''' </summary>
	Public Sub SetGeneralFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.GeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.GeneralFull field.
	''' </summary>
	Public Sub SetGeneralFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.GeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.GeneralFull field.
	''' </summary>
	Public Sub SetGeneralFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.GeneralFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.General field.
	''' </summary>
	Public Function GetGeneralValue() As ColumnValue
		Return Me.GetValue(TableUtils.GeneralColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.General field.
	''' </summary>
	Public Function GetGeneralFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.GeneralColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.General field.
	''' </summary>
	Public Sub SetGeneralFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.GeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.General field.
	''' </summary>
	Public Sub SetGeneralFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.GeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.General field.
	''' </summary>
	Public Sub SetGeneralFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.GeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.General field.
	''' </summary>
	Public Sub SetGeneralFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.GeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.General field.
	''' </summary>
	Public Sub SetGeneralFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.GeneralColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.LtGeneralFull field.
	''' </summary>
	Public Function GetLtGeneralFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.LtGeneralFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.LtGeneralFull field.
	''' </summary>
	Public Function GetLtGeneralFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.LtGeneralFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtGeneralFull field.
	''' </summary>
	Public Sub SetLtGeneralFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.LtGeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtGeneralFull field.
	''' </summary>
	Public Sub SetLtGeneralFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.LtGeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtGeneralFull field.
	''' </summary>
	Public Sub SetLtGeneralFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtGeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtGeneralFull field.
	''' </summary>
	Public Sub SetLtGeneralFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtGeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtGeneralFull field.
	''' </summary>
	Public Sub SetLtGeneralFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtGeneralFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.LtGeneral field.
	''' </summary>
	Public Function GetLtGeneralValue() As ColumnValue
		Return Me.GetValue(TableUtils.LtGeneralColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.LtGeneral field.
	''' </summary>
	Public Function GetLtGeneralFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.LtGeneralColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtGeneral field.
	''' </summary>
	Public Sub SetLtGeneralFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.LtGeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtGeneral field.
	''' </summary>
	Public Sub SetLtGeneralFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.LtGeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtGeneral field.
	''' </summary>
	Public Sub SetLtGeneralFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtGeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtGeneral field.
	''' </summary>
	Public Sub SetLtGeneralFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtGeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtGeneral field.
	''' </summary>
	Public Sub SetLtGeneralFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtGeneralColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.MjGeneralFull field.
	''' </summary>
	Public Function GetMjGeneralFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.MjGeneralFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.MjGeneralFull field.
	''' </summary>
	Public Function GetMjGeneralFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.MjGeneralFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MjGeneralFull field.
	''' </summary>
	Public Sub SetMjGeneralFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.MjGeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MjGeneralFull field.
	''' </summary>
	Public Sub SetMjGeneralFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.MjGeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MjGeneralFull field.
	''' </summary>
	Public Sub SetMjGeneralFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MjGeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MjGeneralFull field.
	''' </summary>
	Public Sub SetMjGeneralFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MjGeneralFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MjGeneralFull field.
	''' </summary>
	Public Sub SetMjGeneralFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MjGeneralFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.MjGeneral field.
	''' </summary>
	Public Function GetMjGeneralValue() As ColumnValue
		Return Me.GetValue(TableUtils.MjGeneralColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.MjGeneral field.
	''' </summary>
	Public Function GetMjGeneralFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.MjGeneralColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MjGeneral field.
	''' </summary>
	Public Sub SetMjGeneralFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.MjGeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MjGeneral field.
	''' </summary>
	Public Sub SetMjGeneralFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.MjGeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MjGeneral field.
	''' </summary>
	Public Sub SetMjGeneralFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MjGeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MjGeneral field.
	''' </summary>
	Public Sub SetMjGeneralFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MjGeneralColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MjGeneral field.
	''' </summary>
	Public Sub SetMjGeneralFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MjGeneralColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SpColonelFull field.
	''' </summary>
	Public Function GetSpColonelFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.SpColonelFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SpColonelFull field.
	''' </summary>
	Public Function GetSpColonelFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.SpColonelFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SpColonelFull field.
	''' </summary>
	Public Sub SetSpColonelFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SpColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SpColonelFull field.
	''' </summary>
	Public Sub SetSpColonelFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.SpColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SpColonelFull field.
	''' </summary>
	Public Sub SetSpColonelFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SpColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SpColonelFull field.
	''' </summary>
	Public Sub SetSpColonelFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SpColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SpColonelFull field.
	''' </summary>
	Public Sub SetSpColonelFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SpColonelFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SpColonel field.
	''' </summary>
	Public Function GetSpColonelValue() As ColumnValue
		Return Me.GetValue(TableUtils.SpColonelColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SpColonel field.
	''' </summary>
	Public Function GetSpColonelFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.SpColonelColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SpColonel field.
	''' </summary>
	Public Sub SetSpColonelFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SpColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SpColonel field.
	''' </summary>
	Public Sub SetSpColonelFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.SpColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SpColonel field.
	''' </summary>
	Public Sub SetSpColonelFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SpColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SpColonel field.
	''' </summary>
	Public Sub SetSpColonelFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SpColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SpColonel field.
	''' </summary>
	Public Sub SetSpColonelFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SpColonelColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.ColonelFull field.
	''' </summary>
	Public Function GetColonelFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.ColonelFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.ColonelFull field.
	''' </summary>
	Public Function GetColonelFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.ColonelFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.ColonelFull field.
	''' </summary>
	Public Sub SetColonelFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.ColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.ColonelFull field.
	''' </summary>
	Public Sub SetColonelFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.ColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.ColonelFull field.
	''' </summary>
	Public Sub SetColonelFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.ColonelFull field.
	''' </summary>
	Public Sub SetColonelFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.ColonelFull field.
	''' </summary>
	Public Sub SetColonelFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ColonelFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Colonel field.
	''' </summary>
	Public Function GetColonelValue() As ColumnValue
		Return Me.GetValue(TableUtils.ColonelColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Colonel field.
	''' </summary>
	Public Function GetColonelFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.ColonelColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Colonel field.
	''' </summary>
	Public Sub SetColonelFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.ColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Colonel field.
	''' </summary>
	Public Sub SetColonelFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.ColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Colonel field.
	''' </summary>
	Public Sub SetColonelFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Colonel field.
	''' </summary>
	Public Sub SetColonelFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Colonel field.
	''' </summary>
	Public Sub SetColonelFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ColonelColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.LtColonelFull field.
	''' </summary>
	Public Function GetLtColonelFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.LtColonelFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.LtColonelFull field.
	''' </summary>
	Public Function GetLtColonelFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.LtColonelFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtColonelFull field.
	''' </summary>
	Public Sub SetLtColonelFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.LtColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtColonelFull field.
	''' </summary>
	Public Sub SetLtColonelFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.LtColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtColonelFull field.
	''' </summary>
	Public Sub SetLtColonelFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtColonelFull field.
	''' </summary>
	Public Sub SetLtColonelFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtColonelFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtColonelFull field.
	''' </summary>
	Public Sub SetLtColonelFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtColonelFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.LtColonel field.
	''' </summary>
	Public Function GetLtColonelValue() As ColumnValue
		Return Me.GetValue(TableUtils.LtColonelColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.LtColonel field.
	''' </summary>
	Public Function GetLtColonelFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.LtColonelColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtColonel field.
	''' </summary>
	Public Sub SetLtColonelFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.LtColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtColonel field.
	''' </summary>
	Public Sub SetLtColonelFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.LtColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtColonel field.
	''' </summary>
	Public Sub SetLtColonelFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtColonel field.
	''' </summary>
	Public Sub SetLtColonelFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtColonelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LtColonel field.
	''' </summary>
	Public Sub SetLtColonelFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LtColonelColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.MajorFull field.
	''' </summary>
	Public Function GetMajorFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.MajorFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.MajorFull field.
	''' </summary>
	Public Function GetMajorFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.MajorFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MajorFull field.
	''' </summary>
	Public Sub SetMajorFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.MajorFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MajorFull field.
	''' </summary>
	Public Sub SetMajorFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.MajorFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MajorFull field.
	''' </summary>
	Public Sub SetMajorFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MajorFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MajorFull field.
	''' </summary>
	Public Sub SetMajorFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MajorFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.MajorFull field.
	''' </summary>
	Public Sub SetMajorFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MajorFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Major field.
	''' </summary>
	Public Function GetMajorValue() As ColumnValue
		Return Me.GetValue(TableUtils.MajorColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Major field.
	''' </summary>
	Public Function GetMajorFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.MajorColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Major field.
	''' </summary>
	Public Sub SetMajorFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.MajorColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Major field.
	''' </summary>
	Public Sub SetMajorFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.MajorColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Major field.
	''' </summary>
	Public Sub SetMajorFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MajorColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Major field.
	''' </summary>
	Public Sub SetMajorFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MajorColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Major field.
	''' </summary>
	Public Sub SetMajorFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MajorColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.CaptianFull field.
	''' </summary>
	Public Function GetCaptianFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.CaptianFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.CaptianFull field.
	''' </summary>
	Public Function GetCaptianFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.CaptianFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.CaptianFull field.
	''' </summary>
	Public Sub SetCaptianFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.CaptianFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.CaptianFull field.
	''' </summary>
	Public Sub SetCaptianFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.CaptianFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.CaptianFull field.
	''' </summary>
	Public Sub SetCaptianFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CaptianFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.CaptianFull field.
	''' </summary>
	Public Sub SetCaptianFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CaptianFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.CaptianFull field.
	''' </summary>
	Public Sub SetCaptianFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CaptianFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Captian field.
	''' </summary>
	Public Function GetCaptianValue() As ColumnValue
		Return Me.GetValue(TableUtils.CaptianColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Captian field.
	''' </summary>
	Public Function GetCaptianFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.CaptianColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Captian field.
	''' </summary>
	Public Sub SetCaptianFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.CaptianColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Captian field.
	''' </summary>
	Public Sub SetCaptianFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.CaptianColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Captian field.
	''' </summary>
	Public Sub SetCaptianFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CaptianColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Captian field.
	''' </summary>
	Public Sub SetCaptianFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CaptianColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Captian field.
	''' </summary>
	Public Sub SetCaptianFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CaptianColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.LieutenantFull field.
	''' </summary>
	Public Function GetLieutenantFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.LieutenantFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.LieutenantFull field.
	''' </summary>
	Public Function GetLieutenantFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.LieutenantFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LieutenantFull field.
	''' </summary>
	Public Sub SetLieutenantFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.LieutenantFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LieutenantFull field.
	''' </summary>
	Public Sub SetLieutenantFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.LieutenantFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LieutenantFull field.
	''' </summary>
	Public Sub SetLieutenantFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LieutenantFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LieutenantFull field.
	''' </summary>
	Public Sub SetLieutenantFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LieutenantFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.LieutenantFull field.
	''' </summary>
	Public Sub SetLieutenantFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LieutenantFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Lieutenant field.
	''' </summary>
	Public Function GetLieutenantValue() As ColumnValue
		Return Me.GetValue(TableUtils.LieutenantColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Lieutenant field.
	''' </summary>
	Public Function GetLieutenantFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.LieutenantColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Lieutenant field.
	''' </summary>
	Public Sub SetLieutenantFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.LieutenantColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Lieutenant field.
	''' </summary>
	Public Sub SetLieutenantFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.LieutenantColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Lieutenant field.
	''' </summary>
	Public Sub SetLieutenantFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LieutenantColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Lieutenant field.
	''' </summary>
	Public Sub SetLieutenantFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LieutenantColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Lieutenant field.
	''' </summary>
	Public Sub SetLieutenantFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LieutenantColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SubLieutenantFull field.
	''' </summary>
	Public Function GetSubLieutenantFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.SubLieutenantFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SubLieutenantFull field.
	''' </summary>
	Public Function GetSubLieutenantFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.SubLieutenantFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SubLieutenantFull field.
	''' </summary>
	Public Sub SetSubLieutenantFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SubLieutenantFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SubLieutenantFull field.
	''' </summary>
	Public Sub SetSubLieutenantFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.SubLieutenantFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SubLieutenantFull field.
	''' </summary>
	Public Sub SetSubLieutenantFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SubLieutenantFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SubLieutenantFull field.
	''' </summary>
	Public Sub SetSubLieutenantFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SubLieutenantFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SubLieutenantFull field.
	''' </summary>
	Public Sub SetSubLieutenantFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SubLieutenantFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SubLieutenant field.
	''' </summary>
	Public Function GetSubLieutenantValue() As ColumnValue
		Return Me.GetValue(TableUtils.SubLieutenantColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SubLieutenant field.
	''' </summary>
	Public Function GetSubLieutenantFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.SubLieutenantColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SubLieutenant field.
	''' </summary>
	Public Sub SetSubLieutenantFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SubLieutenantColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SubLieutenant field.
	''' </summary>
	Public Sub SetSubLieutenantFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.SubLieutenantColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SubLieutenant field.
	''' </summary>
	Public Sub SetSubLieutenantFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SubLieutenantColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SubLieutenant field.
	''' </summary>
	Public Sub SetSubLieutenantFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SubLieutenantColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SubLieutenant field.
	''' </summary>
	Public Sub SetSubLieutenantFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SubLieutenantColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm0Full field.
	''' </summary>
	Public Function GetSm0FullValue() As ColumnValue
		Return Me.GetValue(TableUtils.Sm0FullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm0Full field.
	''' </summary>
	Public Function GetSm0FullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.Sm0FullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm0Full field.
	''' </summary>
	Public Sub SetSm0FullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Sm0FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm0Full field.
	''' </summary>
	Public Sub SetSm0FullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.Sm0FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm0Full field.
	''' </summary>
	Public Sub SetSm0FullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm0FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm0Full field.
	''' </summary>
	Public Sub SetSm0FullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm0FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm0Full field.
	''' </summary>
	Public Sub SetSm0FullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm0FullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm0 field.
	''' </summary>
	Public Function GetSm0Value() As ColumnValue
		Return Me.GetValue(TableUtils.Sm0Column)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm0 field.
	''' </summary>
	Public Function GetSm0FieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.Sm0Column).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm0 field.
	''' </summary>
	Public Sub SetSm0FieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Sm0Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm0 field.
	''' </summary>
	Public Sub SetSm0FieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.Sm0Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm0 field.
	''' </summary>
	Public Sub SetSm0FieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm0Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm0 field.
	''' </summary>
	Public Sub SetSm0FieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm0Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm0 field.
	''' </summary>
	Public Sub SetSm0FieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm0Column)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm1Full field.
	''' </summary>
	Public Function GetSm1FullValue() As ColumnValue
		Return Me.GetValue(TableUtils.Sm1FullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm1Full field.
	''' </summary>
	Public Function GetSm1FullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.Sm1FullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm1Full field.
	''' </summary>
	Public Sub SetSm1FullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Sm1FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm1Full field.
	''' </summary>
	Public Sub SetSm1FullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.Sm1FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm1Full field.
	''' </summary>
	Public Sub SetSm1FullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm1FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm1Full field.
	''' </summary>
	Public Sub SetSm1FullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm1FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm1Full field.
	''' </summary>
	Public Sub SetSm1FullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm1FullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm1 field.
	''' </summary>
	Public Function GetSm1Value() As ColumnValue
		Return Me.GetValue(TableUtils.Sm1Column)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm1 field.
	''' </summary>
	Public Function GetSm1FieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.Sm1Column).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm1 field.
	''' </summary>
	Public Sub SetSm1FieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Sm1Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm1 field.
	''' </summary>
	Public Sub SetSm1FieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.Sm1Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm1 field.
	''' </summary>
	Public Sub SetSm1FieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm1Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm1 field.
	''' </summary>
	Public Sub SetSm1FieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm1Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm1 field.
	''' </summary>
	Public Sub SetSm1FieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm1Column)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm2Full field.
	''' </summary>
	Public Function GetSm2FullValue() As ColumnValue
		Return Me.GetValue(TableUtils.Sm2FullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm2Full field.
	''' </summary>
	Public Function GetSm2FullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.Sm2FullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm2Full field.
	''' </summary>
	Public Sub SetSm2FullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Sm2FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm2Full field.
	''' </summary>
	Public Sub SetSm2FullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.Sm2FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm2Full field.
	''' </summary>
	Public Sub SetSm2FullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm2FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm2Full field.
	''' </summary>
	Public Sub SetSm2FullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm2FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm2Full field.
	''' </summary>
	Public Sub SetSm2FullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm2FullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm2 field.
	''' </summary>
	Public Function GetSm2Value() As ColumnValue
		Return Me.GetValue(TableUtils.Sm2Column)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm2 field.
	''' </summary>
	Public Function GetSm2FieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.Sm2Column).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm2 field.
	''' </summary>
	Public Sub SetSm2FieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Sm2Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm2 field.
	''' </summary>
	Public Sub SetSm2FieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.Sm2Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm2 field.
	''' </summary>
	Public Sub SetSm2FieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm2Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm2 field.
	''' </summary>
	Public Sub SetSm2FieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm2Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm2 field.
	''' </summary>
	Public Sub SetSm2FieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm2Column)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm3Full field.
	''' </summary>
	Public Function GetSm3FullValue() As ColumnValue
		Return Me.GetValue(TableUtils.Sm3FullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm3Full field.
	''' </summary>
	Public Function GetSm3FullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.Sm3FullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm3Full field.
	''' </summary>
	Public Sub SetSm3FullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Sm3FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm3Full field.
	''' </summary>
	Public Sub SetSm3FullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.Sm3FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm3Full field.
	''' </summary>
	Public Sub SetSm3FullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm3FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm3Full field.
	''' </summary>
	Public Sub SetSm3FullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm3FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm3Full field.
	''' </summary>
	Public Sub SetSm3FullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm3FullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm3 field.
	''' </summary>
	Public Function GetSm3Value() As ColumnValue
		Return Me.GetValue(TableUtils.Sm3Column)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm3 field.
	''' </summary>
	Public Function GetSm3FieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.Sm3Column).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm3 field.
	''' </summary>
	Public Sub SetSm3FieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Sm3Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm3 field.
	''' </summary>
	Public Sub SetSm3FieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.Sm3Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm3 field.
	''' </summary>
	Public Sub SetSm3FieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm3Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm3 field.
	''' </summary>
	Public Sub SetSm3FieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm3Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm3 field.
	''' </summary>
	Public Sub SetSm3FieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm3Column)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SgtFull field.
	''' </summary>
	Public Function GetSgtFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.SgtFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.SgtFull field.
	''' </summary>
	Public Function GetSgtFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.SgtFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SgtFull field.
	''' </summary>
	Public Sub SetSgtFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SgtFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SgtFull field.
	''' </summary>
	Public Sub SetSgtFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.SgtFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SgtFull field.
	''' </summary>
	Public Sub SetSgtFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SgtFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SgtFull field.
	''' </summary>
	Public Sub SetSgtFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SgtFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.SgtFull field.
	''' </summary>
	Public Sub SetSgtFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SgtFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sgt field.
	''' </summary>
	Public Function GetSgtValue() As ColumnValue
		Return Me.GetValue(TableUtils.SgtColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sgt field.
	''' </summary>
	Public Function GetSgtFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.SgtColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sgt field.
	''' </summary>
	Public Sub SetSgtFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SgtColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sgt field.
	''' </summary>
	Public Sub SetSgtFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.SgtColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sgt field.
	''' </summary>
	Public Sub SetSgtFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SgtColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sgt field.
	''' </summary>
	Public Sub SetSgtFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SgtColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sgt field.
	''' </summary>
	Public Sub SetSgtFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SgtColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.CptFull field.
	''' </summary>
	Public Function GetCptFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.CptFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.CptFull field.
	''' </summary>
	Public Function GetCptFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.CptFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.CptFull field.
	''' </summary>
	Public Sub SetCptFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.CptFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.CptFull field.
	''' </summary>
	Public Sub SetCptFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.CptFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.CptFull field.
	''' </summary>
	Public Sub SetCptFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CptFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.CptFull field.
	''' </summary>
	Public Sub SetCptFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CptFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.CptFull field.
	''' </summary>
	Public Sub SetCptFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CptFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Cpt field.
	''' </summary>
	Public Function GetCptValue() As ColumnValue
		Return Me.GetValue(TableUtils.CptColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Cpt field.
	''' </summary>
	Public Function GetCptFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.CptColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Cpt field.
	''' </summary>
	Public Sub SetCptFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.CptColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Cpt field.
	''' </summary>
	Public Sub SetCptFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.CptColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Cpt field.
	''' </summary>
	Public Sub SetCptFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CptColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Cpt field.
	''' </summary>
	Public Sub SetCptFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CptColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Cpt field.
	''' </summary>
	Public Sub SetCptFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CptColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.PtcFull field.
	''' </summary>
	Public Function GetPtcFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.PtcFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.PtcFull field.
	''' </summary>
	Public Function GetPtcFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.PtcFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PtcFull field.
	''' </summary>
	Public Sub SetPtcFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PtcFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PtcFull field.
	''' </summary>
	Public Sub SetPtcFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.PtcFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PtcFull field.
	''' </summary>
	Public Sub SetPtcFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PtcFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PtcFull field.
	''' </summary>
	Public Sub SetPtcFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PtcFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PtcFull field.
	''' </summary>
	Public Sub SetPtcFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PtcFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Ptc field.
	''' </summary>
	Public Function GetPtcValue() As ColumnValue
		Return Me.GetValue(TableUtils.PtcColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Ptc field.
	''' </summary>
	Public Function GetPtcFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.PtcColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Ptc field.
	''' </summary>
	Public Sub SetPtcFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PtcColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Ptc field.
	''' </summary>
	Public Sub SetPtcFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.PtcColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Ptc field.
	''' </summary>
	Public Sub SetPtcFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PtcColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Ptc field.
	''' </summary>
	Public Sub SetPtcFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PtcColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Ptc field.
	''' </summary>
	Public Sub SetPtcFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PtcColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.PvtVolFull field.
	''' </summary>
	Public Function GetPvtVolFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.PvtVolFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.PvtVolFull field.
	''' </summary>
	Public Function GetPvtVolFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.PvtVolFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtVolFull field.
	''' </summary>
	Public Sub SetPvtVolFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PvtVolFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtVolFull field.
	''' </summary>
	Public Sub SetPvtVolFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.PvtVolFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtVolFull field.
	''' </summary>
	Public Sub SetPvtVolFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtVolFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtVolFull field.
	''' </summary>
	Public Sub SetPvtVolFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtVolFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtVolFull field.
	''' </summary>
	Public Sub SetPvtVolFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtVolFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.PvtVol field.
	''' </summary>
	Public Function GetPvtVolValue() As ColumnValue
		Return Me.GetValue(TableUtils.PvtVolColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.PvtVol field.
	''' </summary>
	Public Function GetPvtVolFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.PvtVolColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtVol field.
	''' </summary>
	Public Sub SetPvtVolFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PvtVolColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtVol field.
	''' </summary>
	Public Sub SetPvtVolFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.PvtVolColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtVol field.
	''' </summary>
	Public Sub SetPvtVolFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtVolColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtVol field.
	''' </summary>
	Public Sub SetPvtVolFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtVolColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtVol field.
	''' </summary>
	Public Sub SetPvtVolFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtVolColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm4Full field.
	''' </summary>
	Public Function GetSm4FullValue() As ColumnValue
		Return Me.GetValue(TableUtils.Sm4FullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm4Full field.
	''' </summary>
	Public Function GetSm4FullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.Sm4FullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4Full field.
	''' </summary>
	Public Sub SetSm4FullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Sm4FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4Full field.
	''' </summary>
	Public Sub SetSm4FullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.Sm4FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4Full field.
	''' </summary>
	Public Sub SetSm4FullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm4FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4Full field.
	''' </summary>
	Public Sub SetSm4FullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm4FullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4Full field.
	''' </summary>
	Public Sub SetSm4FullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm4FullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm4 field.
	''' </summary>
	Public Function GetSm4Value() As ColumnValue
		Return Me.GetValue(TableUtils.Sm4Column)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm4 field.
	''' </summary>
	Public Function GetSm4FieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.Sm4Column).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4 field.
	''' </summary>
	Public Sub SetSm4FieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Sm4Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4 field.
	''' </summary>
	Public Sub SetSm4FieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.Sm4Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4 field.
	''' </summary>
	Public Sub SetSm4FieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm4Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4 field.
	''' </summary>
	Public Sub SetSm4FieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm4Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4 field.
	''' </summary>
	Public Sub SetSm4FieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm4Column)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.PvtFull field.
	''' </summary>
	Public Function GetPvtFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.PvtFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.PvtFull field.
	''' </summary>
	Public Function GetPvtFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.PvtFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtFull field.
	''' </summary>
	Public Sub SetPvtFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PvtFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtFull field.
	''' </summary>
	Public Sub SetPvtFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.PvtFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtFull field.
	''' </summary>
	Public Sub SetPvtFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtFull field.
	''' </summary>
	Public Sub SetPvtFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.PvtFull field.
	''' </summary>
	Public Sub SetPvtFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Pvt field.
	''' </summary>
	Public Function GetPvtValue() As ColumnValue
		Return Me.GetValue(TableUtils.PvtColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Pvt field.
	''' </summary>
	Public Function GetPvtFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.PvtColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvt field.
	''' </summary>
	Public Sub SetPvtFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PvtColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvt field.
	''' </summary>
	Public Sub SetPvtFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.PvtColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvt field.
	''' </summary>
	Public Sub SetPvtFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvt field.
	''' </summary>
	Public Sub SetPvtFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvt field.
	''' </summary>
	Public Sub SetPvtFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm4Now field.
	''' </summary>
	Public Function GetSm4NowValue() As ColumnValue
		Return Me.GetValue(TableUtils.Sm4NowColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Sm4Now field.
	''' </summary>
	Public Function GetSm4NowFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.Sm4NowColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4Now field.
	''' </summary>
	Public Sub SetSm4NowFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Sm4NowColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4Now field.
	''' </summary>
	Public Sub SetSm4NowFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.Sm4NowColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4Now field.
	''' </summary>
	Public Sub SetSm4NowFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm4NowColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4Now field.
	''' </summary>
	Public Sub SetSm4NowFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm4NowColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Sm4Now field.
	''' </summary>
	Public Sub SetSm4NowFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Sm4NowColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Pvtst field.
	''' </summary>
	Public Function GetPvtstValue() As ColumnValue
		Return Me.GetValue(TableUtils.PvtstColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Pvtst field.
	''' </summary>
	Public Function GetPvtstFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.PvtstColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvtst field.
	''' </summary>
	Public Sub SetPvtstFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PvtstColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvtst field.
	''' </summary>
	Public Sub SetPvtstFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.PvtstColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvtst field.
	''' </summary>
	Public Sub SetPvtstFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtstColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvtst field.
	''' </summary>
	Public Sub SetPvtstFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtstColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvtst field.
	''' </summary>
	Public Sub SetPvtstFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtstColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Pvtnd field.
	''' </summary>
	Public Function GetPvtndValue() As ColumnValue
		Return Me.GetValue(TableUtils.PvtndColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Pvtnd field.
	''' </summary>
	Public Function GetPvtndFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.PvtndColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvtnd field.
	''' </summary>
	Public Sub SetPvtndFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PvtndColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvtnd field.
	''' </summary>
	Public Sub SetPvtndFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.PvtndColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvtnd field.
	''' </summary>
	Public Sub SetPvtndFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtndColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvtnd field.
	''' </summary>
	Public Sub SetPvtndFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtndColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Pvtnd field.
	''' </summary>
	Public Sub SetPvtndFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PvtndColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.EmpFull field.
	''' </summary>
	Public Function GetEmpFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.EmpFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.EmpFull field.
	''' </summary>
	Public Function GetEmpFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.EmpFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpFull field.
	''' </summary>
	Public Sub SetEmpFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.EmpFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpFull field.
	''' </summary>
	Public Sub SetEmpFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.EmpFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpFull field.
	''' </summary>
	Public Sub SetEmpFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpFull field.
	''' </summary>
	Public Sub SetEmpFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpFull field.
	''' </summary>
	Public Sub SetEmpFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Emp field.
	''' </summary>
	Public Function GetEmpValue() As ColumnValue
		Return Me.GetValue(TableUtils.EmpColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.Emp field.
	''' </summary>
	Public Function GetEmpFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.EmpColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Emp field.
	''' </summary>
	Public Sub SetEmpFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.EmpColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Emp field.
	''' </summary>
	Public Sub SetEmpFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.EmpColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Emp field.
	''' </summary>
	Public Sub SetEmpFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Emp field.
	''' </summary>
	Public Sub SetEmpFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.Emp field.
	''' </summary>
	Public Sub SetEmpFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.EmpOffFull field.
	''' </summary>
	Public Function GetEmpOffFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.EmpOffFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.EmpOffFull field.
	''' </summary>
	Public Function GetEmpOffFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.EmpOffFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpOffFull field.
	''' </summary>
	Public Sub SetEmpOffFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.EmpOffFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpOffFull field.
	''' </summary>
	Public Sub SetEmpOffFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.EmpOffFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpOffFull field.
	''' </summary>
	Public Sub SetEmpOffFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpOffFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpOffFull field.
	''' </summary>
	Public Sub SetEmpOffFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpOffFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpOffFull field.
	''' </summary>
	Public Sub SetEmpOffFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpOffFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.EmpOff field.
	''' </summary>
	Public Function GetEmpOffValue() As ColumnValue
		Return Me.GetValue(TableUtils.EmpOffColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.EmpOff field.
	''' </summary>
	Public Function GetEmpOffFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.EmpOffColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpOff field.
	''' </summary>
	Public Sub SetEmpOffFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.EmpOffColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpOff field.
	''' </summary>
	Public Sub SetEmpOffFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.EmpOffColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpOff field.
	''' </summary>
	Public Sub SetEmpOffFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpOffColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpOff field.
	''' </summary>
	Public Sub SetEmpOffFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpOffColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpOff field.
	''' </summary>
	Public Sub SetEmpOffFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpOffColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.EmpTmpFull field.
	''' </summary>
	Public Function GetEmpTmpFullValue() As ColumnValue
		Return Me.GetValue(TableUtils.EmpTmpFullColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.EmpTmpFull field.
	''' </summary>
	Public Function GetEmpTmpFullFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.EmpTmpFullColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpTmpFull field.
	''' </summary>
	Public Sub SetEmpTmpFullFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.EmpTmpFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpTmpFull field.
	''' </summary>
	Public Sub SetEmpTmpFullFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.EmpTmpFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpTmpFull field.
	''' </summary>
	Public Sub SetEmpTmpFullFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpTmpFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpTmpFull field.
	''' </summary>
	Public Sub SetEmpTmpFullFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpTmpFullColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpTmpFull field.
	''' </summary>
	Public Sub SetEmpTmpFullFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpTmpFullColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.EmpTmp field.
	''' </summary>
	Public Function GetEmpTmpValue() As ColumnValue
		Return Me.GetValue(TableUtils.EmpTmpColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Section_.EmpTmp field.
	''' </summary>
	Public Function GetEmpTmpFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.EmpTmpColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpTmp field.
	''' </summary>
	Public Sub SetEmpTmpFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.EmpTmpColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpTmp field.
	''' </summary>
	Public Sub SetEmpTmpFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.EmpTmpColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpTmp field.
	''' </summary>
	Public Sub SetEmpTmpFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpTmpColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpTmp field.
	''' </summary>
	Public Sub SetEmpTmpFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpTmpColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Section_.EmpTmp field.
	''' </summary>
	Public Sub SetEmpTmpFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EmpTmpColumn)
	End Sub


#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.SectionId field.
	''' </summary>
	Public Property SectionId() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.SectionIdColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.SectionIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SectionIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SectionIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SectionIdDefault() As String
        Get
            Return TableUtils.SectionIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.SectionName field.
	''' </summary>
	Public Property SectionName() As String
		Get 
			Return CType(Me.GetValue(TableUtils.SectionNameColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.SectionNameColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SectionNameSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SectionNameColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SectionNameDefault() As String
        Get
            Return TableUtils.SectionNameColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.SectionAbbvrName field.
	''' </summary>
	Public Property SectionAbbvrName() As String
		Get 
			Return CType(Me.GetValue(TableUtils.SectionAbbvrNameColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.SectionAbbvrNameColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SectionAbbvrNameSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SectionAbbvrNameColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SectionAbbvrNameDefault() As String
        Get
            Return TableUtils.SectionAbbvrNameColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.SectionEName field.
	''' </summary>
	Public Property SectionEName() As String
		Get 
			Return CType(Me.GetValue(TableUtils.SectionENameColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.SectionENameColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SectionENameSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SectionENameColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SectionENameDefault() As String
        Get
            Return TableUtils.SectionENameColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.MarshallFull field.
	''' </summary>
	Public Property MarshallFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.MarshallFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.MarshallFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property MarshallFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.MarshallFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property MarshallFullDefault() As String
        Get
            Return TableUtils.MarshallFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.MarShall field.
	''' </summary>
	Public Property MarShall() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.MarShallColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.MarShallColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property MarShallSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.MarShallColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property MarShallDefault() As String
        Get
            Return TableUtils.MarShallColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.GeneralFull field.
	''' </summary>
	Public Property GeneralFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.GeneralFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.GeneralFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property GeneralFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.GeneralFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property GeneralFullDefault() As String
        Get
            Return TableUtils.GeneralFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.General field.
	''' </summary>
	Public Property General() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.GeneralColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.GeneralColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property GeneralSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.GeneralColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property GeneralDefault() As String
        Get
            Return TableUtils.GeneralColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.LtGeneralFull field.
	''' </summary>
	Public Property LtGeneralFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.LtGeneralFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.LtGeneralFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property LtGeneralFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.LtGeneralFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property LtGeneralFullDefault() As String
        Get
            Return TableUtils.LtGeneralFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.LtGeneral field.
	''' </summary>
	Public Property LtGeneral() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.LtGeneralColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.LtGeneralColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property LtGeneralSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.LtGeneralColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property LtGeneralDefault() As String
        Get
            Return TableUtils.LtGeneralColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.MjGeneralFull field.
	''' </summary>
	Public Property MjGeneralFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.MjGeneralFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.MjGeneralFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property MjGeneralFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.MjGeneralFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property MjGeneralFullDefault() As String
        Get
            Return TableUtils.MjGeneralFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.MjGeneral field.
	''' </summary>
	Public Property MjGeneral() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.MjGeneralColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.MjGeneralColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property MjGeneralSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.MjGeneralColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property MjGeneralDefault() As String
        Get
            Return TableUtils.MjGeneralColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.SpColonelFull field.
	''' </summary>
	Public Property SpColonelFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.SpColonelFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.SpColonelFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SpColonelFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SpColonelFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SpColonelFullDefault() As String
        Get
            Return TableUtils.SpColonelFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.SpColonel field.
	''' </summary>
	Public Property SpColonel() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.SpColonelColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.SpColonelColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SpColonelSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SpColonelColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SpColonelDefault() As String
        Get
            Return TableUtils.SpColonelColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.ColonelFull field.
	''' </summary>
	Public Property ColonelFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.ColonelFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.ColonelFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property ColonelFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.ColonelFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property ColonelFullDefault() As String
        Get
            Return TableUtils.ColonelFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Colonel field.
	''' </summary>
	Public Property Colonel() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.ColonelColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.ColonelColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property ColonelSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.ColonelColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property ColonelDefault() As String
        Get
            Return TableUtils.ColonelColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.LtColonelFull field.
	''' </summary>
	Public Property LtColonelFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.LtColonelFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.LtColonelFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property LtColonelFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.LtColonelFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property LtColonelFullDefault() As String
        Get
            Return TableUtils.LtColonelFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.LtColonel field.
	''' </summary>
	Public Property LtColonel() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.LtColonelColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.LtColonelColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property LtColonelSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.LtColonelColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property LtColonelDefault() As String
        Get
            Return TableUtils.LtColonelColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.MajorFull field.
	''' </summary>
	Public Property MajorFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.MajorFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.MajorFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property MajorFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.MajorFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property MajorFullDefault() As String
        Get
            Return TableUtils.MajorFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Major field.
	''' </summary>
	Public Property Major() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.MajorColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.MajorColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property MajorSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.MajorColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property MajorDefault() As String
        Get
            Return TableUtils.MajorColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.CaptianFull field.
	''' </summary>
	Public Property CaptianFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.CaptianFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.CaptianFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property CaptianFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.CaptianFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property CaptianFullDefault() As String
        Get
            Return TableUtils.CaptianFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Captian field.
	''' </summary>
	Public Property Captian() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.CaptianColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.CaptianColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property CaptianSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.CaptianColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property CaptianDefault() As String
        Get
            Return TableUtils.CaptianColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.LieutenantFull field.
	''' </summary>
	Public Property LieutenantFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.LieutenantFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.LieutenantFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property LieutenantFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.LieutenantFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property LieutenantFullDefault() As String
        Get
            Return TableUtils.LieutenantFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Lieutenant field.
	''' </summary>
	Public Property Lieutenant() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.LieutenantColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.LieutenantColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property LieutenantSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.LieutenantColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property LieutenantDefault() As String
        Get
            Return TableUtils.LieutenantColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.SubLieutenantFull field.
	''' </summary>
	Public Property SubLieutenantFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.SubLieutenantFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.SubLieutenantFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SubLieutenantFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SubLieutenantFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SubLieutenantFullDefault() As String
        Get
            Return TableUtils.SubLieutenantFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.SubLieutenant field.
	''' </summary>
	Public Property SubLieutenant() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.SubLieutenantColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.SubLieutenantColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SubLieutenantSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SubLieutenantColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SubLieutenantDefault() As String
        Get
            Return TableUtils.SubLieutenantColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sm0Full field.
	''' </summary>
	Public Property Sm0Full() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.Sm0FullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Sm0FullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Sm0FullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Sm0FullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Sm0FullDefault() As String
        Get
            Return TableUtils.Sm0FullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sm0 field.
	''' </summary>
	Public Property Sm0() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.Sm0Column).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Sm0Column)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Sm0Specified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Sm0Column)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Sm0Default() As String
        Get
            Return TableUtils.Sm0Column.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sm1Full field.
	''' </summary>
	Public Property Sm1Full() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.Sm1FullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Sm1FullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Sm1FullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Sm1FullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Sm1FullDefault() As String
        Get
            Return TableUtils.Sm1FullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sm1 field.
	''' </summary>
	Public Property Sm1() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.Sm1Column).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Sm1Column)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Sm1Specified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Sm1Column)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Sm1Default() As String
        Get
            Return TableUtils.Sm1Column.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sm2Full field.
	''' </summary>
	Public Property Sm2Full() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.Sm2FullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Sm2FullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Sm2FullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Sm2FullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Sm2FullDefault() As String
        Get
            Return TableUtils.Sm2FullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sm2 field.
	''' </summary>
	Public Property Sm2() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.Sm2Column).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Sm2Column)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Sm2Specified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Sm2Column)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Sm2Default() As String
        Get
            Return TableUtils.Sm2Column.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sm3Full field.
	''' </summary>
	Public Property Sm3Full() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.Sm3FullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Sm3FullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Sm3FullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Sm3FullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Sm3FullDefault() As String
        Get
            Return TableUtils.Sm3FullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sm3 field.
	''' </summary>
	Public Property Sm3() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.Sm3Column).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Sm3Column)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Sm3Specified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Sm3Column)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Sm3Default() As String
        Get
            Return TableUtils.Sm3Column.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.SgtFull field.
	''' </summary>
	Public Property SgtFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.SgtFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.SgtFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SgtFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SgtFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SgtFullDefault() As String
        Get
            Return TableUtils.SgtFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sgt field.
	''' </summary>
	Public Property Sgt() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.SgtColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.SgtColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SgtSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SgtColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SgtDefault() As String
        Get
            Return TableUtils.SgtColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.CptFull field.
	''' </summary>
	Public Property CptFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.CptFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.CptFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property CptFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.CptFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property CptFullDefault() As String
        Get
            Return TableUtils.CptFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Cpt field.
	''' </summary>
	Public Property Cpt() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.CptColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.CptColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property CptSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.CptColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property CptDefault() As String
        Get
            Return TableUtils.CptColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.PtcFull field.
	''' </summary>
	Public Property PtcFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.PtcFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.PtcFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PtcFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PtcFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PtcFullDefault() As String
        Get
            Return TableUtils.PtcFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Ptc field.
	''' </summary>
	Public Property Ptc() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.PtcColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.PtcColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PtcSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PtcColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PtcDefault() As String
        Get
            Return TableUtils.PtcColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.PvtVolFull field.
	''' </summary>
	Public Property PvtVolFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.PvtVolFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.PvtVolFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PvtVolFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PvtVolFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PvtVolFullDefault() As String
        Get
            Return TableUtils.PvtVolFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.PvtVol field.
	''' </summary>
	Public Property PvtVol() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.PvtVolColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.PvtVolColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PvtVolSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PvtVolColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PvtVolDefault() As String
        Get
            Return TableUtils.PvtVolColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sm4Full field.
	''' </summary>
	Public Property Sm4Full() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.Sm4FullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Sm4FullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Sm4FullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Sm4FullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Sm4FullDefault() As String
        Get
            Return TableUtils.Sm4FullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sm4 field.
	''' </summary>
	Public Property Sm4() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.Sm4Column).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Sm4Column)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Sm4Specified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Sm4Column)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Sm4Default() As String
        Get
            Return TableUtils.Sm4Column.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.PvtFull field.
	''' </summary>
	Public Property PvtFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.PvtFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.PvtFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PvtFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PvtFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PvtFullDefault() As String
        Get
            Return TableUtils.PvtFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Pvt field.
	''' </summary>
	Public Property Pvt() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.PvtColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.PvtColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PvtSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PvtColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PvtDefault() As String
        Get
            Return TableUtils.PvtColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Sm4Now field.
	''' </summary>
	Public Property Sm4Now() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.Sm4NowColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Sm4NowColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Sm4NowSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Sm4NowColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Sm4NowDefault() As String
        Get
            Return TableUtils.Sm4NowColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Pvtst field.
	''' </summary>
	Public Property Pvtst() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.PvtstColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.PvtstColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PvtstSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PvtstColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PvtstDefault() As String
        Get
            Return TableUtils.PvtstColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Pvtnd field.
	''' </summary>
	Public Property Pvtnd() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.PvtndColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.PvtndColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PvtndSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PvtndColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PvtndDefault() As String
        Get
            Return TableUtils.PvtndColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.EmpFull field.
	''' </summary>
	Public Property EmpFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.EmpFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.EmpFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property EmpFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.EmpFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property EmpFullDefault() As String
        Get
            Return TableUtils.EmpFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.Emp field.
	''' </summary>
	Public Property Emp() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.EmpColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.EmpColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property EmpSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.EmpColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property EmpDefault() As String
        Get
            Return TableUtils.EmpColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.EmpOffFull field.
	''' </summary>
	Public Property EmpOffFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.EmpOffFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.EmpOffFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property EmpOffFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.EmpOffFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property EmpOffFullDefault() As String
        Get
            Return TableUtils.EmpOffFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.EmpOff field.
	''' </summary>
	Public Property EmpOff() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.EmpOffColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.EmpOffColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property EmpOffSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.EmpOffColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property EmpOffDefault() As String
        Get
            Return TableUtils.EmpOffColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.EmpTmpFull field.
	''' </summary>
	Public Property EmpTmpFull() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.EmpTmpFullColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.EmpTmpFullColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property EmpTmpFullSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.EmpTmpFullColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property EmpTmpFullDefault() As String
        Get
            Return TableUtils.EmpTmpFullColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Section_.EmpTmp field.
	''' </summary>
	Public Property EmpTmp() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.EmpTmpColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.EmpTmpColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property EmpTmpSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.EmpTmpColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property EmpTmpDefault() As String
        Get
            Return TableUtils.EmpTmpColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
