﻿' This class is "generated" and will be overwritten.
' Your customizations should be made in SexRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="SexRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="SexTable"></see> class.
''' </remarks>
''' <seealso cref="SexTable"></seealso>
''' <seealso cref="SexRecord"></seealso>

<Serializable()> Public Class BaseSexRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As SexTable = SexTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub
	
	'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub SexRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim SexRec As SexRecord = CType(sender,SexRecord)
        Validate_Inserting()
        If Not SexRec Is Nothing AndAlso Not SexRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub SexRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim SexRec As SexRecord = CType(sender,SexRecord)
        Validate_Updating()
        If Not SexRec Is Nothing AndAlso Not SexRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub SexRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim SexRec As SexRecord = CType(sender,SexRecord)
        If Not SexRec Is Nothing AndAlso Not SexRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Sex_.SexId field.
	''' </summary>
	Public Function GetSexIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.SexIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Sex_.SexId field.
	''' </summary>
	Public Function GetSexIdFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.SexIdColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Sex_.SexId field.
	''' </summary>
	Public Sub SetSexIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SexIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Sex_.SexId field.
	''' </summary>
	Public Sub SetSexIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.SexIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Sex_.SexId field.
	''' </summary>
	Public Sub SetSexIdFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SexIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Sex_.SexId field.
	''' </summary>
	Public Sub SetSexIdFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SexIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Sex_.SexId field.
	''' </summary>
	Public Sub SetSexIdFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SexIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Sex_.Sex field.
	''' </summary>
	Public Function GetSexValue() As ColumnValue
		Return Me.GetValue(TableUtils.SexColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Sex_.Sex field.
	''' </summary>
	Public Function GetSexFieldValue() As String
		Return CType(Me.GetValue(TableUtils.SexColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Sex_.Sex field.
	''' </summary>
	Public Sub SetSexFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.SexColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Sex_.Sex field.
	''' </summary>
	Public Sub SetSexFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.SexColumn)
	End Sub



#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Sex_.SexId field.
	''' </summary>
	Public Property SexId() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.SexIdColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.SexIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SexIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SexIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SexIdDefault() As String
        Get
            Return TableUtils.SexIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Sex_.Sex field.
	''' </summary>
	Public Property Sex() As String
		Get 
			Return CType(Me.GetValue(TableUtils.SexColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.SexColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property SexSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.SexColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property SexDefault() As String
        Get
            Return TableUtils.SexColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
