﻿
' This file implements the TableControl, TableControlRow, and RecordControl classes for the 
' ShowViewMaxPersonalEducation.aspx page.  The Row or RecordControl classes are the 
' ideal place to add code customizations. For example, you can override the LoadData, 
' CreateWhereClause, DataBind, SaveData, GetUIData, and Validate methods.

#Region "Imports statements"

Option Strict On
Imports Microsoft.VisualBasic
Imports BaseClasses.Web.UI.WebControls
Imports System
Imports System.Collections
Imports System.Collections.Generic
        
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Utils
Imports ReportTools.ReportCreator
Imports ReportTools.Shared

  
        
Imports Persons.Business
Imports Persons.Data
        

#End Region

  
Namespace Persons.UI.Controls.ShowViewMaxPersonalEducation

#Region "Section 1: Place your customizations here."

    
Public Class View_MaxPersonalEducationTableControlRow
        Inherits BaseView_MaxPersonalEducationTableControlRow
        ' The BaseView_MaxPersonalEducationTableControlRow implements code for a ROW within the
        ' the View_MaxPersonalEducationTableControl table.  The BaseView_MaxPersonalEducationTableControlRow implements the DataBind and SaveData methods.
        ' The loading of data is actually performed by the LoadData method in the base class of View_MaxPersonalEducationTableControl.

        ' This is the ideal place to add your code customizations. For example, you can override the DataBind, 
        ' SaveData, GetUIData, and Validate methods.
        

End Class

  

Public Class View_MaxPersonalEducationTableControl
        Inherits BaseView_MaxPersonalEducationTableControl



        Private Sub View_MaxPersonalEducationTableControl_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init
            MyBase.Control_Init(sender, e)
            Me.CurrentSortOrder.Reset()
            Me.CurrentSortOrder.Add(View_MaxPersonalEducationView.RankId, OrderByItem.OrderDir.Asc)
            Me.CurrentSortOrder.Add(View_MaxPersonalEducationView.DateRank, OrderByItem.OrderDir.Asc)
            Me.CurrentSortOrder.Add(View_MaxPersonalEducationView.DatePrevRank, OrderByItem.OrderDir.Asc)
        End Sub

        Protected Overrides Sub PopulateRankLevelFromFilter(ByVal selectedValue As String, ByVal maxItems As Integer)

            ' Setup the WHERE clause, including the base table if needed.

            Dim wc As WhereClause = Me.CreateWhereClause_RankLevelFromFilter()

            Dim orderBy As OrderBy = New OrderBy(False, True)
            orderBy.Add(View_MaxPersonalEducationView.RankLevel, OrderByItem.OrderDir.Asc)

            Dim values() As String = View_MaxPersonalEducationView.GetValues(View_MaxPersonalEducationView.RankLevel, wc, orderBy, maxItems)

            Me.RankLevelFromFilter.Items.Clear()
            Dim itemValue As String

            For Each itemValue In values
                ' Create the item and add to the list.
                Dim fvalue As String

                If (View_MaxPersonalEducationView.RankLevel.IsColumnValueTypeBoolean()) Then
                    fvalue = itemValue
                Else
                    fvalue = View_MaxPersonalEducationView.RankLevel.Format(itemValue)
                End If

                Dim item As ListItem = New ListItem(fvalue, itemValue)
                Me.RankLevelFromFilter.Items.Add(item)
            Next

            ' Add the All item.
            Me.RankLevelFromFilter.Items.Insert(0, New ListItem(Page.GetResourceValue("Txt:All", "Persons"), "--ANY--"))

            ' Set the selected value.
            SetSelectedValue(Me.RankLevelFromFilter, selectedValue)


        End Sub


        Private Sub View_MaxPersonalEducationTableControl_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            Me.CurrentSortOrder.Reset()
            Me.CurrentSortOrder.Add(View_MaxPersonalEducationView.RankId, OrderByItem.OrderDir.Asc)
            Me.CurrentSortOrder.Add(View_MaxPersonalEducationView.DateRank, OrderByItem.OrderDir.Asc)
            Me.CurrentSortOrder.Add(View_MaxPersonalEducationView.DatePrevRank, OrderByItem.OrderDir.Asc)

        End Sub
    End Class

  

#End Region

  

#Region "Section 2: Do not modify this section."
    
    
' Base class for the View_MaxPersonalEducationTableControlRow control on the ShowViewMaxPersonalEducation page.
' Do not modify this class. Instead override any method in View_MaxPersonalEducationTableControlRow.
Public Class BaseView_MaxPersonalEducationTableControlRow
        Inherits Persons.UI.BaseApplicationRecordControl

        '  To customize, override this method in View_MaxPersonalEducationTableControlRow.
        Protected Overridable Sub Control_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Init
          
            Me.ClearControlsFromSession()
        End Sub

        '  To customize, override this method in View_MaxPersonalEducationTableControlRow.
        Protected Overridable Sub Control_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        
            'Call LoadFocusScripts from repeater so that onfocus attribute could be added to elements
            Me.Page.LoadFocusScripts(Me)
                    
        
              ' Register the event handlers.
          
    
        End Sub

        
        Public Overridable Sub LoadData()        
                
            ' Load the data from the database into the DataSource View_MaxPersonalEducation record.
            ' It is better to make changes to functions called by LoadData such as
            ' CreateWhereClause, rather than making changes here.
    
            ' The RecordUniqueId is set the first time a record is loaded, and is
            ' used during a PostBack to load the record.
          
            If Me.RecordUniqueId IsNot Nothing AndAlso Me.RecordUniqueId.Trim <> "" Then
                Me.DataSource = View_MaxPersonalEducationView.GetRecord(Me.RecordUniqueId, True)
          
                Return
            End If
        
            ' Since this is a row in the table, the data for this row is loaded by the 
            ' LoadData method of the BaseView_MaxPersonalEducationTableControl when the data for the entire
            ' table is loaded.
            
            Me.DataSource = New View_MaxPersonalEducationRecord()
          
    
    
        End Sub

        ' Populate the UI controls using the DataSource.  To customize, override this method in View_MaxPersonalEducationTableControlRow.
        Public Overrides Sub DataBind()
            ' The DataBind method binds the user interface controls to the values
            ' from the database record.  To do this, it calls the Set methods for 
            ' each of the field displayed on the webpage.  It is better to make 
            ' changes in the Set methods, rather than making changes here.
            
            MyBase.DataBind()

            ' Make sure that the DataSource is initialized.
            If Me.DataSource Is Nothing Then
    
                Return
            End If
            
    
            'LoadData for DataSource for chart and report if they exist
          
      
      
            ' Call the Set methods for each controls on the panel
        
                SetCountry()
                SetCourse()
                SetCourseAbbr()
                SetEdYear()
                SetFacultry()
                SetInstitue()
                SetLevel()
                SetRankAndName()
                SetSectionAbbvrName()
      
      
            Me.IsNewRecord = True
            
            If Me.DataSource.IsCreated Then
                Me.IsNewRecord = False
                
                Me.RecordUniqueId = Me.DataSource.GetID.ToXmlString()
            End If
          
            ' Now load data for each record and table child UI controls.
            ' Ordering is important because child controls get 
            ' their parent ids from their parent UI controls.
            Dim shouldResetControl As Boolean = False
                  
        End Sub
        
        
        Public Overridable Sub SetCountry()
            
        
            ' Set the Country Literal on the webpage with value from the
            ' View_MaxPersonalEducation database record.

            ' Me.DataSource is the View_MaxPersonalEducation record retrieved from the database.
            ' Me.Country is the ASP:Literal on the webpage.
            
            ' You can modify this method directly, or replace it with a call to
            '     MyBase.SetCountry()
            ' and add your own code before or after the call to the MyBase function.

            
                  
            If Me.DataSource IsNot Nothing AndAlso Me.DataSource.CountrySpecified Then
                				
                ' If the Country is non-NULL, then format the value.

                ' The Format method will use the Display Format
                                Dim formattedValue As String = Me.DataSource.Format(View_MaxPersonalEducationView.Country)
                              
                formattedValue = HttpUtility.HtmlEncode(formattedValue)
                Me.Country.Text = formattedValue
                
            Else 
            
                ' Country is NULL in the database, so use the Default Value.  
                ' Default Value could also be NULL.
        
                Me.Country.Text = View_MaxPersonalEducationView.Country.Format(View_MaxPersonalEducationView.Country.DefaultValue)
                        		
                End If
                 
            ' If the Country is NULL or blank, then use the value specified  
            ' on Properties.
            If Me.Country.Text Is Nothing _
                OrElse Me.Country.Text.Trim() = "" Then
                ' Set the value specified on the Properties.
                Me.Country.Text = "&nbsp;"
            End If
                  
        End Sub
                
        Public Overridable Sub SetCourse()
            
        
            ' Set the Course Literal on the webpage with value from the
            ' View_MaxPersonalEducation database record.

            ' Me.DataSource is the View_MaxPersonalEducation record retrieved from the database.
            ' Me.Course is the ASP:Literal on the webpage.
            
            ' You can modify this method directly, or replace it with a call to
            '     MyBase.SetCourse()
            ' and add your own code before or after the call to the MyBase function.

            
                  
            If Me.DataSource IsNot Nothing AndAlso Me.DataSource.CourseSpecified Then
                				
                ' If the Course is non-NULL, then format the value.

                ' The Format method will use the Display Format
                                Dim formattedValue As String = Me.DataSource.Format(View_MaxPersonalEducationView.Course)
                              
                formattedValue = HttpUtility.HtmlEncode(formattedValue)
                Me.Course.Text = formattedValue
                
            Else 
            
                ' Course is NULL in the database, so use the Default Value.  
                ' Default Value could also be NULL.
        
                Me.Course.Text = View_MaxPersonalEducationView.Course.Format(View_MaxPersonalEducationView.Course.DefaultValue)
                        		
                End If
                 
            ' If the Course is NULL or blank, then use the value specified  
            ' on Properties.
            If Me.Course.Text Is Nothing _
                OrElse Me.Course.Text.Trim() = "" Then
                ' Set the value specified on the Properties.
                Me.Course.Text = "&nbsp;"
            End If
                  
        End Sub
                
        Public Overridable Sub SetCourseAbbr()
            
        
            ' Set the CourseAbbr Literal on the webpage with value from the
            ' View_MaxPersonalEducation database record.

            ' Me.DataSource is the View_MaxPersonalEducation record retrieved from the database.
            ' Me.CourseAbbr is the ASP:Literal on the webpage.
            
            ' You can modify this method directly, or replace it with a call to
            '     MyBase.SetCourseAbbr()
            ' and add your own code before or after the call to the MyBase function.

            
                  
            If Me.DataSource IsNot Nothing AndAlso Me.DataSource.CourseAbbrSpecified Then
                				
                ' If the CourseAbbr is non-NULL, then format the value.

                ' The Format method will use the Display Format
                                Dim formattedValue As String = Me.DataSource.Format(View_MaxPersonalEducationView.CourseAbbr)
                              
                formattedValue = HttpUtility.HtmlEncode(formattedValue)
                Me.CourseAbbr.Text = formattedValue
                
            Else 
            
                ' CourseAbbr is NULL in the database, so use the Default Value.  
                ' Default Value could also be NULL.
        
                Me.CourseAbbr.Text = View_MaxPersonalEducationView.CourseAbbr.Format(View_MaxPersonalEducationView.CourseAbbr.DefaultValue)
                        		
                End If
                 
            ' If the CourseAbbr is NULL or blank, then use the value specified  
            ' on Properties.
            If Me.CourseAbbr.Text Is Nothing _
                OrElse Me.CourseAbbr.Text.Trim() = "" Then
                ' Set the value specified on the Properties.
                Me.CourseAbbr.Text = "&nbsp;"
            End If
                  
        End Sub
                
        Public Overridable Sub SetEdYear()
            
        
            ' Set the EdYear Literal on the webpage with value from the
            ' View_MaxPersonalEducation database record.

            ' Me.DataSource is the View_MaxPersonalEducation record retrieved from the database.
            ' Me.EdYear is the ASP:Literal on the webpage.
            
            ' You can modify this method directly, or replace it with a call to
            '     MyBase.SetEdYear()
            ' and add your own code before or after the call to the MyBase function.

            
                  
            If Me.DataSource IsNot Nothing AndAlso Me.DataSource.EdYearSpecified Then
                				
                ' If the EdYear is non-NULL, then format the value.

                ' The Format method will use the Display Format
                                Dim formattedValue As String = Me.DataSource.Format(View_MaxPersonalEducationView.EdYear)
                              
                formattedValue = HttpUtility.HtmlEncode(formattedValue)
                Me.EdYear.Text = formattedValue
                
            Else 
            
                ' EdYear is NULL in the database, so use the Default Value.  
                ' Default Value could also be NULL.
        
                Me.EdYear.Text = View_MaxPersonalEducationView.EdYear.Format(View_MaxPersonalEducationView.EdYear.DefaultValue)
                        		
                End If
                 
            ' If the EdYear is NULL or blank, then use the value specified  
            ' on Properties.
            If Me.EdYear.Text Is Nothing _
                OrElse Me.EdYear.Text.Trim() = "" Then
                ' Set the value specified on the Properties.
                Me.EdYear.Text = "&nbsp;"
            End If
                  
        End Sub
                
        Public Overridable Sub SetFacultry()
            
        
            ' Set the Facultry Literal on the webpage with value from the
            ' View_MaxPersonalEducation database record.

            ' Me.DataSource is the View_MaxPersonalEducation record retrieved from the database.
            ' Me.Facultry is the ASP:Literal on the webpage.
            
            ' You can modify this method directly, or replace it with a call to
            '     MyBase.SetFacultry()
            ' and add your own code before or after the call to the MyBase function.

            
                  
            If Me.DataSource IsNot Nothing AndAlso Me.DataSource.FacultrySpecified Then
                				
                ' If the Facultry is non-NULL, then format the value.

                ' The Format method will use the Display Format
                                Dim formattedValue As String = Me.DataSource.Format(View_MaxPersonalEducationView.Facultry)
                              
                formattedValue = HttpUtility.HtmlEncode(formattedValue)
                Me.Facultry.Text = formattedValue
                
            Else 
            
                ' Facultry is NULL in the database, so use the Default Value.  
                ' Default Value could also be NULL.
        
                Me.Facultry.Text = View_MaxPersonalEducationView.Facultry.Format(View_MaxPersonalEducationView.Facultry.DefaultValue)
                        		
                End If
                 
            ' If the Facultry is NULL or blank, then use the value specified  
            ' on Properties.
            If Me.Facultry.Text Is Nothing _
                OrElse Me.Facultry.Text.Trim() = "" Then
                ' Set the value specified on the Properties.
                Me.Facultry.Text = "&nbsp;"
            End If
                  
        End Sub
                
        Public Overridable Sub SetInstitue()
            
        
            ' Set the Institue Literal on the webpage with value from the
            ' View_MaxPersonalEducation database record.

            ' Me.DataSource is the View_MaxPersonalEducation record retrieved from the database.
            ' Me.Institue is the ASP:Literal on the webpage.
            
            ' You can modify this method directly, or replace it with a call to
            '     MyBase.SetInstitue()
            ' and add your own code before or after the call to the MyBase function.

            
                  
            If Me.DataSource IsNot Nothing AndAlso Me.DataSource.InstitueSpecified Then
                				
                ' If the Institue is non-NULL, then format the value.

                ' The Format method will use the Display Format
                                Dim formattedValue As String = Me.DataSource.Format(View_MaxPersonalEducationView.Institue)
                              
                formattedValue = HttpUtility.HtmlEncode(formattedValue)
                Me.Institue.Text = formattedValue
                
            Else 
            
                ' Institue is NULL in the database, so use the Default Value.  
                ' Default Value could also be NULL.
        
                Me.Institue.Text = View_MaxPersonalEducationView.Institue.Format(View_MaxPersonalEducationView.Institue.DefaultValue)
                        		
                End If
                 
            ' If the Institue is NULL or blank, then use the value specified  
            ' on Properties.
            If Me.Institue.Text Is Nothing _
                OrElse Me.Institue.Text.Trim() = "" Then
                ' Set the value specified on the Properties.
                Me.Institue.Text = "&nbsp;"
            End If
                  
        End Sub
                
        Public Overridable Sub SetLevel()
            
        
            ' Set the Level Literal on the webpage with value from the
            ' View_MaxPersonalEducation database record.

            ' Me.DataSource is the View_MaxPersonalEducation record retrieved from the database.
            ' Me.Level is the ASP:Literal on the webpage.
            
            ' You can modify this method directly, or replace it with a call to
            '     MyBase.SetLevel()
            ' and add your own code before or after the call to the MyBase function.

            
                  
            If Me.DataSource IsNot Nothing AndAlso Me.DataSource.LevelSpecified Then
                				
                ' If the Level is non-NULL, then format the value.

                ' The Format method will use the Display Format
                                Dim formattedValue As String = Me.DataSource.Format(View_MaxPersonalEducationView.Level)
                              
                formattedValue = HttpUtility.HtmlEncode(formattedValue)
                Me.Level.Text = formattedValue
                
            Else 
            
                ' Level is NULL in the database, so use the Default Value.  
                ' Default Value could also be NULL.
        
                Me.Level.Text = View_MaxPersonalEducationView.Level.Format(View_MaxPersonalEducationView.Level.DefaultValue)
                        		
                End If
                 
            ' If the Level is NULL or blank, then use the value specified  
            ' on Properties.
            If Me.Level.Text Is Nothing _
                OrElse Me.Level.Text.Trim() = "" Then
                ' Set the value specified on the Properties.
                Me.Level.Text = "&nbsp;"
            End If
                  
        End Sub
                
        Public Overridable Sub SetRankAndName()
            
        
            ' Set the RankAndName Literal on the webpage with value from the
            ' View_MaxPersonalEducation database record.

            ' Me.DataSource is the View_MaxPersonalEducation record retrieved from the database.
            ' Me.RankAndName is the ASP:Literal on the webpage.
            
            ' You can modify this method directly, or replace it with a call to
            '     MyBase.SetRankAndName()
            ' and add your own code before or after the call to the MyBase function.

            
                  
            If Me.DataSource IsNot Nothing AndAlso Me.DataSource.RankAndNameSpecified Then
                				
                ' If the RankAndName is non-NULL, then format the value.

                ' The Format method will use the Display Format
                                Dim formattedValue As String = Me.DataSource.Format(View_MaxPersonalEducationView.RankAndName)
                              
                formattedValue = HttpUtility.HtmlEncode(formattedValue)
                Me.RankAndName.Text = formattedValue
                
            Else 
            
                ' RankAndName is NULL in the database, so use the Default Value.  
                ' Default Value could also be NULL.
        
                Me.RankAndName.Text = View_MaxPersonalEducationView.RankAndName.Format(View_MaxPersonalEducationView.RankAndName.DefaultValue)
                        		
                End If
                 
            ' If the RankAndName is NULL or blank, then use the value specified  
            ' on Properties.
            If Me.RankAndName.Text Is Nothing _
                OrElse Me.RankAndName.Text.Trim() = "" Then
                ' Set the value specified on the Properties.
                Me.RankAndName.Text = "&nbsp;"
            End If
                  
        End Sub
                
        Public Overridable Sub SetSectionAbbvrName()
            
        
            ' Set the SectionAbbvrName Literal on the webpage with value from the
            ' View_MaxPersonalEducation database record.

            ' Me.DataSource is the View_MaxPersonalEducation record retrieved from the database.
            ' Me.SectionAbbvrName is the ASP:Literal on the webpage.
            
            ' You can modify this method directly, or replace it with a call to
            '     MyBase.SetSectionAbbvrName()
            ' and add your own code before or after the call to the MyBase function.

            
                  
            If Me.DataSource IsNot Nothing AndAlso Me.DataSource.SectionAbbvrNameSpecified Then
                				
                ' If the SectionAbbvrName is non-NULL, then format the value.

                ' The Format method will use the Display Format
                                Dim formattedValue As String = Me.DataSource.Format(View_MaxPersonalEducationView.SectionAbbvrName)
                              
                formattedValue = HttpUtility.HtmlEncode(formattedValue)
                Me.SectionAbbvrName.Text = formattedValue
                
            Else 
            
                ' SectionAbbvrName is NULL in the database, so use the Default Value.  
                ' Default Value could also be NULL.
        
                Me.SectionAbbvrName.Text = View_MaxPersonalEducationView.SectionAbbvrName.Format(View_MaxPersonalEducationView.SectionAbbvrName.DefaultValue)
                        		
                End If
                 
            ' If the SectionAbbvrName is NULL or blank, then use the value specified  
            ' on Properties.
            If Me.SectionAbbvrName.Text Is Nothing _
                OrElse Me.SectionAbbvrName.Text.Trim() = "" Then
                ' Set the value specified on the Properties.
                Me.SectionAbbvrName.Text = "&nbsp;"
            End If
                  
        End Sub
                

        Public EvaluateFormulaDelegate As BaseClasses.Data.DataSource.EvaluateFormulaDelegate = New BaseClasses.Data.DataSource.EvaluateFormulaDelegate(AddressOf Me.EvaluateFormula)

        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord, ByVal format As String, ByVal variables As System.Collections.Generic.IDictionary(Of String, Object), ByVal includeDS As Boolean, ByVal e As FormulaEvaluator) As String
            If e Is Nothing Then
                e = New FormulaEvaluator()
            End If
            
            e.Variables.Clear()

            
            ' add variables for formula evaluation
            If variables IsNot Nothing Then
                Dim enumerator As System.Collections.Generic.IEnumerator(Of System.Collections.Generic.KeyValuePair(Of String, Object)) = variables.GetEnumerator()
                While enumerator.MoveNext()
                    e.Variables.Add(enumerator.Current.Key, enumerator.Current.Value)
                End While
            End If

            If includeDS
                
            End IF
            
            
            ' Other variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            If dataSourceForEvaluate Is Nothing Then

                e.DataSource = Me.DataSource

            Else
                e.DataSource = dataSourceForEvaluate
            End If

            ' Define the calling control.  This is used to add other 
            ' related table and record controls as variables.
            e.CallingControl = Me

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If

            If Not String.IsNullOrEmpty(format) AndAlso (String.IsNullOrEmpty(formula) OrElse formula.IndexOf("Format(") < 0) Then
                Return FormulaUtils.Format(resultObj, format)
            Else
                Return resultObj.ToString()
            End If
        End Function      
        
        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate as BaseClasses.Data.BaseRecord, ByVal format as String, ByVal variables As System.Collections.Generic.IDictionary(Of String, Object), ByVal includeDS As Boolean) As String
            Return EvaluateFormula(formula, dataSourceForEvaluate, format,variables ,includeDS, Nothing)        
        End Function        

        
        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord, ByVal format As String, ByVal variables As System.Collections.Generic.IDictionary(Of String, Object)) As String
            Return EvaluateFormula(formula, dataSourceForEvaluate, format, variables ,True, Nothing)        
        End Function        

        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord, ByVal format As String) As String
            Return Me.EvaluateFormula(formula, dataSourceForEvaluate, format, Nothing, True, Nothing)
        End Function

        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord, ByVal variables As System.Collections.Generic.IDictionary(Of String, Object), ByVal e as FormulaEvaluator) As String
            Return Me.EvaluateFormula(formula, dataSourceForEvaluate, Nothing, variables, True, e)
        End Function

        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord) As String
            Return Me.EvaluateFormula(formula, dataSourceForEvaluate, Nothing, Nothing, True, Nothing)
        End Function

        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal includeDS as Boolean) As String
            Return Me.EvaluateFormula(formula, Nothing, Nothing, Nothing, includeDS, Nothing)
        End Function

        Public Overridable Function EvaluateFormula(ByVal formula As String) As String
            Return Me.EvaluateFormula(formula, Nothing, Nothing, Nothing, True, Nothing)
        End Function


        Public Overridable Sub RegisterPostback()
        
        
        End Sub

      
        
        ' To customize, override this method in View_MaxPersonalEducationTableControlRow.
        Public Overridable Sub SaveData()
            ' Saves the associated record in the database.
            ' SaveData calls Validate and Get methods - so it may be more appropriate to
            ' customize those methods.

            ' 1. Load the existing record from the database. Since we save the entire record, this ensures 
            ' that fields that are not displayed are also properly initialized.
            Me.LoadData()
        
              
            ' 2. Perform any custom validation.
            Me.Validate()

            
            ' 3. Set the values in the record with data from UI controls.
            ' This calls the Get() method for each of the user interface controls.
            Me.GetUIData()

            ' 4. Save in the database.
            ' We should not save the record if the data did not change. This
            ' will save a database hit and avoid triggering any database triggers.
             
            If Me.DataSource.IsAnyValueChanged Then
                ' Save record to database but do not commit yet.
                ' Auto generated ids are available after saving for use by child (dependent) records.
                Me.DataSource.Save()
              
                DirectCast(GetParentControlObject(Me, "View_MaxPersonalEducationTableControl"), View_MaxPersonalEducationTableControl).DataChanged = True
                DirectCast(GetParentControlObject(Me, "View_MaxPersonalEducationTableControl"), View_MaxPersonalEducationTableControl).ResetData = True
            End If
            
      
            ' update session or cookie by formula
                                    
      
            ' Setting the DataChanged to True results in the page being refreshed with
            ' the most recent data from the database.  This happens in PreRender event
            ' based on the current sort, search and filter criteria.
            Me.DataChanged = True
            Me.ResetData = True
            
            ' For Master-Detail relationships, save data on the Detail table(s)
          
        End Sub

        ' To customize, override this method in View_MaxPersonalEducationTableControlRow.
        Public Overridable Sub GetUIData()
            ' The GetUIData method retrieves the updated values from the user interface 
            ' controls into a database record in preparation for saving or updating.
            ' To do this, it calls the Get methods for each of the field displayed on 
            ' the webpage.  It is better to make changes in the Get methods, rather 
            ' than making changes here.
      
            ' Call the Get methods for each of the user interface controls.
        
            GetCountry()
            GetCourse()
            GetCourseAbbr()
            GetEdYear()
            GetFacultry()
            GetInstitue()
            GetLevel()
            GetRankAndName()
            GetSectionAbbvrName()
        End Sub
        
        
        Public Overridable Sub GetCountry()
            
        End Sub
                
        Public Overridable Sub GetCourse()
            
        End Sub
                
        Public Overridable Sub GetCourseAbbr()
            
        End Sub
                
        Public Overridable Sub GetEdYear()
            
        End Sub
                
        Public Overridable Sub GetFacultry()
            
        End Sub
                
        Public Overridable Sub GetInstitue()
            
        End Sub
                
        Public Overridable Sub GetLevel()
            
        End Sub
                
        Public Overridable Sub GetRankAndName()
            
        End Sub
                
        Public Overridable Sub GetSectionAbbvrName()
            
        End Sub
                
      
        ' To customize, override this method in View_MaxPersonalEducationTableControlRow.
        
        Public Overridable Function CreateWhereClause() As WhereClause
        
            Return Nothing
            
        End Function
        
    

        ' To customize, override this method in View_MaxPersonalEducationTableControlRow.
        Public Overridable Sub Validate() 
            ' Add custom validation for any control within this panel.
            ' Example.  If you have a State ASP:Textbox control
            ' If Me.State.Text <> "CA" Then
            '    Throw New Exception("State must be CA (California).")
            ' End If

            ' The Validate method is common across all controls within
            ' this panel so you can validate multiple fields, but report
            ' one error message.
            
                
        End Sub

        Public Overridable Sub Delete()
        
            If Me.IsNewRecord() Then
                Return
            End If

            Dim pkValue As KeyValue = KeyValue.XmlToKey(Me.RecordUniqueId)
          View_MaxPersonalEducationView.DeleteRecord(pkValue)
          
            DirectCast(GetParentControlObject(Me, "View_MaxPersonalEducationTableControl"), View_MaxPersonalEducationTableControl).DataChanged = True
            DirectCast(GetParentControlObject(Me, "View_MaxPersonalEducationTableControl"), View_MaxPersonalEducationTableControl).ResetData = True
        End Sub

        Protected Overridable Sub Control_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
            ' PreRender event is raised just before page is being displayed.
            Try
                DbUtils.StartTransaction()
                Me.RegisterPostback()

                If Not Me.Page.ErrorOnPage AndAlso (Me.Page.IsPageRefresh OrElse Me.DataChanged OrElse Me.ResetData) Then
                  
                    ' Call the Set methods for each controls on the panel that use resultset
                  
                
                    ' Re-load the data and update the web page if necessary.
                    ' This is typically done during a postback (filter, search button, sort, pagination button).
                    ' In each of the other click handlers, simply set DataChanged to True to reload the data.
                    Me.LoadData()
                    Me.DataBind()			
                End If
                                
                						
            Catch ex As Exception
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
            Finally
                DbUtils.EndTransaction()
            End Try
        End Sub
        
            
        Protected Overrides Sub SaveControlsToSession()
            MyBase.SaveControlsToSession()
        
    
            'Save pagination state to session.
          
        End Sub
        
        
    
        Protected Overrides Sub ClearControlsFromSession()
            MyBase.ClearControlsFromSession()

        

            ' Clear pagination state from session.
        
        End Sub

        Protected Overrides Sub LoadViewState(ByVal savedState As Object)
            MyBase.LoadViewState(savedState)
            Dim isNewRecord As String = CType(ViewState("IsNewRecord"), String)
            If Not isNewRecord Is Nothing AndAlso isNewRecord.Trim <> "" Then
                Me.IsNewRecord = Boolean.Parse(isNewRecord)
            End If
            
            Dim myCheckSum As String = CType(ViewState("CheckSum"), String)
            If Not myCheckSum Is Nothing AndAlso myCheckSum.Trim <> "" Then
                Me.CheckSum = myCheckSum
            End If
            
    
            ' Load view state for pagination control.
                 
        End Sub

        Protected Overrides Function SaveViewState() As Object
            ViewState("IsNewRecord") = Me.IsNewRecord.ToString()
            ViewState("CheckSum") = Me.CheckSum
            
    
            ' Load view state for pagination control.
                  
            Return MyBase.SaveViewState()
        End Function
        
        
   
        Private _PreviousUIData As New Hashtable
        Public Overridable Property PreviousUIData() As Hashtable
            Get
                Return _PreviousUIData
            End Get
            Set(ByVal value As Hashtable)
                _PreviousUIData = value
            End Set
        End Property   
   
        Private _IsNewRecord As Boolean = True
        Public Overridable Property IsNewRecord() As Boolean
            Get
                Return Me._IsNewRecord
            End Get
            Set(ByVal value As Boolean)
                Me._IsNewRecord = value
            End Set
        End Property

        Private _DataChanged As Boolean = False
        Public Overridable Property DataChanged() As Boolean
            Get
                Return Me._DataChanged
            End Get
            Set(ByVal Value As Boolean)
                Me._DataChanged = Value
            End Set
        End Property

        Private _ResetData As Boolean = False
        Public Overridable Property ResetData() As Boolean
            Get
                Return Me._ResetData
            End Get
            Set(ByVal Value As Boolean)
                Me._ResetData = Value
            End Set
        End Property
        
        Public Property RecordUniqueId() As String
            Get
                Return CType(Me.ViewState("BaseView_MaxPersonalEducationTableControlRow_Rec"), String)
            End Get
            Set(ByVal value As String)
                Me.ViewState("BaseView_MaxPersonalEducationTableControlRow_Rec") = value
            End Set
        End Property
        
        Private _DataSource As View_MaxPersonalEducationRecord
        Public Property DataSource() As View_MaxPersonalEducationRecord     
            Get
                Return Me._DataSource
            End Get
            
            Set(ByVal value As View_MaxPersonalEducationRecord)
            
                Me._DataSource = value
            End Set
        End Property

        

        Private _checkSum As String
        Public Overridable Property CheckSum() As String
            Get
                Return Me._checkSum
            End Get
            Set(ByVal value As String)
                Me._checkSum = value
            End Set
        End Property
        
        Private _TotalPages As Integer
        Public Property TotalPages() As Integer
            Get
                Return Me._TotalPages
            End Get
            Set(ByVal value As Integer)
                Me._TotalPages = value
            End Set
        End Property
        
        Private _PageIndex As Integer
        Public Property PageIndex() As Integer
            Get
                ' Return the PageIndex
                Return Me._PageIndex
            End Get
            Set(ByVal value As Integer)
                Me._PageIndex = value
            End Set
        End Property
    
        Private _DisplayLastPage As Boolean
        Public Property DisplayLastPage() As Boolean
            Get
                Return Me._DisplayLastPage
            End Get
            Set(ByVal value As Boolean)
                Me._DisplayLastPage = value
            End Set
        End Property
        
        

#Region "Helper Properties"
        
        Public ReadOnly Property Country() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "Country"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
            
        Public ReadOnly Property Course() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "Course"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
            
        Public ReadOnly Property CourseAbbr() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "CourseAbbr"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
            
        Public ReadOnly Property EdYear() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "EdYear"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
            
        Public ReadOnly Property Facultry() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "Facultry"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
            
        Public ReadOnly Property Institue() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "Institue"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
            
        Public ReadOnly Property Level() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "Level"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
            
        Public ReadOnly Property RankAndName() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "RankAndName"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
            
        Public ReadOnly Property SectionAbbvrName() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "SectionAbbvrName"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
            
#End Region

#Region "Helper Functions"

        Public Overrides Overloads Function ModifyRedirectUrl(ByVal url As String, ByVal arg As String, ByVal bEncrypt As Boolean) As String
            Return Me.Page.EvaluateExpressions(url, arg, bEncrypt, Me)
        End Function

        Public Overrides Overloads Function EvaluateExpressions(ByVal url As String, ByVal arg As String, ByVal bEncrypt As Boolean) As String
            
            Dim rec As View_MaxPersonalEducationRecord = Nothing
             
        
            Try
                rec = Me.GetRecord()
            Catch ex As Exception
                ' Do nothing
            End Try

            If rec Is Nothing AndAlso url.IndexOf("{") >= 0 Then
                ' Localization.
                
            Throw New Exception(Page.GetResourceValue("Err:RecDataSrcNotInitialized", "Persons"))
                    
            End If
            Return EvaluateExpressions(url, arg, rec, bEncrypt)
        End Function

         
        Public Overridable Function GetRecord() As View_MaxPersonalEducationRecord
            If Not Me.DataSource Is Nothing Then
                Return Me.DataSource
            End If
            
            If Not Me.RecordUniqueId Is Nothing Then
                
                Return View_MaxPersonalEducationView.GetRecord(Me.RecordUniqueId, True)
                
            End If
            
            ' Localization.
            
            Throw New Exception(Page.GetResourceValue("Err:RetrieveRec", "Persons"))
                
        End Function

        Public Shadows ReadOnly Property Page() As BaseApplicationPage
            Get
                Return DirectCast(MyBase.Page, BaseApplicationPage)
            End Get
        End Property

#End Region

End Class

  

' Base class for the View_MaxPersonalEducationTableControl control on the ShowViewMaxPersonalEducation page.
' Do not modify this class. Instead override any method in View_MaxPersonalEducationTableControl.
Public Class BaseView_MaxPersonalEducationTableControl
        Inherits Persons.UI.BaseApplicationTableControl

        

        Protected Overridable Sub Control_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Init
  
      
                  
           ' Setup the filter and search events.
        
            AddHandler Me.CourseAbbrFilter.SelectedIndexChanged, AddressOf CourseAbbrFilter_SelectedIndexChanged
            AddHandler Me.FacultryFilter.SelectedIndexChanged, AddressOf FacultryFilter_SelectedIndexChanged
            AddHandler Me.LevelFilter.SelectedIndexChanged, AddressOf LevelFilter_SelectedIndexChanged
            AddHandler Me.RankLevelFromFilter.SelectedIndexChanged, AddressOf RankLevelFromFilter_SelectedIndexChanged
            AddHandler Me.SectionAbbvrNameFilter.SelectedIndexChanged, AddressOf SectionAbbvrNameFilter_SelectedIndexChanged
            If Not Me.Page.IsPostBack Then
                Dim initialVal As String = ""
                If  Me.InSession(Me.CourseAbbrFilter) 				
                    initialVal = Me.GetFromSession(Me.CourseAbbrFilter)
                
              End If
              
                If initialVal <> ""				
                        
                        Me.CourseAbbrFilter.Items.Add(New ListItem(initialVal, initialVal))
                            
                        Me.CourseAbbrFilter.SelectedValue = initialVal
                            
                    End If
                
            End If
            If Not Me.Page.IsPostBack Then
                Dim initialVal As String = ""
                If  Me.InSession(Me.FacultryFilter) 				
                    initialVal = Me.GetFromSession(Me.FacultryFilter)
                
              End If
              
                If initialVal <> ""				
                        
                        Me.FacultryFilter.Items.Add(New ListItem(initialVal, initialVal))
                            
                        Me.FacultryFilter.SelectedValue = initialVal
                            
                    End If
                
            End If
            If Not Me.Page.IsPostBack Then
                Dim initialVal As String = ""
                If  Me.InSession(Me.LevelFilter) 				
                    initialVal = Me.GetFromSession(Me.LevelFilter)
                
              End If
              
                If initialVal <> ""				
                        
                        Me.LevelFilter.Items.Add(New ListItem(initialVal, initialVal))
                            
                        Me.LevelFilter.SelectedValue = initialVal
                            
                    End If
                
            End If
            If Not Me.Page.IsPostBack Then
                Dim initialVal As String = ""
                If  Me.InSession(Me.RankLevelFromFilter) 				
                    initialVal = Me.GetFromSession(Me.RankLevelFromFilter)
                
              End If
              
                If initialVal <> ""				
                        
                        Me.RankLevelFromFilter.Items.Add(New ListItem(initialVal, initialVal))
                            
                        Me.RankLevelFromFilter.SelectedValue = initialVal
                            
                    End If
                
            End If
            If Not Me.Page.IsPostBack Then
                Dim initialVal As String = ""
                If  Me.InSession(Me.SectionAbbvrNameFilter) 				
                    initialVal = Me.GetFromSession(Me.SectionAbbvrNameFilter)
                
              End If
              
                If initialVal <> ""				
                        
                        Me.SectionAbbvrNameFilter.Items.Add(New ListItem(initialVal, initialVal))
                            
                        Me.SectionAbbvrNameFilter.SelectedValue = initialVal
                            
                    End If
                
            End If
            If Not Me.Page.IsPostBack Then
                Dim initialVal As String = ""
                If  Me.InSession(Me.View_MaxPersonalEducationSearch1) 				
                    initialVal = Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)
                
              End If
              
                If initialVal <> ""				
                        
                        Me.View_MaxPersonalEducationSearch1.Text = initialVal
                            
                    End If
                
            End If
      
      
            ' Control Initializations.
            ' Initialize the table's current sort order.
            
            If Me.InSession(Me, "Order_By") Then
                Me.CurrentSortOrder = OrderBy.FromXmlString(Me.GetFromSession(Me, "Order_By", Nothing))
            Else
                Me.CurrentSortOrder = New OrderBy(True, False)
            
    End If

    
    
            ' Setup default pagination settings.
        
            Me.PageSize = CInt(Me.GetFromSession(Me, "Page_Size", "10"))
            Me.PageIndex = CInt(Me.GetFromSession(Me, "Page_Index", "0"))
            
        
            
            Me.ClearControlsFromSession()
        End Sub

        Protected Overridable Sub Control_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        
            SaveControlsToSession_Ajax()
        
            ' Setup the pagination events.
            
              AddHandler Me.View_MaxPersonalEducationPagination.FirstPage.Click, AddressOf View_MaxPersonalEducationPagination_FirstPage_Click
              
              AddHandler Me.View_MaxPersonalEducationPagination.LastPage.Click, AddressOf View_MaxPersonalEducationPagination_LastPage_Click
              
              AddHandler Me.View_MaxPersonalEducationPagination.NextPage.Click, AddressOf View_MaxPersonalEducationPagination_NextPage_Click
              
              AddHandler Me.View_MaxPersonalEducationPagination.PageSizeButton.Click, AddressOf View_MaxPersonalEducationPagination_PageSizeButton_Click
            
              AddHandler Me.View_MaxPersonalEducationPagination.PreviousPage.Click, AddressOf View_MaxPersonalEducationPagination_PreviousPage_Click
                          
        
            ' Setup the sorting events.
          
              AddHandler Me.SectionAbbvrNameLabel.Click, AddressOf SectionAbbvrNameLabel_Click
            
            ' Setup the button events.
          
              AddHandler Me.View_MaxPersonalEducationExportCSVButton.Click, AddressOf View_MaxPersonalEducationExportCSVButton_Click
              
              AddHandler Me.View_MaxPersonalEducationExportExcelButton.Click, AddressOf View_MaxPersonalEducationExportExcelButton_Click
              
              AddHandler Me.View_MaxPersonalEducationPDFButton.Click, AddressOf View_MaxPersonalEducationPDFButton_Click
              
              AddHandler Me.View_MaxPersonalEducationRefreshButton.Click, AddressOf View_MaxPersonalEducationRefreshButton_Click
              
              AddHandler Me.View_MaxPersonalEducationResetButton.Click, AddressOf View_MaxPersonalEducationResetButton_Click
              
              AddHandler Me.View_MaxPersonalEducationWordButton.Click, AddressOf View_MaxPersonalEducationWordButton_Click
              
            AddHandler Me.View_MaxPersonalEducationSearchButton1.Button.Click, AddressOf View_MaxPersonalEducationSearchButton1_Click
            
        
          ' Setup events for others
            
        End Sub
        
        
        Public Overridable Sub LoadData()        
        
            ' Read data from database. Returns an array of records that can be assigned
            ' to the DataSource table control property.
            Try	
                Dim joinFilter As CompoundFilter = CreateCompoundJoinFilter()
                
                ' The WHERE clause will be empty when displaying all records in table.
                Dim wc As WhereClause = CreateWhereClause()
                If wc IsNot Nothing AndAlso Not wc.RunQuery Then
                    ' Initialize an empty array of records
                    Dim alist As New ArrayList(0)
                    Me.DataSource = DirectCast(alist.ToArray(GetType(View_MaxPersonalEducationRecord)), View_MaxPersonalEducationRecord())
                    ' Add records to the list if needed.
                    Me.AddNewRecords()
                    Me._TotalRecords = 0
                    Me._TotalPages = 0
                    Return
                End If

                ' Call OrderBy to determine the order - either use the order defined
                ' on the Query Wizard, or specified by user (by clicking on column heading)
                Dim orderBy As OrderBy = CreateOrderBy()
                
                ' Get the pagesize from the pagesize control.
                Me.GetPageSize()
                               
                If Me.DisplayLastPage Then
                    Dim totalRecords As Integer = If(Me._TotalRecords < 0, View_MaxPersonalEducationView.GetRecordCount(CreateCompoundJoinFilter(), CreateWhereClause()), Me._TotalRecords)
                     
                      Dim totalPages As Integer = CInt(Math.Ceiling(totalRecords / Me.PageSize))
                    
                    Me.PageIndex = totalPages - 1
                End If                               
                
                ' Make sure PageIndex (current page) and PageSize are within bounds.
                If Me.PageIndex < 0 Then
                    Me.PageIndex = 0
                End If
                If Me.PageSize < 1 Then
                    Me.PageSize = 1
                End If
                
                ' Retrieve the records and set the table DataSource.
                ' Only PageSize records are fetched starting at PageIndex (zero based).
                If Me.AddNewRecord > 0 Then
                ' Make sure to preserve the previously entered data on new rows.
                    Dim postdata As New ArrayList
                    For Each rc As View_MaxPersonalEducationTableControlRow In Me.GetRecordControls()
                        If Not rc.IsNewRecord Then
                            rc.DataSource = rc.GetRecord()
                            rc.GetUIData()
                            postdata.Add(rc.DataSource)
                            UIData.Add(rc.PreservedUIData())							
                        End If
                    Next
                    Me.DataSource = DirectCast(postdata.ToArray(GetType(View_MaxPersonalEducationRecord)), View_MaxPersonalEducationRecord())
                Else  ' Get the records from the database	
                        Me.DataSource = View_MaxPersonalEducationView.GetRecords(joinFilter, wc, orderBy, Me.PageIndex, Me.PageSize)
                      
                End If
                
                ' if the datasource contains no records contained in database, then load the last page.
                If (DbUtils.GetCreatedRecords(Me.DataSource).Length = 0 AndAlso Not Me.DisplayLastPage) Then
                      Me.DisplayLastPage = True
                      LoadData()
                Else
                
                    ' Add any new rows desired by the user.
                    Me.AddNewRecords()
                

                    ' Initialize the page and grand totals. now
                
                End If
    
            Catch ex As Exception
                ' Report the error message to the end user
                Dim msg As String = ex.Message
                If ex.InnerException IsNot Nothing Then
                    msg = msg & " InnerException: " & ex.InnerException.Message
                End If
                Throw New Exception(msg, ex.InnerException)
            End Try
        End Sub
        
        
        
    
        Public Overrides Sub DataBind()
            ' The DataBind method binds the user interface controls to the values
            ' from the database record for each row in the table.  To do this, it calls the
            ' DataBind for each of the rows.
            ' DataBind also populates any filters above the table, and sets the pagination
            ' control to the correct number of records and the current page number.
            
            MyBase.DataBind()

            ' Make sure that the DataSource is initialized.
            If Me.DataSource Is Nothing Then
                Return
            End If
            
            'LoadData for DataSource for chart and report if they exist
               
            ' Setup the pagination controls.
            BindPaginationControls()

      
        
          ' Bind the repeater with the list of records to expand the UI.
          Dim rep As System.Web.UI.WebControls.Repeater = CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationTableControlRepeater"), System.Web.UI.WebControls.Repeater)
          If rep Is Nothing Then Return
          rep.DataSource = DataSource()
          rep.DataBind()

          Dim index As Integer = 0
          For Each repItem As System.Web.UI.WebControls.RepeaterItem In rep.Items
          ' Loop through all rows in the table, set its DataSource and call DataBind().
          Dim recControl As View_MaxPersonalEducationTableControlRow = DirectCast(repItem.FindControl("View_MaxPersonalEducationTableControlRow"), View_MaxPersonalEducationTableControlRow)
          recControl.DataSource = Me.DataSource(index)
          If Me.UIData.Count > index Then
          recControl.PreviousUIData = Me.UIData(index)
          End If
          recControl.DataBind()
            recControl.Visible = Not Me.InDeletedRecordIds(recControl)
          
          index += 1
          Next
        
    
           
                
            ' Call the Set methods for each controls on the panel
        
                SetCountryLabel()
                SetCourseAbbrFilter()
                SetCourseAbbrLabel()
                SetCourseAbbrLabel1()
                SetCourseLabel()
                SetEdYearLabel()
                SetFacultryFilter()
                SetFacultryLabel()
                SetFacultryLabel1()
                SetInstitueLabel()
                SetLevelFilter()
                SetLevelLabel()
                SetLevelLabel1()
                SetPersonalNameLabel()
                SetRankLevelFromFilter()
                SetRankLevelLabel()
                SetSectionAbbvrNameFilter()
                SetSectionAbbvrNameLabel()
                SetSectionAbbvrNameLabel1()
                
                
                
                
                
                
                SetView_MaxPersonalEducationSearch1()
                
                SetView_MaxPersonalEducationTableControlCollapsibleRegion()
                SetView_MaxPersonalEducationTableControlIcon()
                SetView_MaxPersonalEducationTableControlPanelExtender()
                
                
            ' setting the state of expand or collapse alternative rows
      
    
            ' Load data for each record and table UI control.
            ' Ordering is important because child controls get 
            ' their parent ids from their parent UI controls.
                
      
            ' this method calls the set method for controls with special formula like running total, sum, rank, etc
            SetFormulaControls()
      End Sub
      
        Public Overridable Sub SetFormulaControls()
            ' this method calls Set methods for the control that has special formula
        
        

    End Sub

    
      
        Public Overridable Sub RegisterPostback()
        
              Me.Page.RegisterPostBackTrigger(MiscUtils.FindControlRecursively(Me,"View_MaxPersonalEducationExportCSVButton"))
                        
              Me.Page.RegisterPostBackTrigger(MiscUtils.FindControlRecursively(Me,"View_MaxPersonalEducationExportExcelButton"))
                        
              Me.Page.RegisterPostBackTrigger(MiscUtils.FindControlRecursively(Me,"View_MaxPersonalEducationPDFButton"))
                        
              Me.Page.RegisterPostBackTrigger(MiscUtils.FindControlRecursively(Me,"View_MaxPersonalEducationWordButton"))
                        
        
        End Sub

        Public EvaluateFormulaDelegate As BaseClasses.Data.DataSource.EvaluateFormulaDelegate = New BaseClasses.Data.DataSource.EvaluateFormulaDelegate(AddressOf Me.EvaluateFormula)

        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate as BaseClasses.Data.BaseRecord, ByVal format as String, ByVal variables As System.Collections.Generic.IDictionary(Of String, Object), ByVal includeDS As Boolean, ByVal e as FormulaEvaluator) As String
            If e Is Nothing
                e = New FormulaEvaluator()
            End If
            
            e.Variables.Clear()
            
            
            ' add variables for formula evaluation
            If variables IsNot Nothing Then
                Dim enumerator As System.Collections.Generic.IEnumerator(Of System.Collections.Generic.KeyValuePair(Of String, Object)) = variables.GetEnumerator()
                While enumerator.MoveNext()
                    e.Variables.Add(enumerator.Current.Key, enumerator.Current.Value)
                End While
            End If
            
            If includeDS
                
            End If
            
            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            ' Define the calling control.  This is used to add other 
            ' related table and record controls as variables.
            e.CallingControl = Me

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
            
            If Not String.IsNullOrEmpty(format) AndAlso (String.IsNullOrEmpty(formula) OrElse formula.IndexOf("Format(") < 0) Then
                Return FormulaUtils.Format(resultObj, format)
            Else
                Return resultObj.ToString()
            End If
        End Function			

        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate as BaseClasses.Data.BaseRecord, ByVal format as String, ByVal variables As System.Collections.Generic.IDictionary(Of String, Object), ByVal includeDS As Boolean) As String
            Return EvaluateFormula(formula, dataSourceForEvaluate, format,variables ,includeDS, Nothing)        
        End Function        

        
        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord, ByVal format As String, ByVal variables As System.Collections.Generic.IDictionary(Of String, Object)) As String
            Return EvaluateFormula(formula, dataSourceForEvaluate, format, variables ,True, Nothing)        
        End Function        

        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord, ByVal format As String) As String
            Return Me.EvaluateFormula(formula, dataSourceForEvaluate, format, Nothing, True, Nothing)
        End Function

        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord, ByVal variables As System.Collections.Generic.IDictionary(Of String, Object), ByVal e as FormulaEvaluator) As String
            Return Me.EvaluateFormula(formula, dataSourceForEvaluate, Nothing, variables, True, e)
        End Function

        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord) As String
            Return Me.EvaluateFormula(formula, dataSourceForEvaluate, Nothing, Nothing, True, Nothing)
        End Function

        Public Overridable Function EvaluateFormula(ByVal formula As String, ByVal includeDS as Boolean) As String
            Return Me.EvaluateFormula(formula, Nothing, Nothing, Nothing, includeDS, Nothing)
        End Function

        Public Overridable Function EvaluateFormula(ByVal formula As String) As String
            Return Me.EvaluateFormula(formula, Nothing, Nothing, Nothing, True, Nothing)
        End Function




        Public Overridable Sub ResetControl()
                    
            Me.CourseAbbrFilter.ClearSelection()
            
            Me.FacultryFilter.ClearSelection()
            
            Me.LevelFilter.ClearSelection()
            
            Me.RankLevelFromFilter.ClearSelection()
            
            Me.SectionAbbvrNameFilter.ClearSelection()
            
            Me.View_MaxPersonalEducationSearch1.Text = ""
            
            Me.CurrentSortOrder.Reset()
            If (Me.InSession(Me, "Order_By")) Then
                Me.CurrentSortOrder = OrderBy.FromXmlString(Me.GetFromSession(Me, "Order_By", Nothing))
            Else
                Me.CurrentSortOrder = New OrderBy(True, False)
                
            End If
                
            Me.PageIndex = 0
        End Sub

        Protected Overridable Sub BindPaginationControls()
            ' Setup the pagination controls.

            ' Bind the pagination labels.
        
            If DbUtils.GetCreatedRecords(Me.DataSource).Length > 0 Then                      
                    
                Me.View_MaxPersonalEducationPagination.CurrentPage.Text = (Me.PageIndex + 1).ToString()
            Else
                Me.View_MaxPersonalEducationPagination.CurrentPage.Text = "0"
            End If
            Me.View_MaxPersonalEducationPagination.PageSize.Text = Me.PageSize.ToString()
            Me.View_MaxPersonalEducationPagination.TotalItems.Text = Me.TotalRecords.ToString()
            Me.View_MaxPersonalEducationPagination.TotalPages.Text = Me.TotalPages.ToString()

            ' Bind the buttons for View_MaxPersonalEducationTableControl pagination.
        
            Me.View_MaxPersonalEducationPagination.FirstPage.Enabled = Not (Me.PageIndex = 0)
            If Me._TotalPages < 0 Then      ' if the total pages is not determined yet, enable last and next buttons
                Me.View_MaxPersonalEducationPagination.LastPage.Enabled = True
            ElseIf Me._TotalPages = 0          ' if the total pages is determined and it is 0, enable last and next buttons
                Me.View_MaxPersonalEducationPagination.LastPage.Enabled = False            
            Else                               ' if the total pages is the last page, disable last and next buttons
                Me.View_MaxPersonalEducationPagination.LastPage.Enabled = Not (Me.PageIndex = Me.TotalPages - 1)
            End If
          
            If Me._TotalPages < 0 Then      ' if the total pages is not determined yet, enable last and next buttons
                Me.View_MaxPersonalEducationPagination.NextPage.Enabled = True
            ElseIf Me._TotalPages = 0          ' if the total pages is determined and it is 0, enable last and next buttons
                Me.View_MaxPersonalEducationPagination.NextPage.Enabled = False            
            Else                               ' if the total pages is the last page, disable last and next buttons
                Me.View_MaxPersonalEducationPagination.NextPage.Enabled = Not (Me.PageIndex = Me.TotalPages - 1)
            End If
          
            Me.View_MaxPersonalEducationPagination.PreviousPage.Enabled = Not (Me.PageIndex = 0)


        End Sub

        Public Overridable Sub SaveData()
            ' Save the data from the entire table.  Calls each row's Save Data
            ' to save their data.  This function is called by the Click handler of the
            ' Save button.  The button handler should Start/Commit/End a transaction.
            
            Dim recCtl As View_MaxPersonalEducationTableControlRow
            For Each recCtl In Me.GetRecordControls()
        
                If Me.InDeletedRecordIds(recCtl) Then
                    ' Delete any pending deletes. 
                    recCtl.Delete()
                Else
                    If recCtl.Visible Then
                        recCtl.SaveData()
                    End If
                End If
          
            Next
            
            ' Setting the DataChanged to True results in the page being refreshed with
            ' the most recent data from the database.  This happens in PreRender event
            ' based on the current sort, search and filter criteria.
            Me.DataChanged = True
            Me.ResetData = True
          
            ' Set IsNewRecord to False for all records - since everything has been saved and is no longer "new"
            For Each recCtl In Me.GetRecordControls()
                recCtl.IsNewRecord = False
            Next
    
      
            ' Set DeletedRecordsIds to Nothing since we have deleted all pending deletes.
            Me.DeletedRecordIds = Nothing
      
        End Sub

        Public Overridable Function CreateCompoundJoinFilter() As CompoundFilter
            Dim jFilter As CompoundFilter = New CompoundFilter()
        
            Return jFilter

        End Function

        
          Public Overridable Function CreateOrderBy() As OrderBy
          ' The CurrentSortOrder is initialized to the sort order on the
          ' Query Wizard.  It may be modified by the Click handler for any of
          ' the column heading to sort or reverse sort by that column.
          ' You can add your own sort order, or modify it on the Query Wizard.
          Return Me.CurrentSortOrder
          End Function
      
        Public Overridable Function CreateWhereClause() As WhereClause
            'This CreateWhereClause is used for loading the data.
            View_MaxPersonalEducationView.Instance.InnerFilter = Nothing
            Dim wc As WhereClause = New WhereClause()
            
            ' Compose the WHERE clause consiting of:
            ' 1. Static clause defined at design time.
            ' 2. User selected search criteria.
            ' 3. User selected filter criteria.

              
            If IsValueSelected(Me.CourseAbbrFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.CourseAbbrFilter, Me.GetFromSession(Me.CourseAbbrFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.FacultryFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.FacultryFilter, Me.GetFromSession(Me.FacultryFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.LevelFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.Level, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.LevelFilter, Me.GetFromSession(Me.LevelFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.RankLevelFromFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.RankLevel, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.RankLevelFromFilter, Me.GetFromSession(Me.RankLevelFromFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.SectionAbbvrNameFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.SectionAbbvrName, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.SectionAbbvrNameFilter, Me.GetFromSession(Me.SectionAbbvrNameFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.View_MaxPersonalEducationSearch1) Then
              If Me.View_MaxPersonalEducationSearch1.Text = BaseClasses.Resources.AppResources.GetResourceValue("Txt:SearchForEllipsis", Nothing) Then
                 Me.View_MaxPersonalEducationSearch1.Text = ""
              Else
              ' Strip "..." from begin and ending of the search text, otherwise the search will return 0 values as in database "..." is not stored.
              
                    If Me.View_MaxPersonalEducationSearch1.Text.StartsWith("...") Then
                        Me.View_MaxPersonalEducationSearch1.Text = Me.View_MaxPersonalEducationSearch1.Text.SubString(3,Me.View_MaxPersonalEducationSearch1.Text.Length-3)
                    End If
                    If Me.View_MaxPersonalEducationSearch1.Text.EndsWith("...") then
                        Me.View_MaxPersonalEducationSearch1.Text = Me.View_MaxPersonalEducationSearch1.Text.SubString(0,Me.View_MaxPersonalEducationSearch1.Text.Length-3)
                        ' Strip the last word as well as it is likely only a partial word
                        Dim endindex As Integer = View_MaxPersonalEducationSearch1.Text.Length - 1
                        While (Not Char.IsWhiteSpace(View_MaxPersonalEducationSearch1.Text(endindex)) AndAlso endindex > 0)
                            endindex -= 1
                        End While
                        If endindex > 0 Then
                            View_MaxPersonalEducationSearch1.Text = View_MaxPersonalEducationSearch1.Text.Substring(0, endindex)
                        End If
              End If
            End If
            
              Dim formatedSearchText As String = MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1))
                
                ' After stripping "..." see if the search text is null or empty.
                If IsValueSelected(Me.View_MaxPersonalEducationSearch1) Then 
        ' These clauses are added depending on operator and fields selected in Control's property page, bindings tab.
                    
                    Dim search As WhereClause = New WhereClause()
                    
                    search.iOR(View_MaxPersonalEducationView.Course, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    search.iOR(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    search.iOR(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    wc.iAND(search)
                  
                End If
            End If
                  
    Return wc
    End Function

    
        Public Overridable Function CreateWhereClause(ByVal searchText as String, ByVal fromSearchControl as String, ByVal AutoTypeAheadSearch as String, ByVal AutoTypeAheadWordSeparators as String) As WhereClause
            ' This CreateWhereClause is used for loading list of suggestions for Auto Type-Ahead feature.
            View_MaxPersonalEducationView.Instance.InnerFilter = Nothing
            Dim wc As WhereClause = New WhereClause()
        
      ' Compose the WHERE clause consiting of:
      ' 1. Static clause defined at design time.
      ' 2. User selected search criteria.
      ' 3. User selected filter criteria.

      Dim appRelativeVirtualPath As String = CType(HttpContext.Current.Session("AppRelativeVirtualPath"), String)
      
            ' Adds clauses if values are selected in Filter controls which are configured in the page.
          
            Dim CourseAbbrFilterSelectedValue As String = CType(HttpContext.Current.Session()(HttpContext.Current.Session.SessionID & appRelativeVirtualPath & "CourseAbbrFilter_Ajax"), String)
            If IsValueSelected(CourseAbbrFilterSelectedValue) Then
    
                 wc.iAND(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.EqualsTo, CourseAbbrFilterSelectedValue, false, False)
             
             End If
                      
            Dim FacultryFilterSelectedValue As String = CType(HttpContext.Current.Session()(HttpContext.Current.Session.SessionID & appRelativeVirtualPath & "FacultryFilter_Ajax"), String)
            If IsValueSelected(FacultryFilterSelectedValue) Then
    
                 wc.iAND(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.EqualsTo, FacultryFilterSelectedValue, false, False)
             
             End If
                      
            Dim LevelFilterSelectedValue As String = CType(HttpContext.Current.Session()(HttpContext.Current.Session.SessionID & appRelativeVirtualPath & "LevelFilter_Ajax"), String)
            If IsValueSelected(LevelFilterSelectedValue) Then
    
                 wc.iAND(View_MaxPersonalEducationView.Level, BaseFilter.ComparisonOperator.EqualsTo, LevelFilterSelectedValue, false, False)
             
             End If
                      
            Dim RankLevelFromFilterSelectedValue As String = CType(HttpContext.Current.Session()(HttpContext.Current.Session.SessionID & appRelativeVirtualPath & "RankLevelFromFilter_Ajax"), String)
            If IsValueSelected(RankLevelFromFilterSelectedValue) Then
    
                 wc.iAND(View_MaxPersonalEducationView.RankLevel, BaseFilter.ComparisonOperator.EqualsTo, RankLevelFromFilterSelectedValue, false, False)
             
             End If
                      
            Dim SectionAbbvrNameFilterSelectedValue As String = CType(HttpContext.Current.Session()(HttpContext.Current.Session.SessionID & appRelativeVirtualPath & "SectionAbbvrNameFilter_Ajax"), String)
            If IsValueSelected(SectionAbbvrNameFilterSelectedValue) Then
    
                 wc.iAND(View_MaxPersonalEducationView.SectionAbbvrName, BaseFilter.ComparisonOperator.EqualsTo, SectionAbbvrNameFilterSelectedValue, false, False)
             
             End If
                      
            If IsValueSelected(searchText) and fromSearchControl = "View_MaxPersonalEducationSearch1" Then
                Dim formatedSearchText as String = searchText
                ' Strip "..." from begin and ending of the search text, otherwise the search will return 0 values as in database "..." is not stored.
                If searchText.StartsWith("...") Then
                    formatedSearchText = searchText.SubString(3,searchText.Length-3)
                End If
                If searchText.EndsWith("...") Then
                    formatedSearchText = searchText.SubString(0,searchText.Length-3)
                    ' Strip the last word as well as it is likely only a partial word
                    Dim endindex As Integer = searchText.Length - 1
                    While (Not Char.IsWhiteSpace(searchText(endindex)) AndAlso endindex > 0)
                        endindex -= 1
                    End While
                    If endindex > 0 Then
                        searchText = searchText.Substring(0, endindex)
                    End If
                End If
                'After stripping "...", trim any leading and trailing whitespaces 
                formatedSearchText = formatedSearchText.Trim()
                ' After stripping "..." see if the search text is null or empty.
                If IsValueSelected(formatedSearchText) Then
                      ' These clauses are added depending on operator and fields selected in Control's property page, bindings tab.
                    
                    Dim search As WhereClause = New WhereClause()
                    
                    If InvariantLCase(AutoTypeAheadSearch).equals("wordsstartingwithsearchstring") Then
                
                        search.iOR(View_MaxPersonalEducationView.Course, BaseFilter.ComparisonOperator.Starts_With, formatedSearchText, True, False)
                        search.iOR(View_MaxPersonalEducationView.Course, BaseFilter.ComparisonOperator.Contains, AutoTypeAheadWordSeparators & formatedSearchText, True, False)
                
                        search.iOR(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.Starts_With, formatedSearchText, True, False)
                        search.iOR(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.Contains, AutoTypeAheadWordSeparators & formatedSearchText, True, False)
                
                        search.iOR(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.Starts_With, formatedSearchText, True, False)
                        search.iOR(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.Contains, AutoTypeAheadWordSeparators & formatedSearchText, True, False)
                
                    Else
                        
                        search.iOR(View_MaxPersonalEducationView.Course, BaseFilter.ComparisonOperator.Contains, formatedSearchText, True, False)
                        search.iOR(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.Contains, formatedSearchText, True, False)
                        search.iOR(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.Contains, formatedSearchText, True, False)
                    End If
                    wc.iAND(search)
                  
                End If
            End If
                  
      
            Return wc
        End Function
          
        Public Overridable Function GetAutoCompletionList_View_MaxPersonalEducationSearch1(ByVal prefixText As String, ByVal count As Integer) As String()
            Dim resultList As ArrayList = New ArrayList
            Dim wordList As ArrayList = New ArrayList
            Dim iteration As Integer = 0
            
            Dim filterJoin As CompoundFilter = CreateCompoundJoinFilter()
            Dim wc As WhereClause = CreateWhereClause(prefixText,"View_MaxPersonalEducationSearch1", "WordsStartingWithSearchString", "[^a-zA-Z0-9]")
            While (resultList.Count < count AndAlso iteration < 5)
                ' Fetch 100 records in each iteration
                Dim recordList () As Persons.Business.View_MaxPersonalEducationRecord = View_MaxPersonalEducationView.GetRecords(filterJoin, wc, Nothing, iteration, 100)
                Dim rec As View_MaxPersonalEducationRecord = Nothing
                Dim resultItem As String = ""
                For Each rec In recordList 
                    ' Exit the loop if recordList count has reached AutoTypeAheadListSize.
                    If resultList.Count >= count then
                        Exit For
                    End If
                    ' If the field is configured to Display as Foreign key, Format() method returns the 
                    ' Display as Forien Key value instead of original field value.
                    ' Since search had to be done in multiple fields (selected in Control's page property, binding tab) in a record,
                    ' We need to find relevent field to display which matches the prefixText and is not already present in the result list.
                
                    resultItem = rec.Format(View_MaxPersonalEducationView.Course)
                    If resultItem IsNot Nothing AndAlso resultItem.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture).Contains(prefixText.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture))  Then
      
                        Dim isAdded As Boolean = FormatSuggestions(prefixText, resultItem, 50, "AtBeginningOfMatchedString", "WordsStartingWithSearchString", "[^a-zA-Z0-9]", resultList)
                        If isAdded Then
                            Continue For
                        End If
                    End If
      
                    resultItem = rec.Format(View_MaxPersonalEducationView.CourseAbbr)
                    If resultItem IsNot Nothing AndAlso resultItem.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture).Contains(prefixText.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture))  Then
      
                        Dim isAdded As Boolean = FormatSuggestions(prefixText, resultItem, 50, "AtBeginningOfMatchedString", "WordsStartingWithSearchString", "[^a-zA-Z0-9]", resultList)
                        If isAdded Then
                            Continue For
                        End If
                    End If
      
                    resultItem = rec.Format(View_MaxPersonalEducationView.Facultry)
                    If resultItem IsNot Nothing AndAlso resultItem.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture).Contains(prefixText.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture))  Then
      
                        Dim isAdded As Boolean = FormatSuggestions(prefixText, resultItem, 50, "AtBeginningOfMatchedString", "WordsStartingWithSearchString", "[^a-zA-Z0-9]", resultList)
                        If isAdded Then
                            Continue For
                        End If
                    End If
      
                Next
                ' Exit the loop if number of records found is less as further iteration will not return any more records
                If recordList .Length < 100 Then
                    Exit While
                End If
                iteration += 1
            End While
             
            resultList.Sort()
            Dim result() As String = New String(resultList.Count - 1) {}
            Array.Copy(resultList.ToArray, result, resultList.Count)
            Return result
        End Function
          
          
        Public Overridable Function FormatSuggestions(ByVal prefixText As String, ByVal resultItem As String, _
                                                 ByVal columnLength As Integer, ByVal AutoTypeAheadDisplayFoundText As String, _
                                                 ByVal autoTypeAheadSearch As String, ByVal AutoTypeAheadWordSeparators As String, _
                                                 ByVal resultList As ArrayList) As Boolean
                                                 
            'Formats the resultItem and adds it to the list of suggestions.
            Dim index As Integer = resultItem.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture).IndexOf(prefixText.ToUpper(System.Threading.Thread.CurrentThread.CurrentCulture))
            Dim itemToAdd As String = ""
            Dim isFound As Boolean = False
            Dim isAdded As Boolean = False
            ' Get the index where prfixt is at the beginning of resultItem. If not found then, index of word which begins with prefixText.
            If InvariantLCase(autoTypeAheadSearch).equals("wordsstartingwithsearchstring") And Not index = 0 Then
                ' Expression to find word which contains AutoTypeAheadWordSeparators followed by prefixText
                Dim regex1 As System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex( AutoTypeAheadWordSeparators + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                If regex1.IsMatch(resultItem) Then
                    index = regex1.Match(resultItem).Index
                    isFound = True
                End If
                ' If the prefixText is found immediatly after white space then starting of the word is found so don not search any further
                If not resultItem(index).ToString() = " " Then
                    ' Expression to find beginning of the word which contains AutoTypeAheadWordSeparators followed by prefixText
                    Dim regex As System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex("\\S*" + AutoTypeAheadWordSeparators + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                    If regex.IsMatch(resultItem) Then
                        index = regex.Match(resultItem).Index
                        isFound = True
                    End If
                 End If
            End If
            
            ' If autoTypeAheadSearch value is wordsstartingwithsearchstring then, extract the substring only if the prefixText is found at the 
            ' beginning of the resultItem (index = 0) or a word in resultItem is found starts with prefixText. 
            If index = 0 Or isFound Or InvariantLCase(autoTypeAheadSearch).Equals("anywhereinstring") then
                If InvariantLCase(AutoTypeAheadDisplayFoundText).equals("atbeginningofmatchedstring") Then
                    ' Expression to find beginning of the word which contains prefixText
                    Dim regex1 As System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex("\\S*" + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                    '  Find the beginning of the word which contains prefexText
                    If (StringUtils.InvariantLCase(autoTypeAheadSearch).Equals("anywhereinstring") AndAlso regex1.IsMatch(resultItem)) Then
                        index = regex1.Match(resultItem).Index
                        isFound = True
                    End If
                    ' Display string from the index till end of the string if sub string from index till end is less than columnLength value.
                    If Len(resultItem) - index <= columnLength Then
                        If index = 0 Then 
                            itemToAdd = resultItem 
                        Else
                            itemToAdd = "..." & resultItem.Substring(index, Len(resultItem) - index) 
                        End If
                    Else
                        If index = 0 Then
                            itemToAdd = resultItem.Substring(index, (columnLength - 3)) & "..."
                        Else
                            'Truncate the string to show only columnLength - 6 characters as begining and trailing "..." has to be appended.
                            itemToAdd = "..." & resultItem.Substring(index , columnLength - 6) & "..." 
                        End If
                    End If
                ElseIf InvariantLCase(AutoTypeAheadDisplayFoundText).equals("inmiddleofmatchedstring") Then
                    Dim subStringBeginIndex As Integer = CType(columnLength/2, Integer)
                    If Len(resultItem) <= columnLength Then
                        itemToAdd = resultItem
                    Else
                        ' Sanity check at end of the string
                        If index + Len(prefixText) = columnLength Then
                            itemToAdd =  "..." & resultItem.Substring(index-columnLength,index)
                        ElseIf Len(resultItem) - index < subStringBeginIndex Then 
                            ' Display string from the end till columnLength value if, index is closer to the end of the string.
                            itemToAdd =  "..." & resultItem.Substring(Len(resultItem)-columnLength,Len(resultItem))
                        ElseIf index <= subStringBeginIndex Then 
                            ' Sanity chet at beginning of the string
                            itemToAdd =  resultItem.Substring(0, columnLength) & "..."
                        Else
                            ' Display string containing text before the prefixText occures and text after the prefixText
                            itemToAdd =  "..." & resultItem.Substring(index - subStringBeginIndex, columnLength) & "..." 
                        End If
                    End If
                ElseIf InvariantLCase(AutoTypeAheadDisplayFoundText).equals("atendofmatchedstring") Then
                     ' Expression to find ending of the word which contains prefexText
                    Dim regex1 As System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex("\s", System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                    ' Find the ending of the word which contains prefexText
                    If regex1.IsMatch(resultItem, index + 1) Then
                        index = regex1.Match(resultItem, index + 1).Index
                    Else
                        ' If the word which contains prefexText is the last word in string, regex1.IsMatch returns false.
                        index = resultItem.Length
                    End If
                    If index > Len(resultItem) Then
                        index = Len(resultItem)
                    End If
                    ' If text from beginning of the string till index is less than columnLength value then, display string from the beginning till index.
                    If  index <= columnLength Then
                        if index = Len(resultItem) Then   'Make decision to append "..."
                            itemToAdd = resultItem.Substring(0,index)
                        Else
                            itemToAdd = resultItem.Substring(0,index) & "..."
                        End If
                    Else
                        If index = Len(resultItem) Then
                            itemToAdd = "..." & resultItem.Substring(index - (columnLength - 3), (columnLength - 3))
                        Else
                            'Truncate the string to show only columnLength - 6 characters as begining and trailing "..." has to be appended.
                            itemToAdd = "..." & resultItem.Substring(index - (columnLength - 6), columnLength - 6) & "..." 
                        End If
                    End If
                End If
                
                ' Remove newline character from itemToAdd
                Dim prefixTextIndex As Integer = itemToAdd.IndexOf(prefixText, StringComparison.CurrentCultureIgnoreCase)
                ' If itemToAdd contains any newline after the search text then show text only till newline
                Dim regex2 As System.Text.RegularExpressions.Regex = New System.Text.RegularExpressions.Regex("(" & vbCrLf & "|" & vbLf & ")", System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                Dim newLineIndexAfterPrefix As Integer = -1
                If regex2.IsMatch(itemToAdd, prefixTextIndex) Then
                    newLineIndexAfterPrefix = regex2.Match(itemToAdd, prefixTextIndex).Index
                End If
                If (newLineIndexAfterPrefix > -1) Then
                    If itemToAdd.EndsWith("...") Then
                        itemToAdd = (itemToAdd.Substring(0, newLineIndexAfterPrefix) + "...")
                    Else
                        itemToAdd = itemToAdd.Substring(0, newLineIndexAfterPrefix)
                    End If
                End If
                ' If itemToAdd contains any newline before search text then show text which comes after newline
                Dim regex3 As System.Text.RegularExpressions.Regex = New System.Text.RegularExpressions.Regex("(" & vbCrLf & "|" & vbLf & ")", (System.Text.RegularExpressions.RegexOptions.IgnoreCase Or System.Text.RegularExpressions.RegexOptions.RightToLeft))
                Dim newLineIndexBeforePrefix As Integer = -1
                If regex3.IsMatch(itemToAdd, prefixTextIndex) Then
                    newLineIndexBeforePrefix = regex3.Match(itemToAdd, prefixTextIndex).Index
                End If
                If (newLineIndexBeforePrefix > -1) Then
                    If itemToAdd.StartsWith("...") Then
                        itemToAdd = ("..." + itemToAdd.Substring((newLineIndexBeforePrefix + regex3.Match(itemToAdd, prefixTextIndex).Length)))
                    Else
                        itemToAdd = itemToAdd.Substring((newLineIndexBeforePrefix + regex3.Match(itemToAdd, prefixTextIndex).Length))
                    End If
                End If

                If Not itemToAdd is nothing AndAlso Not resultList.Contains(itemToAdd) Then
                    
                    resultList.Add(itemToAdd)
          				
                    isAdded = true
                End If
            End If
            Return isAdded
        End Function
        
    
        Protected Overridable Sub GetPageSize()
        
            If Me.View_MaxPersonalEducationPagination.PageSize.Text.Trim <> "" Then
                Try
                    'Me.PageSize = Integer.Parse(Me.View_MaxPersonalEducationPagination.PageSize.Text)
                Catch ex As Exception
                End Try
            End If
        End Sub

        Protected Overridable Sub AddNewRecords()
            
            Dim newRecordList As ArrayList = New ArrayList()
          
    Dim newUIDataList As System.Collections.Generic.List(Of Hashtable) = New System.Collections.Generic.List(Of Hashtable)()

    ' Loop though all the record controls and if the record control
    ' does not have a unique record id set, then create a record
    ' and add to the list.
    If Not Me.ResetData Then
    Dim rep As System.Web.UI.WebControls.Repeater = CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationTableControlRepeater"), System.Web.UI.WebControls.Repeater)
    If rep Is Nothing Then Return

    Dim repItem As System.Web.UI.WebControls.RepeaterItem
    For Each repItem In rep.Items
    ' Loop through all rows in the table, set its DataSource and call DataBind().
    
    Dim recControl As View_MaxPersonalEducationTableControlRow = DirectCast(repItem.FindControl("View_MaxPersonalEducationTableControlRow"), View_MaxPersonalEducationTableControlRow)

                    If recControl.Visible AndAlso recControl.IsNewRecord() Then
                    
                        Dim rec As View_MaxPersonalEducationRecord = New View_MaxPersonalEducationRecord()
        
                        If recControl.Country.Text <> "" Then
                            rec.Parse(recControl.Country.Text, View_MaxPersonalEducationView.Country)
                        End If
                        If recControl.Course.Text <> "" Then
                            rec.Parse(recControl.Course.Text, View_MaxPersonalEducationView.Course)
                        End If
                        If recControl.CourseAbbr.Text <> "" Then
                            rec.Parse(recControl.CourseAbbr.Text, View_MaxPersonalEducationView.CourseAbbr)
                        End If
                        If recControl.EdYear.Text <> "" Then
                            rec.Parse(recControl.EdYear.Text, View_MaxPersonalEducationView.EdYear)
                        End If
                        If recControl.Facultry.Text <> "" Then
                            rec.Parse(recControl.Facultry.Text, View_MaxPersonalEducationView.Facultry)
                        End If
                        If recControl.Institue.Text <> "" Then
                            rec.Parse(recControl.Institue.Text, View_MaxPersonalEducationView.Institue)
                        End If
                        If recControl.Level.Text <> "" Then
                            rec.Parse(recControl.Level.Text, View_MaxPersonalEducationView.Level)
                        End If
                        If recControl.RankAndName.Text <> "" Then
                            rec.Parse(recControl.RankAndName.Text, View_MaxPersonalEducationView.RankAndName)
                        End If
                        If recControl.SectionAbbvrName.Text <> "" Then
                            rec.Parse(recControl.SectionAbbvrName.Text, View_MaxPersonalEducationView.SectionAbbvrName)
                        End If
                        newUIDataList.Add(recControl.PreservedUIData())	  
                        newRecordList.Add(rec)
                    End If
                Next
            End If
            
    
            ' Add any new record to the list.
            Dim index As Integer = 0
            For index = 1 To Me.AddNewRecord
            
                newRecordList.Insert(0, New View_MaxPersonalEducationRecord())
                newUIDataList.Insert(0, New Hashtable())				
              
            Next
            Me.AddNewRecord = 0

            ' Finally, add any new records to the DataSource.
            If newRecordList.Count > 0 Then
            
                Dim finalList As ArrayList = New ArrayList(Me.DataSource)
                finalList.InsertRange(0, newRecordList)

                Me.DataSource = DirectCast(finalList.ToArray(GetType(View_MaxPersonalEducationRecord)), View_MaxPersonalEducationRecord())
              
            End If
            
            ' Add the existing UI data to this hash table
            If newUIDataList.Count > 0 Then
                Me.UIData.InsertRange(0, newUIDataList)
            End If
            
        End Sub

        
        Public Sub AddToDeletedRecordIds(ByVal rec As View_MaxPersonalEducationTableControlRow)
            If rec.IsNewRecord() Then
                Return
            End If

            If Not Me.DeletedRecordIds Is Nothing AndAlso Me.DeletedRecordIds.Trim <> "" Then
                Me.DeletedRecordIds &= ","
            End If

            Me.DeletedRecordIds &= "[" & rec.RecordUniqueId & "]"
        End Sub

        Protected Overridable Function InDeletedRecordIds(ByVal rec As View_MaxPersonalEducationTableControlRow) As Boolean
            If Me.DeletedRecordIds Is Nothing OrElse Me.DeletedRecordIds.Trim = "" Then
                Return False
            End If

            Return Me.DeletedRecordIds.IndexOf("[" & rec.RecordUniqueId & "]") >= 0
        End Function

        Private _DeletedRecordIds As String
        Public Property DeletedRecordIds() As String
            Get
                Return Me._DeletedRecordIds
            End Get
            Set(ByVal value As String)
                Me._DeletedRecordIds = value
            End Set
        End Property
        
      
        ' Create Set, WhereClause, and Populate Methods
        
        Public Overridable Sub SetCountryLabel()
                  
                  End Sub
                
        Public Overridable Sub SetCourseAbbrLabel()
                  
                  End Sub
                
        Public Overridable Sub SetCourseAbbrLabel1()
                  
                  End Sub
                
        Public Overridable Sub SetCourseLabel()
                  
                  End Sub
                
        Public Overridable Sub SetEdYearLabel()
                  
                  End Sub
                
        Public Overridable Sub SetFacultryLabel()
                  
                  End Sub
                
        Public Overridable Sub SetFacultryLabel1()
                  
                  End Sub
                
        Public Overridable Sub SetInstitueLabel()
                  
                  End Sub
                
        Public Overridable Sub SetLevelLabel()
                  
                  End Sub
                
        Public Overridable Sub SetLevelLabel1()
                  
                  End Sub
                
        Public Overridable Sub SetPersonalNameLabel()
                  
                  End Sub
                
        Public Overridable Sub SetRankLevelLabel()
                  
                  End Sub
                
        Public Overridable Sub SetSectionAbbvrNameLabel()
                  
                  End Sub
                
        Public Overridable Sub SetSectionAbbvrNameLabel1()
                  
                  End Sub
                
        Public Overridable Sub SetView_MaxPersonalEducationTableControlCollapsibleRegion()
                  
                  End Sub
                
        Public Overridable Sub SetView_MaxPersonalEducationTableControlIcon()
                  
                  End Sub
                
        Public Overridable Sub SetView_MaxPersonalEducationTableControlPanelExtender()
                  
                  End Sub
                
        Public Overridable Sub SetCourseAbbrFilter()
            
                Me.PopulateCourseAbbrFilter(GetSelectedValue(Me.CourseAbbrFilter,  GetFromSession(Me.CourseAbbrFilter)), 500)					
                    
        End Sub	
            
        Public Overridable Sub SetFacultryFilter()
            
                Me.PopulateFacultryFilter(GetSelectedValue(Me.FacultryFilter,  GetFromSession(Me.FacultryFilter)), 500)					
                    
        End Sub	
            
        Public Overridable Sub SetLevelFilter()
            
                Me.PopulateLevelFilter(GetSelectedValue(Me.LevelFilter,  GetFromSession(Me.LevelFilter)), 500)					
                    
        End Sub	
            
        Public Overridable Sub SetRankLevelFromFilter()
            
                Me.PopulateRankLevelFromFilter(GetSelectedValue(Me.RankLevelFromFilter,  GetFromSession(Me.RankLevelFromFilter)), 500)					
                    
        End Sub	
            
        Public Overridable Sub SetSectionAbbvrNameFilter()
            
                Me.PopulateSectionAbbvrNameFilter(GetSelectedValue(Me.SectionAbbvrNameFilter,  GetFromSession(Me.SectionAbbvrNameFilter)), 500)					
                    
        End Sub	
            
        Public Overridable Sub SetView_MaxPersonalEducationSearch1()
            
        End Sub	
            
        ' Get the filters' data for CourseAbbrFilter
        Protected Overridable Sub PopulateCourseAbbrFilter(ByVal selectedValue As String, ByVal maxItems As Integer)
                    
                
            Me.CourseAbbrFilter.Items.Clear()
            
                    
            		  			
            ' Set up the WHERE and the ORDER BY clause by calling the CreateWhereClause_CourseAbbrFilter function.
            ' It is better to customize the where clause there.
                
            ' Setup the WHERE clause, including the base table if needed.
                
            Dim wc As WhereClause = Me.CreateWhereClause_CourseAbbrFilter()
                  
            ' Setup the static list items        
            
            ' Add the All item.
            Me.CourseAbbrFilter.Items.Insert(0, new ListItem(Me.Page.GetResourceValue("Txt:All", "Persons"), "--ANY--"))
                            
            
            
            Dim orderBy As OrderBy = New OrderBy(False, False)
            orderBy.Add(View_MaxPersonalEducationView.CourseAbbr, OrderByItem.OrderDir.Asc)                
            
            
            Dim joinFilter As CompoundFilter = CreateCompoundJoinFilter()
            Dim values() As String = View_MaxPersonalEducationView.GetValues(View_MaxPersonalEducationView.CourseAbbr, joinFilter, wc, orderBy, maxItems)
            
            Dim cvalue As String
            
            Dim listDuplicates As New ArrayList()
            For Each cvalue In values
                ' Create the item and add to the list.
                Dim fvalue As String
          
                If ( View_MaxPersonalEducationView.CourseAbbr.IsColumnValueTypeBoolean()) Then
                    fvalue = cvalue
                Else
                    fvalue = View_MaxPersonalEducationView.CourseAbbr.Format(cvalue)
                End If

                If (IsNothing(fvalue)) Then
                    fvalue = ""
                End If

                fvalue = fvalue.Trim()

                If ( fvalue.Length > 50 ) Then
                    fvalue = fvalue.Substring(0, 50) & "..."
                End If

                Dim dupItem As ListItem = Me.CourseAbbrFilter.Items.FindByText(fvalue)
								
                If Not IsNothing(dupItem) Then
                    listDuplicates.Add(fvalue)
                    dupItem.Text = fvalue & " (ID " & dupItem.Value.Substring(0, Math.Min(dupItem.Value.Length,38)) & ")"
                End If

                Dim newItem As ListItem = New ListItem(fvalue, cvalue)
                Me.CourseAbbrFilter.Items.Add(newItem)

                If listDuplicates.Contains(fvalue) Then
                    newItem.Text = fvalue & " (ID " & cvalue.Substring(0, Math.Min(cvalue.Length,38)) & ")"
                End If
          
            Next
                    

                
            ' Set the selected value.
            SetSelectedValue(Me.CourseAbbrFilter, selectedValue)

                
        End Sub
            
        ' Get the filters' data for FacultryFilter
        Protected Overridable Sub PopulateFacultryFilter(ByVal selectedValue As String, ByVal maxItems As Integer)
                    
                
            Me.FacultryFilter.Items.Clear()
            
                    
            		  			
            ' Set up the WHERE and the ORDER BY clause by calling the CreateWhereClause_FacultryFilter function.
            ' It is better to customize the where clause there.
                
            ' Setup the WHERE clause, including the base table if needed.
                
            Dim wc As WhereClause = Me.CreateWhereClause_FacultryFilter()
                  
            ' Setup the static list items        
            
            ' Add the All item.
            Me.FacultryFilter.Items.Insert(0, new ListItem(Me.Page.GetResourceValue("Txt:All", "Persons"), "--ANY--"))
                            
            
            
            Dim orderBy As OrderBy = New OrderBy(False, False)
            orderBy.Add(View_MaxPersonalEducationView.Facultry, OrderByItem.OrderDir.Asc)                
            
            
            Dim joinFilter As CompoundFilter = CreateCompoundJoinFilter()
            Dim values() As String = View_MaxPersonalEducationView.GetValues(View_MaxPersonalEducationView.Facultry, joinFilter, wc, orderBy, maxItems)
            
            Dim cvalue As String
            
            Dim listDuplicates As New ArrayList()
            For Each cvalue In values
                ' Create the item and add to the list.
                Dim fvalue As String
          
                If ( View_MaxPersonalEducationView.Facultry.IsColumnValueTypeBoolean()) Then
                    fvalue = cvalue
                Else
                    fvalue = View_MaxPersonalEducationView.Facultry.Format(cvalue)
                End If

                If (IsNothing(fvalue)) Then
                    fvalue = ""
                End If

                fvalue = fvalue.Trim()

                If ( fvalue.Length > 50 ) Then
                    fvalue = fvalue.Substring(0, 50) & "..."
                End If

                Dim dupItem As ListItem = Me.FacultryFilter.Items.FindByText(fvalue)
								
                If Not IsNothing(dupItem) Then
                    listDuplicates.Add(fvalue)
                    dupItem.Text = fvalue & " (ID " & dupItem.Value.Substring(0, Math.Min(dupItem.Value.Length,38)) & ")"
                End If

                Dim newItem As ListItem = New ListItem(fvalue, cvalue)
                Me.FacultryFilter.Items.Add(newItem)

                If listDuplicates.Contains(fvalue) Then
                    newItem.Text = fvalue & " (ID " & cvalue.Substring(0, Math.Min(cvalue.Length,38)) & ")"
                End If
          
            Next
                    

                
            ' Set the selected value.
            SetSelectedValue(Me.FacultryFilter, selectedValue)

                
        End Sub
            
        ' Get the filters' data for LevelFilter
        Protected Overridable Sub PopulateLevelFilter(ByVal selectedValue As String, ByVal maxItems As Integer)
                    
                
            Me.LevelFilter.Items.Clear()
            
                    
            		  			
            ' Set up the WHERE and the ORDER BY clause by calling the CreateWhereClause_LevelFilter function.
            ' It is better to customize the where clause there.
                
            ' Setup the WHERE clause, including the base table if needed.
                
            Dim wc As WhereClause = Me.CreateWhereClause_LevelFilter()
                  
            ' Setup the static list items        
            
            ' Add the All item.
            Me.LevelFilter.Items.Insert(0, new ListItem(Me.Page.GetResourceValue("Txt:All", "Persons"), "--ANY--"))
                            
            
            
            Dim orderBy As OrderBy = New OrderBy(False, False)
            orderBy.Add(View_MaxPersonalEducationView.Level, OrderByItem.OrderDir.Asc)                
            
            
            Dim joinFilter As CompoundFilter = CreateCompoundJoinFilter()
            Dim values() As String = View_MaxPersonalEducationView.GetValues(View_MaxPersonalEducationView.Level, joinFilter, wc, orderBy, maxItems)
            
            Dim cvalue As String
            
            Dim listDuplicates As New ArrayList()
            For Each cvalue In values
                ' Create the item and add to the list.
                Dim fvalue As String
          
                If ( View_MaxPersonalEducationView.Level.IsColumnValueTypeBoolean()) Then
                    fvalue = cvalue
                Else
                    fvalue = View_MaxPersonalEducationView.Level.Format(cvalue)
                End If

                If (IsNothing(fvalue)) Then
                    fvalue = ""
                End If

                fvalue = fvalue.Trim()

                If ( fvalue.Length > 50 ) Then
                    fvalue = fvalue.Substring(0, 50) & "..."
                End If

                Dim dupItem As ListItem = Me.LevelFilter.Items.FindByText(fvalue)
								
                If Not IsNothing(dupItem) Then
                    listDuplicates.Add(fvalue)
                    dupItem.Text = fvalue & " (ID " & dupItem.Value.Substring(0, Math.Min(dupItem.Value.Length,38)) & ")"
                End If

                Dim newItem As ListItem = New ListItem(fvalue, cvalue)
                Me.LevelFilter.Items.Add(newItem)

                If listDuplicates.Contains(fvalue) Then
                    newItem.Text = fvalue & " (ID " & cvalue.Substring(0, Math.Min(cvalue.Length,38)) & ")"
                End If
          
            Next
                    

                
            ' Set the selected value.
            SetSelectedValue(Me.LevelFilter, selectedValue)

                
        End Sub
            
        ' Get the filters' data for RankLevelFromFilter
        Protected Overridable Sub PopulateRankLevelFromFilter(ByVal selectedValue As String, ByVal maxItems As Integer)
                    
                
            Me.RankLevelFromFilter.Items.Clear()
            
                    
            		  			
            ' Set up the WHERE and the ORDER BY clause by calling the CreateWhereClause_RankLevelFromFilter function.
            ' It is better to customize the where clause there.
                
            ' Setup the WHERE clause, including the base table if needed.
                
            Dim wc As WhereClause = Me.CreateWhereClause_RankLevelFromFilter()
                  
            ' Setup the static list items        
            
            ' Add the All item.
            Me.RankLevelFromFilter.Items.Insert(0, new ListItem(Me.Page.GetResourceValue("Txt:All", "Persons"), "--ANY--"))
                            
            
            
            Dim orderBy As OrderBy = New OrderBy(False, False)
            orderBy.Add(View_MaxPersonalEducationView.RankLevel, OrderByItem.OrderDir.Asc)                
            
            
            Dim joinFilter As CompoundFilter = CreateCompoundJoinFilter()
            Dim values() As String = View_MaxPersonalEducationView.GetValues(View_MaxPersonalEducationView.RankLevel, joinFilter, wc, orderBy, maxItems)
            
            Me.Page.PregetDfkaRecords(View_MaxPersonalEducationView.RankLevel, values)
            Dim cvalue As String
            
            Dim itemsList As New System.Web.UI.WebControls.ListItemCollection
            Dim listDuplicates As New ArrayList()
            For Each cvalue In values
                 ' Create the item and add to the list.

                  Dim fvalue As String = ""
                  Dim _isExpandableNonCompositeForeignKey As Boolean = View_MaxPersonalEducationView.Instance.TableDefinition.IsExpandableNonCompositeForeignKey(View_MaxPersonalEducationView.RankLevel)
                  If _isExpandableNonCompositeForeignKey AndAlso View_MaxPersonalEducationView.RankLevel.IsApplyDisplayAs Then
                    fvalue = View_MaxPersonalEducationView.GetDFKA(cvalue,View_MaxPersonalEducationView.RankLevel,Nothing)
                  End If
                  If (Not _isExpandableNonCompositeForeignKey) Or (String.IsNullOrEmpty(fvalue)) Then
                    fvalue = View_MaxPersonalEducationView.RankLevel.Format(cvalue)
                  End If
                  If cvalue IsNot Nothing or fvalue IsNot Nothing
                    ' store the list item in a collection and sort later
                     If (IsNothing(fvalue)) Then
                         fvalue = ""
                     End If

                     fvalue = fvalue.Trim()

                     If ( fvalue.Length > 50 ) Then
                        fvalue = fvalue.Substring(0, 50) & "..."
                     End If

                     Dim dupItem As ListItem = Me.RankLevelFromFilter.Items.FindByText(fvalue)
								
                     If Not IsNothing(dupItem) Then
                        listDuplicates.Add(fvalue)
                        dupItem.Text = fvalue & " (ID " & dupItem.Value.Substring(0, Math.Min(dupItem.Value.Length,38)) & ")"
                     End If

                     Dim newItem As ListItem = New ListItem(fvalue, cvalue)
                     RankLevelFromFilter.Items.Add(newItem)

                     If listDuplicates.Contains(fvalue) Then
                        newItem.Text = fvalue & " (ID " & cvalue.Substring(0, Math.Min(cvalue.Length,38)) & ")"
                     End If
                  End If
            Next
            
            ' sort the collection and then add to the filter control
            RankLevelFromFilter.Items.AddRange(GetSortListItem(itemsList))

    

                
            ' Set the selected value.
            SetSelectedValue(Me.RankLevelFromFilter, selectedValue)

                
        End Sub
            
        ' Get the filters' data for SectionAbbvrNameFilter
        Protected Overridable Sub PopulateSectionAbbvrNameFilter(ByVal selectedValue As String, ByVal maxItems As Integer)
                    
                
            Me.SectionAbbvrNameFilter.Items.Clear()
            
                    
            		  			
            ' Set up the WHERE and the ORDER BY clause by calling the CreateWhereClause_SectionAbbvrNameFilter function.
            ' It is better to customize the where clause there.
                
            ' Setup the WHERE clause, including the base table if needed.
                
            Dim wc As WhereClause = Me.CreateWhereClause_SectionAbbvrNameFilter()
                  
            ' Setup the static list items        
            
            ' Add the All item.
            Me.SectionAbbvrNameFilter.Items.Insert(0, new ListItem(Me.Page.GetResourceValue("Txt:All", "Persons"), "--ANY--"))
                            
            
            
            Dim orderBy As OrderBy = New OrderBy(False, False)
            orderBy.Add(View_MaxPersonalEducationView.SectionAbbvrName, OrderByItem.OrderDir.Asc)                
            
            
            Dim values() As String = View_MaxPersonalEducationView.GetValues(View_MaxPersonalEducationView.SectionAbbvrName, wc, orderBy, maxItems)
            
            Dim cvalue As String
            
            Dim listDuplicates As New ArrayList()
            For Each cvalue In values
                ' Create the item and add to the list.
                Dim fvalue As String
          
                If ( View_MaxPersonalEducationView.SectionAbbvrName.IsColumnValueTypeBoolean()) Then
                    fvalue = cvalue
                Else
                    fvalue = View_MaxPersonalEducationView.SectionAbbvrName.Format(cvalue)
                End If

                If (IsNothing(fvalue)) Then
                    fvalue = ""
                End If

                fvalue = fvalue.Trim()

                If ( fvalue.Length > 50 ) Then
                    fvalue = fvalue.Substring(0, 50) & "..."
                End If

                Dim dupItem As ListItem = Me.SectionAbbvrNameFilter.Items.FindByText(fvalue)
								
                If Not IsNothing(dupItem) Then
                    listDuplicates.Add(fvalue)
                    dupItem.Text = fvalue & " (ID " & dupItem.Value.Substring(0, Math.Min(dupItem.Value.Length,38)) & ")"
                End If

                Dim newItem As ListItem = New ListItem(fvalue, cvalue)
                Me.SectionAbbvrNameFilter.Items.Add(newItem)

                If listDuplicates.Contains(fvalue) Then
                    newItem.Text = fvalue & " (ID " & cvalue.Substring(0, Math.Min(cvalue.Length,38)) & ")"
                End If
          
            Next
                    

                
            ' Set the selected value.
            SetSelectedValue(Me.SectionAbbvrNameFilter, selectedValue)

                
        End Sub
            
        Public Overridable Function CreateWhereClause_CourseAbbrFilter() As WhereClause
          
            ' Create a where clause for the filter CourseAbbrFilter.
            ' This function is called by the Populate method to load the items 
            ' in the CourseAbbrFilterDropDownList
            
            Dim wc As WhereClause = New WhereClause()
                  
            If IsValueSelected(Me.FacultryFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.FacultryFilter, Me.GetFromSession(Me.FacultryFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.LevelFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.Level, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.LevelFilter, Me.GetFromSession(Me.LevelFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.RankLevelFromFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.RankLevel, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.RankLevelFromFilter, Me.GetFromSession(Me.RankLevelFromFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.SectionAbbvrNameFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.SectionAbbvrName, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.SectionAbbvrNameFilter, Me.GetFromSession(Me.SectionAbbvrNameFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.View_MaxPersonalEducationSearch1) Then
              If Me.View_MaxPersonalEducationSearch1.Text = BaseClasses.Resources.AppResources.GetResourceValue("Txt:SearchForEllipsis", Nothing) Then
                 Me.View_MaxPersonalEducationSearch1.Text = ""
              Else
              ' Strip "..." from begin and ending of the search text, otherwise the search will return 0 values as in database "..." is not stored.
              
                    If Me.View_MaxPersonalEducationSearch1.Text.StartsWith("...") Then
                        Me.View_MaxPersonalEducationSearch1.Text = Me.View_MaxPersonalEducationSearch1.Text.SubString(3,Me.View_MaxPersonalEducationSearch1.Text.Length-3)
                    End If
                    If Me.View_MaxPersonalEducationSearch1.Text.EndsWith("...") then
                        Me.View_MaxPersonalEducationSearch1.Text = Me.View_MaxPersonalEducationSearch1.Text.SubString(0,Me.View_MaxPersonalEducationSearch1.Text.Length-3)
                        ' Strip the last word as well as it is likely only a partial word
                        Dim endindex As Integer = View_MaxPersonalEducationSearch1.Text.Length - 1
                        While (Not Char.IsWhiteSpace(View_MaxPersonalEducationSearch1.Text(endindex)) AndAlso endindex > 0)
                            endindex -= 1
                        End While
                        If endindex > 0 Then
                            View_MaxPersonalEducationSearch1.Text = View_MaxPersonalEducationSearch1.Text.Substring(0, endindex)
                        End If
              End If
            End If
            
              Dim formatedSearchText As String = MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1))
                
                ' After stripping "..." see if the search text is null or empty.
                If IsValueSelected(Me.View_MaxPersonalEducationSearch1) Then 
        ' These clauses are added depending on operator and fields selected in Control's property page, bindings tab.
                    
                    Dim search As WhereClause = New WhereClause()
                    
                    search.iOR(View_MaxPersonalEducationView.Course, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    search.iOR(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    search.iOR(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    wc.iAND(search)
                  
                End If
            End If
                  
            Dim wc1 As WhereClause = Me.CreateWhereClause
            If wc1.Count > 0 Then
                wc.AddFilter(wc1.GetFilter(), CompoundFilter.CompoundingOperators.And_Operator)
            End If
          
            Return wc
        End Function			
            
        Public Overridable Function CreateWhereClause_FacultryFilter() As WhereClause
          
            ' Create a where clause for the filter FacultryFilter.
            ' This function is called by the Populate method to load the items 
            ' in the FacultryFilterDropDownList
            
            Dim wc As WhereClause = New WhereClause()
                  
            If IsValueSelected(Me.CourseAbbrFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.CourseAbbrFilter, Me.GetFromSession(Me.CourseAbbrFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.LevelFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.Level, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.LevelFilter, Me.GetFromSession(Me.LevelFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.RankLevelFromFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.RankLevel, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.RankLevelFromFilter, Me.GetFromSession(Me.RankLevelFromFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.SectionAbbvrNameFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.SectionAbbvrName, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.SectionAbbvrNameFilter, Me.GetFromSession(Me.SectionAbbvrNameFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.View_MaxPersonalEducationSearch1) Then
              If Me.View_MaxPersonalEducationSearch1.Text = BaseClasses.Resources.AppResources.GetResourceValue("Txt:SearchForEllipsis", Nothing) Then
                 Me.View_MaxPersonalEducationSearch1.Text = ""
              Else
              ' Strip "..." from begin and ending of the search text, otherwise the search will return 0 values as in database "..." is not stored.
              
                    If Me.View_MaxPersonalEducationSearch1.Text.StartsWith("...") Then
                        Me.View_MaxPersonalEducationSearch1.Text = Me.View_MaxPersonalEducationSearch1.Text.SubString(3,Me.View_MaxPersonalEducationSearch1.Text.Length-3)
                    End If
                    If Me.View_MaxPersonalEducationSearch1.Text.EndsWith("...") then
                        Me.View_MaxPersonalEducationSearch1.Text = Me.View_MaxPersonalEducationSearch1.Text.SubString(0,Me.View_MaxPersonalEducationSearch1.Text.Length-3)
                        ' Strip the last word as well as it is likely only a partial word
                        Dim endindex As Integer = View_MaxPersonalEducationSearch1.Text.Length - 1
                        While (Not Char.IsWhiteSpace(View_MaxPersonalEducationSearch1.Text(endindex)) AndAlso endindex > 0)
                            endindex -= 1
                        End While
                        If endindex > 0 Then
                            View_MaxPersonalEducationSearch1.Text = View_MaxPersonalEducationSearch1.Text.Substring(0, endindex)
                        End If
              End If
            End If
            
              Dim formatedSearchText As String = MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1))
                
                ' After stripping "..." see if the search text is null or empty.
                If IsValueSelected(Me.View_MaxPersonalEducationSearch1) Then 
        ' These clauses are added depending on operator and fields selected in Control's property page, bindings tab.
                    
                    Dim search As WhereClause = New WhereClause()
                    
                    search.iOR(View_MaxPersonalEducationView.Course, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    search.iOR(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    search.iOR(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    wc.iAND(search)
                  
                End If
            End If
                  
            Dim wc1 As WhereClause = Me.CreateWhereClause
            If wc1.Count > 0 Then
                wc.AddFilter(wc1.GetFilter(), CompoundFilter.CompoundingOperators.And_Operator)
            End If
          
            Return wc
        End Function			
            
        Public Overridable Function CreateWhereClause_LevelFilter() As WhereClause
          
            ' Create a where clause for the filter LevelFilter.
            ' This function is called by the Populate method to load the items 
            ' in the LevelFilterDropDownList
            
            Dim wc As WhereClause = New WhereClause()
                  
            If IsValueSelected(Me.CourseAbbrFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.CourseAbbrFilter, Me.GetFromSession(Me.CourseAbbrFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.FacultryFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.FacultryFilter, Me.GetFromSession(Me.FacultryFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.RankLevelFromFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.RankLevel, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.RankLevelFromFilter, Me.GetFromSession(Me.RankLevelFromFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.SectionAbbvrNameFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.SectionAbbvrName, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.SectionAbbvrNameFilter, Me.GetFromSession(Me.SectionAbbvrNameFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.View_MaxPersonalEducationSearch1) Then
              If Me.View_MaxPersonalEducationSearch1.Text = BaseClasses.Resources.AppResources.GetResourceValue("Txt:SearchForEllipsis", Nothing) Then
                 Me.View_MaxPersonalEducationSearch1.Text = ""
              Else
              ' Strip "..." from begin and ending of the search text, otherwise the search will return 0 values as in database "..." is not stored.
              
                    If Me.View_MaxPersonalEducationSearch1.Text.StartsWith("...") Then
                        Me.View_MaxPersonalEducationSearch1.Text = Me.View_MaxPersonalEducationSearch1.Text.SubString(3,Me.View_MaxPersonalEducationSearch1.Text.Length-3)
                    End If
                    If Me.View_MaxPersonalEducationSearch1.Text.EndsWith("...") then
                        Me.View_MaxPersonalEducationSearch1.Text = Me.View_MaxPersonalEducationSearch1.Text.SubString(0,Me.View_MaxPersonalEducationSearch1.Text.Length-3)
                        ' Strip the last word as well as it is likely only a partial word
                        Dim endindex As Integer = View_MaxPersonalEducationSearch1.Text.Length - 1
                        While (Not Char.IsWhiteSpace(View_MaxPersonalEducationSearch1.Text(endindex)) AndAlso endindex > 0)
                            endindex -= 1
                        End While
                        If endindex > 0 Then
                            View_MaxPersonalEducationSearch1.Text = View_MaxPersonalEducationSearch1.Text.Substring(0, endindex)
                        End If
              End If
            End If
            
              Dim formatedSearchText As String = MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1))
                
                ' After stripping "..." see if the search text is null or empty.
                If IsValueSelected(Me.View_MaxPersonalEducationSearch1) Then 
        ' These clauses are added depending on operator and fields selected in Control's property page, bindings tab.
                    
                    Dim search As WhereClause = New WhereClause()
                    
                    search.iOR(View_MaxPersonalEducationView.Course, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    search.iOR(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    search.iOR(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    wc.iAND(search)
                  
                End If
            End If
                  
            Dim wc1 As WhereClause = Me.CreateWhereClause
            If wc1.Count > 0 Then
                wc.AddFilter(wc1.GetFilter(), CompoundFilter.CompoundingOperators.And_Operator)
            End If
          
            Return wc
        End Function			
            
        Public Overridable Function CreateWhereClause_RankLevelFromFilter() As WhereClause
          
            ' Create a where clause for the filter RankLevelFromFilter.
            ' This function is called by the Populate method to load the items 
            ' in the RankLevelFromFilterDropDownList
            
            Dim wc As WhereClause = New WhereClause()
                  
            If IsValueSelected(Me.CourseAbbrFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.CourseAbbrFilter, Me.GetFromSession(Me.CourseAbbrFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.FacultryFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.FacultryFilter, Me.GetFromSession(Me.FacultryFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.LevelFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.Level, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.LevelFilter, Me.GetFromSession(Me.LevelFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.SectionAbbvrNameFilter) Then
    
                wc.iAND(View_MaxPersonalEducationView.SectionAbbvrName, BaseFilter.ComparisonOperator.EqualsTo, MiscUtils.GetSelectedValue(Me.SectionAbbvrNameFilter, Me.GetFromSession(Me.SectionAbbvrNameFilter)), False, False)
            
            End If
                  
                
                       
            If IsValueSelected(Me.View_MaxPersonalEducationSearch1) Then
              If Me.View_MaxPersonalEducationSearch1.Text = BaseClasses.Resources.AppResources.GetResourceValue("Txt:SearchForEllipsis", Nothing) Then
                 Me.View_MaxPersonalEducationSearch1.Text = ""
              Else
              ' Strip "..." from begin and ending of the search text, otherwise the search will return 0 values as in database "..." is not stored.
              
                    If Me.View_MaxPersonalEducationSearch1.Text.StartsWith("...") Then
                        Me.View_MaxPersonalEducationSearch1.Text = Me.View_MaxPersonalEducationSearch1.Text.SubString(3,Me.View_MaxPersonalEducationSearch1.Text.Length-3)
                    End If
                    If Me.View_MaxPersonalEducationSearch1.Text.EndsWith("...") then
                        Me.View_MaxPersonalEducationSearch1.Text = Me.View_MaxPersonalEducationSearch1.Text.SubString(0,Me.View_MaxPersonalEducationSearch1.Text.Length-3)
                        ' Strip the last word as well as it is likely only a partial word
                        Dim endindex As Integer = View_MaxPersonalEducationSearch1.Text.Length - 1
                        While (Not Char.IsWhiteSpace(View_MaxPersonalEducationSearch1.Text(endindex)) AndAlso endindex > 0)
                            endindex -= 1
                        End While
                        If endindex > 0 Then
                            View_MaxPersonalEducationSearch1.Text = View_MaxPersonalEducationSearch1.Text.Substring(0, endindex)
                        End If
              End If
            End If
            
              Dim formatedSearchText As String = MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1))
                
                ' After stripping "..." see if the search text is null or empty.
                If IsValueSelected(Me.View_MaxPersonalEducationSearch1) Then 
        ' These clauses are added depending on operator and fields selected in Control's property page, bindings tab.
                    
                    Dim search As WhereClause = New WhereClause()
                    
                    search.iOR(View_MaxPersonalEducationView.Course, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    search.iOR(View_MaxPersonalEducationView.CourseAbbr, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    search.iOR(View_MaxPersonalEducationView.Facultry, BaseFilter.ComparisonOperator.Contains, MiscUtils.GetSelectedValue(Me.View_MaxPersonalEducationSearch1, Me.GetFromSession(Me.View_MaxPersonalEducationSearch1)), True, False)
        
                    wc.iAND(search)
                  
                End If
            End If
                  
            Dim wc1 As WhereClause = Me.CreateWhereClause
            If wc1.Count > 0 Then
                wc.AddFilter(wc1.GetFilter(), CompoundFilter.CompoundingOperators.And_Operator)
            End If
          
            Return wc
        End Function			
            
        Public Overridable Function CreateWhereClause_SectionAbbvrNameFilter() As WhereClause
          
            ' Create a where clause for the filter SectionAbbvrNameFilter.
            ' This function is called by the Populate method to load the items 
            ' in the SectionAbbvrNameFilterDropDownList
            
            Dim wc As WhereClause= New WhereClause()
            Return wc
            
        End Function			
            

    
    
        Protected Overridable Sub Control_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
            ' PreRender event is raised just before page is being displayed.
            Try
                DbUtils.StartTransaction
                Me.RegisterPostback()
                
                If Not Me.Page.ErrorOnPage AndAlso (Me.Page.IsPageRefresh OrElse Me.DataChanged OrElse Me.ResetData) Then
                  
                    ' Call the Set methods for each controls on the panel that use resultset
                  
                SetCourseAbbrFilter()
                SetFacultryFilter()
                SetLevelFilter()
                SetRankLevelFromFilter()
                
                    ' Re-load the data and update the web page if necessary.
                    ' This is typically done during a postback (filter, search button, sort, pagination button).
                    ' In each of the other click handlers, simply set DataChanged to True to reload the data.
                    
                    Me.LoadData()
                    Me.DataBind()
                    
                End If
                
               
                				
            Catch ex As Exception
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
            Finally
                DbUtils.EndTransaction
            End Try
        End Sub
        
        
        Protected Overrides Sub SaveControlsToSession()
            MyBase.SaveControlsToSession()

            ' Save filter controls to values to session.
        
            Me.SaveToSession(Me.CourseAbbrFilter, Me.CourseAbbrFilter.SelectedValue)
                  
            Me.SaveToSession(Me.FacultryFilter, Me.FacultryFilter.SelectedValue)
                  
            Me.SaveToSession(Me.LevelFilter, Me.LevelFilter.SelectedValue)
                  
            Me.SaveToSession(Me.RankLevelFromFilter, Me.RankLevelFromFilter.SelectedValue)
                  
            Me.SaveToSession(Me.SectionAbbvrNameFilter, Me.SectionAbbvrNameFilter.SelectedValue)
                  
            Me.SaveToSession(Me.View_MaxPersonalEducationSearch1, Me.View_MaxPersonalEducationSearch1.Text)
                  
        
            'Save pagination state to session.
        
            
            
            ' Save table control properties to the session.
            If Not Me.CurrentSortOrder Is Nothing Then
            Me.SaveToSession(Me, "Order_By", Me.CurrentSortOrder.ToXmlString())
            End If
            
            Me.SaveToSession(Me, "Page_Index", Me.PageIndex.ToString())
            Me.SaveToSession(Me, "Page_Size", Me.PageSize.ToString())
        
            Me.SaveToSession(Me, "DeletedRecordIds", Me.DeletedRecordIds)  
        
        End Sub
        
        Protected  Sub SaveControlsToSession_Ajax()
            ' Save filter controls to values to session.
          
      Me.SaveToSession("CourseAbbrFilter_Ajax", Me.CourseAbbrFilter.SelectedValue)
              
      Me.SaveToSession("FacultryFilter_Ajax", Me.FacultryFilter.SelectedValue)
              
      Me.SaveToSession("LevelFilter_Ajax", Me.LevelFilter.SelectedValue)
              
      Me.SaveToSession("RankLevelFromFilter_Ajax", Me.RankLevelFromFilter.SelectedValue)
              
      Me.SaveToSession("SectionAbbvrNameFilter_Ajax", Me.SectionAbbvrNameFilter.SelectedValue)
              
      Me.SaveToSession("View_MaxPersonalEducationSearch1_Ajax", Me.View_MaxPersonalEducationSearch1.Text)
              
            HttpContext.Current.Session("AppRelativeVirtualPath") = Me.Page.AppRelativeVirtualPath
         
        End Sub
        
        Protected Overrides Sub ClearControlsFromSession()
            MyBase.ClearControlsFromSession()

            ' Clear filter controls values from the session.
        
            Me.RemoveFromSession(Me.CourseAbbrFilter)
            Me.RemoveFromSession(Me.FacultryFilter)
            Me.RemoveFromSession(Me.LevelFilter)
            Me.RemoveFromSession(Me.RankLevelFromFilter)
            Me.RemoveFromSession(Me.SectionAbbvrNameFilter)
            Me.RemoveFromSession(Me.View_MaxPersonalEducationSearch1)
    
            ' Clear pagination state from session.
        


    ' Clear table properties from the session.
    Me.RemoveFromSession(Me, "Order_By")
    Me.RemoveFromSession(Me, "Page_Index")
    Me.RemoveFromSession(Me, "Page_Size")
    
            Me.RemoveFromSession(Me, "DeletedRecordIds")  
            
        End Sub

        Protected Overrides Sub LoadViewState(ByVal savedState As Object)
            MyBase.LoadViewState(savedState)

            Dim orderByStr As String = CType(ViewState("View_MaxPersonalEducationTableControl_OrderBy"), String)
            
            If orderByStr IsNot Nothing AndAlso orderByStr.Trim <> "" Then
                Me.CurrentSortOrder = BaseClasses.Data.OrderBy.FromXmlString(orderByStr)
            Else
                Me.CurrentSortOrder = New OrderBy(True, False)
            End If
            
    Dim pageIndex As String = CType(ViewState("Page_Index"), String)
    If pageIndex IsNot Nothing Then
    Me.PageIndex = CInt(pageIndex)
    End If

    Dim pageSize As String = CType(ViewState("Page_Size"), String)
    If Not pageSize Is Nothing Then
    Me.PageSize = CInt(pageSize)
    End If

    
    
            ' Load view state for pagination control.
        
            Me.DeletedRecordIds = CType(Me.ViewState("DeletedRecordIds"), String)
        
        End Sub

        Protected Overrides Function SaveViewState() As Object
            
            If Me.CurrentSortOrder IsNot Nothing Then
                Me.ViewState("View_MaxPersonalEducationTableControl_OrderBy") = Me.CurrentSortOrder.ToXmlString()
            End If
                      
            Me.ViewState("Page_Index") = Me.PageIndex
            Me.ViewState("Page_Size") = Me.PageSize
            
            Me.ViewState("DeletedRecordIds") = Me.DeletedRecordIds
        
    
            ' Load view state for pagination control.
          
    
            Return MyBase.SaveViewState()
        End Function

        ' Generate the event handling functions for pagination events.
        
        ' event handler for ImageButton
        Public Overridable Sub View_MaxPersonalEducationPagination_FirstPage_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
    Try
    
            Me.PageIndex = 0
            Me.DataChanged = True
      
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
    
            End Try
                  
        End Sub
        
        ' event handler for ImageButton
        Public Overridable Sub View_MaxPersonalEducationPagination_LastPage_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
    Try
    
            Me.DisplayLastPage = True
            Me.DataChanged = True
      
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
    
            End Try
                  
        End Sub
        
        ' event handler for ImageButton
        Public Overridable Sub View_MaxPersonalEducationPagination_NextPage_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
    Try
    
            Me.PageIndex += 1
            Me.DataChanged = True
      
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
    
            End Try
                  
        End Sub
        
        ' event handler for LinkButton
        Public Overridable Sub View_MaxPersonalEducationPagination_PageSizeButton_Click(ByVal sender As Object, ByVal args As EventArgs)
              
    Try
    
            Me.DataChanged = True
      
            Me.PageSize = Integer.Parse(Me.View_MaxPersonalEducationPagination.PageSize.Text)
      
            Me.PageIndex = Integer.Parse(Me.View_MaxPersonalEducationPagination.CurrentPage.Text) - 1
          
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
    
            End Try
    
        End Sub
            
        ' event handler for ImageButton
        Public Overridable Sub View_MaxPersonalEducationPagination_PreviousPage_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
    Try
    
            If Me.PageIndex > 0 Then
                Me.PageIndex -= 1
                Me.DataChanged = True
            End If
      
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
    
            End Try
                  
        End Sub
        

        ' Generate the event handling functions for sorting events.
        
        Public Overridable Sub SectionAbbvrNameLabel_Click(ByVal sender As Object, ByVal args As EventArgs)
            ' Sorts by SectionAbbvrName when clicked.
              
            ' Get previous sorting state for SectionAbbvrName.
            
            Dim sd As OrderByItem = Me.CurrentSortOrder.Find(View_MaxPersonalEducationView.SectionAbbvrName)
            If sd Is Nothing OrElse (Me.CurrentSortOrder.Items IsNot Nothing Andalso Me.CurrentSortOrder.Items.Length > 1) Then
                ' First time sort, so add sort order for SectionAbbvrName.
                Me.CurrentSortOrder.Reset()
                Me.CurrentSortOrder.Add(View_MaxPersonalEducationView.SectionAbbvrName, OrderByItem.OrderDir.Asc)
            Else
                ' Previously sorted by SectionAbbvrName, so just reverse.
                sd.Reverse()
            End If
            
            ' Setting the DataChanged to True results in the page being refreshed with
            ' the most recent data from the database.  This happens in PreRender event
            ' based on the current sort, search and filter criteria.
            Me.DataChanged = True
              
        End Sub
            

        ' Generate the event handling functions for button events.
        
        ' event handler for ImageButton
        Public Overridable Sub View_MaxPersonalEducationExportCSVButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
    Try
    ' Enclose all database retrieval/update code within a Transaction boundary
                DbUtils.StartTransaction
                	
          ' Build the where clause based on the current filter and search criteria
          ' Create the Order By clause based on the user's current sorting preference.
          
              Dim wc As WhereClause = CreateWhereClause
              Dim orderBy As OrderBy = Nothing
              
              orderBy = CreateOrderBy
              
            ' Add each of the columns in order of export.
            Dim columns() as BaseColumn = New BaseColumn() { _
                     View_MaxPersonalEducationView.Level, _ 
             View_MaxPersonalEducationView.Course, _ 
             View_MaxPersonalEducationView.CourseAbbr, _ 
             View_MaxPersonalEducationView.Institue, _ 
             View_MaxPersonalEducationView.Facultry, _ 
             View_MaxPersonalEducationView.EdYear, _ 
             View_MaxPersonalEducationView.Country, _ 
             View_MaxPersonalEducationView.SectionAbbvrName, _ 
             View_MaxPersonalEducationView.RankAndName, _ 
             Nothing}          
            Dim  exportData as ExportDataToCSV = New ExportDataToCSV(View_MaxPersonalEducationView.Instance, wc, orderBy, columns)
            
            Dim done As Boolean = False

            Dim totalRowsReturned As Integer = 0
            Dim join As CompoundFilter = CreateCompoundJoinFilter()
            Dim data As DataForExport = New DataForExport(View_MaxPersonalEducationView.Instance, wc, orderBy, columns, join)

          'Check for Export Data Threshold
          Dim exportRawValues As Boolean = False          
          Me.TotalRecords = View_MaxPersonalEducationView.GetRecordCount(join, wc)          
          If Me.TotalRecords > 10000 Then
            exportRawValues = True
          End If
          exportData.StartExport(Me.Page.Response, exportRawValues)

          '  Read pageSize records at a time and write out the CSV file.
          While (Not done)
          Dim recList As ArrayList = data.GetRows(exportData.pageSize)
          If recList Is Nothing Then
          Exit While 'no more records we are done
          End If

          totalRowsReturned = recList.Count
          For Each rec As BaseRecord In recList
          For Each col As BaseColumn In data.ColumnList
          If col Is Nothing Then
          Continue For
          End If

          If Not data.IncludeInExport(col) Then
          Continue For
          End If

          Dim val As String = ""

          If exportRawValues Then
          val = rec.GetValue(col).ToString()
          Else
          Dim _isExpandableNonCompositeForeignKey As Boolean = col.TableDefinition.IsExpandableNonCompositeForeignKey(col)
          If _isExpandableNonCompositeForeignKey AndAlso col.IsApplyDisplayAs Then
          val = View_MaxPersonalEducationView.GetDFKA(rec.GetValue(col).ToString(), col, Nothing)
                    End If
                    If (Not _isExpandableNonCompositeForeignKey) Or (String.IsNullOrEmpty(val)) Then
                      val = exportData.GetDataForExport(col, rec)
                    End If
                  End If
                  exportData.WriteColumnData(val, data.IsString(col))

                Next col
                exportData.WriteNewRow()
              Next rec

              '  If we already are below the pageSize, then we are done.
              If totalRowsReturned < exportData.pageSize Then
                done = True
              End If
            End While
            exportData.FinishExport(Me.Page.Response)

        
            Catch ex As Exception
                ' Upon error, rollback the transaction
                Me.Page.RollBackTransaction(sender)
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
                DbUtils.EndTransaction
            End Try
                  
        End Sub
        
        ' event handler for ImageButton
        Public Overridable Sub View_MaxPersonalEducationExportExcelButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
    Try
    ' Enclose all database retrieval/update code within a Transaction boundary
                DbUtils.StartTransaction
                
            ' To customize the columns or the format, override this function in Section 1 of the page 
            ' and modify it to your liking.
            ' Build the where clause based on the current filter and search criteria
            ' Create the Order By clause based on the user's current sorting preference.
          
              Dim wc As WhereClause = CreateWhereClause
              Dim orderBy As OrderBy = Nothing
              
              orderBy = CreateOrderBy
              
              Dim done As Boolean = False
              Dim val As Object = ""
              ' Read pageSize records at a time and write out the Excel file.
              Dim totalRowsReturned As Integer = 0
          
              Me.TotalRecords = View_MaxPersonalEducationView.GetRecordCount(wc)
              If Me.TotalRecords > 10000 Then
          
              ' Add each of the columns in order of export.
              Dim columns() as BaseColumn = New BaseColumn() { _
                         View_MaxPersonalEducationView.Level, _ 
             View_MaxPersonalEducationView.Course, _ 
             View_MaxPersonalEducationView.CourseAbbr, _ 
             View_MaxPersonalEducationView.Institue, _ 
             View_MaxPersonalEducationView.Facultry, _ 
             View_MaxPersonalEducationView.EdYear, _ 
             View_MaxPersonalEducationView.Country, _ 
             View_MaxPersonalEducationView.SectionAbbvrName, _ 
             View_MaxPersonalEducationView.RankAndName, _ 
             Nothing}
              Dim  exportData as ExportDataToCSV = New ExportDataToCSV(View_MaxPersonalEducationView.Instance, wc, orderBy, columns)
              exportData.StartExport(Me.Page.Response, True)

              Dim dataForCSV As DataForExport = New DataForExport(View_MaxPersonalEducationView.Instance, wc, orderBy, columns)

              '  Read pageSize records at a time and write out the CSV file.
              While (Not done)
                  Dim recList As ArrayList = dataForCSV.GetRows(exportData.pageSize)
                  If recList Is Nothing Then
                      Exit While 'no more records we are done
                  End If

                  totalRowsReturned = recList.Count
                  For Each rec As BaseRecord In recList
                      For Each col As BaseColumn In dataForCSV.ColumnList
                          If col Is Nothing Then
                              Continue For
                          End If

                          If Not dataForCSV.IncludeInExport(col) Then
                              Continue For
                          End If

                          val = rec.GetValue(col).ToString()
                          exportData.WriteColumnData(val, dataForCSV.IsString(col))

                      Next col
                      exportData.WriteNewRow()
                  Next rec

                  '  If we already are below the pageSize, then we are done.
                  If totalRowsReturned < exportData.pageSize Then
                      done = True
                  End If
              End While
              exportData.FinishExport(Me.Page.Response)
          Else
          
              ' Create an instance of the Excel report class with the table class, where clause and order by.
              Dim excelReport As ExportDataToExcel = New ExportDataToExcel(View_MaxPersonalEducationView.Instance, wc, orderBy)
              ' Add each of the columns in order of export.
              ' To customize the data type, change the second parameter of the new ExcelColumn to be
              ' a format string from Excel's Format Cell menu. For example "dddd, mmmm dd, yyyy h:mm AM/PM;@", "#,##0.00"

              If Me.Page.Response Is Nothing Then
                Return
              End If

              excelReport.CreateExcelBook()

              Dim width As Integer = 0
              Dim columnCounter As Integer = 0
              Dim data As DataForExport = New DataForExport(View_MaxPersonalEducationView.Instance, wc, orderBy, Nothing)
                       data.ColumnList.Add(New ExcelColumn(View_MaxPersonalEducationView.Level, "Default"))
             data.ColumnList.Add(New ExcelColumn(View_MaxPersonalEducationView.Course, "Default"))
             data.ColumnList.Add(New ExcelColumn(View_MaxPersonalEducationView.CourseAbbr, "Default"))
             data.ColumnList.Add(New ExcelColumn(View_MaxPersonalEducationView.Institue, "Default"))
             data.ColumnList.Add(New ExcelColumn(View_MaxPersonalEducationView.Facultry, "Default"))
             data.ColumnList.Add(New ExcelColumn(View_MaxPersonalEducationView.EdYear, "Default"))
             data.ColumnList.Add(New ExcelColumn(View_MaxPersonalEducationView.Country, "Default"))
             data.ColumnList.Add(New ExcelColumn(View_MaxPersonalEducationView.SectionAbbvrName, "Default"))
             data.ColumnList.Add(New ExcelColumn(View_MaxPersonalEducationView.RankAndName, "Default"))


              For Each col As ExcelColumn In data.ColumnList
                  width = excelReport.GetExcelCellWidth(col)
                  If data.IncludeInExport(col) Then
                      excelReport.AddColumnToExcelBook(columnCounter, col.ToString(), excelReport.GetExcelDataType(col), width, excelReport.GetDisplayFormat(col))
                      columnCounter = columnCounter + 1
                  End If
              Next col
              
              While (Not done)
                  Dim recList As ArrayList = data.GetRows(excelReport.pageSize)

                  If recList Is Nothing Then
                      Exit While 'no more records we are done
                  End If

                  totalRowsReturned = recList.Count

                  For Each rec As BaseRecord In recList
                      excelReport.AddRowToExcelBook()
                      columnCounter = 0

                      For Each col As ExcelColumn In data.ColumnList
                          If Not data.IncludeInExport(col) Then
                              Continue For
                          End If

                          Dim _isExpandableNonCompositeForeignKey As Boolean = col.DisplayColumn.TableDefinition.IsExpandableNonCompositeForeignKey(col.DisplayColumn)
                          If _isExpandableNonCompositeForeignKey AndAlso col.DisplayColumn.IsApplyDisplayAs Then
                              val = View_MaxPersonalEducationView.GetDFKA(rec.GetValue(col.DisplayColumn).ToString(), col.DisplayColumn, Nothing)
                              If val Is Nothing Then
                                  val = rec.Format(col.DisplayColumn)
                              End If
                          Else
                              val = excelReport.GetValueForExcelExport(col, rec)
                          End If
                          excelReport.AddCellToExcelRow(columnCounter, excelReport.GetExcelDataType(col), val, col.DisplayFormat)

                          columnCounter = columnCounter + 1
                      Next col
                  Next rec

                  ' If we already are below the pageSize, then we are done.
                  If totalRowsReturned < excelReport.pageSize Then
                      done = True
                  End If
              End While

              excelReport.SaveExcelBook(Me.Page.Response)
          End If
        
            Catch ex As Exception
                ' Upon error, rollback the transaction
                Me.Page.RollBackTransaction(sender)
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
                DbUtils.EndTransaction
            End Try
                  
        End Sub
        
        ' event handler for ImageButton
        Public Overridable Sub View_MaxPersonalEducationPDFButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
    Try
    ' Enclose all database retrieval/update code within a Transaction boundary
                DbUtils.StartTransaction
                
                Dim report As PDFReport = New PDFReport() 
                report.SpecificReportFileName = Page.Server.MapPath("ShowViewMaxPersonalEducation.View_MaxPersonalEducationPDFButton.report")
                ' report.Title replaces the value tag of page header and footer containing ${ReportTitle}
                report.Title = "View_MaxPersonalEducation"
                ' If ShowViewMaxPersonalEducation.View_MaxPersonalEducationPDFButton.report specifies a valid report template,
                ' AddColumn method will generate a report template.   
                ' Each AddColumn method-call specifies a column
                ' The 1st parameter represents the text of the column header
                ' The 2nd parameter represents the horizontal alignment of the column header
                ' The 3rd parameter represents the text format of the column detail
                ' The 4th parameter represents the horizontal alignment of the column detail
                ' The 5th parameter represents the relative width of the column   			
                 report.AddColumn(View_MaxPersonalEducationView.Level.Name, ReportEnum.Align.Left, "${Level}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.Course.Name, ReportEnum.Align.Left, "${Course}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.CourseAbbr.Name, ReportEnum.Align.Left, "${CourseAbbr}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.Institue.Name, ReportEnum.Align.Left, "${Institue}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.Facultry.Name, ReportEnum.Align.Left, "${Facultry}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.EdYear.Name, ReportEnum.Align.Left, "${EdYear}", ReportEnum.Align.Left, 15)
                 report.AddColumn(View_MaxPersonalEducationView.Country.Name, ReportEnum.Align.Left, "${Country}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.SectionAbbvrName.Name, ReportEnum.Align.Left, "${SectionAbbvrName}", ReportEnum.Align.Left, 20)
                 report.AddColumn(View_MaxPersonalEducationView.RankAndName.Name, ReportEnum.Align.Left, "${RankAndName}", ReportEnum.Align.Left, 30)

          
                Dim rowsPerQuery As Integer = 5000 
                Dim recordCount As Integer = 0 
                                
                report.Page = Page.GetResourceValue("Txt:Page", "Persons")
                report.ApplicationPath = Me.Page.MapPath(Page.Request.ApplicationPath)
            
                Dim whereClause As WhereClause = CreateWhereClause
                Dim orderBy As OrderBy = CreateOrderBy
              Dim joinFilter As BaseFilter = CreateCompoundJoinFilter()
            
                Dim pageNum As Integer = 0 
                Dim totalRows As Integer = View_MaxPersonalEducationView.GetRecordCount(joinFilter,whereClause)
                Dim columns As ColumnList = View_MaxPersonalEducationView.GetColumnList()
                Dim records As View_MaxPersonalEducationRecord() = Nothing
            
                Do 
                    
                    records = View_MaxPersonalEducationView.GetRecords(joinFilter,whereClause, orderBy, pageNum, rowsPerQuery)
                    If Not (records Is Nothing) AndAlso records.Length > 0 AndAlso whereClause.RunQuery Then
                      For Each record As View_MaxPersonalEducationRecord In records 
                    
                            ' AddData method takes four parameters   
                            ' The 1st parameters represent the data format
                            ' The 2nd parameters represent the data value
                            ' The 3rd parameters represent the default alignment of column using the data
                            ' The 4th parameters represent the maximum length of the data value being shown
                                                         report.AddData("${Level}", record.Format(View_MaxPersonalEducationView.Level), ReportEnum.Align.Left, 100)
                             report.AddData("${Course}", record.Format(View_MaxPersonalEducationView.Course), ReportEnum.Align.Left, 100)
                             report.AddData("${CourseAbbr}", record.Format(View_MaxPersonalEducationView.CourseAbbr), ReportEnum.Align.Left, 100)
                             report.AddData("${Institue}", record.Format(View_MaxPersonalEducationView.Institue), ReportEnum.Align.Left, 100)
                             report.AddData("${Facultry}", record.Format(View_MaxPersonalEducationView.Facultry), ReportEnum.Align.Left, 100)
                             report.AddData("${EdYear}", record.Format(View_MaxPersonalEducationView.EdYear), ReportEnum.Align.Left, 100)
                             report.AddData("${Country}", record.Format(View_MaxPersonalEducationView.Country), ReportEnum.Align.Left, 100)
                             report.AddData("${SectionAbbvrName}", record.Format(View_MaxPersonalEducationView.SectionAbbvrName), ReportEnum.Align.Left, 100)
                             report.AddData("${RankAndName}", record.Format(View_MaxPersonalEducationView.RankAndName), ReportEnum.Align.Left)

                            report.WriteRow 
                        Next 
                        pageNum = pageNum + 1
                        recordCount += records.Length 
                    End If 
                Loop While Not (records Is Nothing) AndAlso recordCount < totalRows  AndAlso whereClause.RunQuery 
                
                report.Close 
                BaseClasses.Utils.NetUtils.WriteResponseBinaryAttachment(Me.Page.Response, report.Title + ".pdf", report.ReportInByteArray, 0, true)
          
            Catch ex As Exception
                ' Upon error, rollback the transaction
                Me.Page.RollBackTransaction(sender)
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
                DbUtils.EndTransaction
            End Try
                  
        End Sub
        
        ' event handler for ImageButton
        Public Overridable Sub View_MaxPersonalEducationRefreshButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
    Try
    
            Dim View_MaxPersonalEducationTableControlObj as View_MaxPersonalEducationTableControl = DirectCast(Me.Page.FindControlRecursively("View_MaxPersonalEducationTableControl"), View_MaxPersonalEducationTableControl)
            View_MaxPersonalEducationTableControlObj.ResetData = True
                        
            View_MaxPersonalEducationTableControlObj.RemoveFromSession(View_MaxPersonalEducationTableControlObj, "DeletedRecordIds")
            View_MaxPersonalEducationTableControlObj.DeletedRecordIds = Nothing
            
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
    
            End Try
                  
        End Sub
        
        ' event handler for ImageButton
        Public Overridable Sub View_MaxPersonalEducationResetButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
    Try
    
              Me.CourseAbbrFilter.ClearSelection()
              Me.FacultryFilter.ClearSelection()
              Me.LevelFilter.ClearSelection()
              Me.RankLevelFromFilter.ClearSelection()
              Me.SectionAbbvrNameFilter.ClearSelection()
              Me.View_MaxPersonalEducationSearch1.Text = ""
              Me.CurrentSortOrder.Reset()
              If Me.InSession(Me, "Order_By") Then
                  Me.CurrentSortOrder = OrderBy.FromXmlString(Me.GetFromSession(Me, "Order_By", Nothing))
              Else
                  Me.CurrentSortOrder = New OrderBy(True, False)
                  

              End If
              

        ' Setting the DataChanged to True results in the page being refreshed with
        ' the most recent data from the database.  This happens in PreRender event
        ' based on the current sort, search and filter criteria.
        Me.DataChanged = True
            
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
    
            End Try
                  
        End Sub
        
        ' event handler for ImageButton
        Public Overridable Sub View_MaxPersonalEducationWordButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
    Try
    ' Enclose all database retrieval/update code within a Transaction boundary
                DbUtils.StartTransaction
                
                Dim report As WordReport = New WordReport
                report.SpecificReportFileName = Page.Server.MapPath("ShowViewMaxPersonalEducation.View_MaxPersonalEducationWordButton.word")
                ' report.Title replaces the value tag of page header and footer containing ${ReportTitle}
                report.Title = "View_MaxPersonalEducation"
                ' If ShowViewMaxPersonalEducation.View_MaxPersonalEducationWordButton.report specifies a valid report template,
                ' AddColumn method will generate a report template.
                ' Each AddColumn method-call specifies a column
                ' The 1st parameter represents the text of the column header
                ' The 2nd parameter represents the horizontal alignment of the column header
                ' The 3rd parameter represents the text format of the column detail
                ' The 4th parameter represents the horizontal alignment of the column detail
                ' The 5th parameter represents the relative width of the column
                 report.AddColumn(View_MaxPersonalEducationView.Level.Name, ReportEnum.Align.Left, "${Level}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.Course.Name, ReportEnum.Align.Left, "${Course}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.CourseAbbr.Name, ReportEnum.Align.Left, "${CourseAbbr}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.Institue.Name, ReportEnum.Align.Left, "${Institue}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.Facultry.Name, ReportEnum.Align.Left, "${Facultry}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.EdYear.Name, ReportEnum.Align.Left, "${EdYear}", ReportEnum.Align.Left, 15)
                 report.AddColumn(View_MaxPersonalEducationView.Country.Name, ReportEnum.Align.Left, "${Country}", ReportEnum.Align.Left, 30)
                 report.AddColumn(View_MaxPersonalEducationView.SectionAbbvrName.Name, ReportEnum.Align.Left, "${SectionAbbvrName}", ReportEnum.Align.Left, 20)
                 report.AddColumn(View_MaxPersonalEducationView.RankAndName.Name, ReportEnum.Align.Left, "${RankAndName}", ReportEnum.Align.Left, 30)

              Dim whereClause As WhereClause = CreateWhereClause
              
              Dim orderBy As OrderBy = CreateOrderBy
              Dim joinFilter As BaseFilter = CreateCompoundJoinFilter()
                
                Dim rowsPerQuery As Integer = 5000
                Dim pageNum As Integer = 0
                Dim recordCount As Integer = 0
                Dim totalRows As Integer = View_MaxPersonalEducationView.GetRecordCount(joinFilter,whereClause)

                report.Page = Page.GetResourceValue("Txt:Page", "Persons")
                report.ApplicationPath = Me.Page.MapPath(Page.Request.ApplicationPath)

                Dim columns As ColumnList = View_MaxPersonalEducationView.GetColumnList()
                Dim records As View_MaxPersonalEducationRecord() = Nothing
                Do
                    records = View_MaxPersonalEducationView.GetRecords(joinFilter,whereClause, orderBy, pageNum, rowsPerQuery)
                    
                    If Not (records Is Nothing) AndAlso records.Length > 0 AndAlso whereClause.RunQuery Then
                      For Each record As View_MaxPersonalEducationRecord In records
                            ' AddData method takes four parameters
                            ' The 1st parameters represent the data format
                            ' The 2nd parameters represent the data value
                            ' The 3rd parameters represent the default alignment of column using the data
                            ' The 4th parameters represent the maximum length of the data value being shown
                             report.AddData("${Level}", record.Format(View_MaxPersonalEducationView.Level), ReportEnum.Align.Left, 100)
                             report.AddData("${Course}", record.Format(View_MaxPersonalEducationView.Course), ReportEnum.Align.Left, 100)
                             report.AddData("${CourseAbbr}", record.Format(View_MaxPersonalEducationView.CourseAbbr), ReportEnum.Align.Left, 100)
                             report.AddData("${Institue}", record.Format(View_MaxPersonalEducationView.Institue), ReportEnum.Align.Left, 100)
                             report.AddData("${Facultry}", record.Format(View_MaxPersonalEducationView.Facultry), ReportEnum.Align.Left, 100)
                             report.AddData("${EdYear}", record.Format(View_MaxPersonalEducationView.EdYear), ReportEnum.Align.Left, 100)
                             report.AddData("${Country}", record.Format(View_MaxPersonalEducationView.Country), ReportEnum.Align.Left, 100)
                             report.AddData("${SectionAbbvrName}", record.Format(View_MaxPersonalEducationView.SectionAbbvrName), ReportEnum.Align.Left, 100)
                             report.AddData("${RankAndName}", record.Format(View_MaxPersonalEducationView.RankAndName), ReportEnum.Align.Left)

                            report.WriteRow
                        Next
                        pageNum = pageNum + 1
                        recordCount += records.Length
                    End If
                Loop While Not (records Is Nothing) AndAlso recordCount < totalRows AndAlso whereClause.RunQuery 
                report.save
                BaseClasses.Utils.NetUtils.WriteResponseBinaryAttachment(Me.Page.Response, report.Title + ".doc", report.ReportInByteArray, 0, true)
          
            Catch ex As Exception
                ' Upon error, rollback the transaction
                Me.Page.RollBackTransaction(sender)
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
                DbUtils.EndTransaction
            End Try
                  
        End Sub
        
        ' event handler for Button with Layout
        Public Overridable Sub View_MaxPersonalEducationSearchButton1_Click(ByVal sender As Object, ByVal args As EventArgs)
              
    Try
    
          Me.DataChanged = True
      
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                ' Report the error message to the end user
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
    
            Finally
    
            End Try
    
        End Sub
            
      

        ' Generate the event handling functions for filter and search events.
        
        ' event handler for FieldFilter
        Protected Overridable Sub CourseAbbrFilter_SelectedIndexChanged(ByVal sender As Object, ByVal args As EventArgs)
           ' Setting the DataChanged to True results in the page being refreshed with
           ' the most recent data from the database.  This happens in PreRender event
           ' based on the current sort, search and filter criteria.
           Me.DataChanged = True
           
          	   
        End Sub
            
        ' event handler for FieldFilter
        Protected Overridable Sub FacultryFilter_SelectedIndexChanged(ByVal sender As Object, ByVal args As EventArgs)
           ' Setting the DataChanged to True results in the page being refreshed with
           ' the most recent data from the database.  This happens in PreRender event
           ' based on the current sort, search and filter criteria.
           Me.DataChanged = True
           
          	   
        End Sub
            
        ' event handler for FieldFilter
        Protected Overridable Sub LevelFilter_SelectedIndexChanged(ByVal sender As Object, ByVal args As EventArgs)
           ' Setting the DataChanged to True results in the page being refreshed with
           ' the most recent data from the database.  This happens in PreRender event
           ' based on the current sort, search and filter criteria.
           Me.DataChanged = True
           
          	   
        End Sub
            
        ' event handler for FieldFilter
        Protected Overridable Sub RankLevelFromFilter_SelectedIndexChanged(ByVal sender As Object, ByVal args As EventArgs)
           ' Setting the DataChanged to True results in the page being refreshed with
           ' the most recent data from the database.  This happens in PreRender event
           ' based on the current sort, search and filter criteria.
           Me.DataChanged = True
           
          	   
        End Sub
            
        ' event handler for FieldFilter
        Protected Overridable Sub SectionAbbvrNameFilter_SelectedIndexChanged(ByVal sender As Object, ByVal args As EventArgs)
           ' Setting the DataChanged to True results in the page being refreshed with
           ' the most recent data from the database.  This happens in PreRender event
           ' based on the current sort, search and filter criteria.
           Me.DataChanged = True
           
          	   
        End Sub
            
      
        ' Generate the event handling functions for others
        
      
        Private _UIData As New System.Collections.Generic.List(Of Hashtable)
        Public Property UIData() As System.Collections.Generic.List(Of Hashtable)
            Get
                Return Me._UIData
            End Get
            Set(ByVal value As System.Collections.Generic.List(Of Hashtable))
                Me._UIData = value
            End Set
        End Property
        
        ' pagination properties
        Protected _PageSize As Integer
        Public Property PageSize() As Integer
            Get
                Return Me._PageSize
            End Get
            Set(ByVal value As Integer)
                Me._PageSize = value
            End Set
        End Property

        Protected _PageIndex As Integer
        Public Property PageIndex() As Integer
            Get
                ' Return the PageIndex
                Return Me._PageIndex
            End Get
            Set(ByVal value As Integer)
                Me._PageIndex = value
            End Set
        End Property

        Protected _TotalRecords As Integer = -1
        Public Property TotalRecords() As Integer
            Get
                If _TotalRecords < 0 
                    _TotalRecords = View_MaxPersonalEducationView.GetRecordCount(CreateCompoundJoinFilter(), CreateWhereClause())
                End If
                Return Me._TotalRecords
            End Get
            Set(ByVal value As Integer)
                If Me.PageSize > 0 Then
                
                    Me.TotalPages = CInt(Math.Ceiling(value / Me.PageSize))
                  
                End If
                Me._TotalRecords = value
            End Set
        End Property

        
    
        Protected _TotalPages As Integer = -1
        Public Property TotalPages() As Integer
            Get
                If _TotalPages < 0 Then
                
                    Me.TotalPages = CInt(Math.Ceiling(TotalRecords / Me.PageSize))
                  
                End If                
                Return Me._TotalPages
            End Get
            Set(ByVal value As Integer)
                Me._TotalPages = value
            End Set
        End Property

        Protected _DisplayLastPage As Boolean
        Public Property DisplayLastPage() As Boolean
            Get
                Return Me._DisplayLastPage
            End Get
            Set(ByVal value As Boolean)
                Me._DisplayLastPage = value
            End Set
        End Property

        Private _DataChanged As Boolean = False
        Public Property DataChanged() As Boolean
            Get
                Return Me._DataChanged
            End Get
            Set(ByVal value As Boolean)
                Me._DataChanged = value
            End Set
        End Property
        
        Private _ResetData As Boolean = False
        Public Property ResetData() As Boolean
            Get
                Return Me._ResetData
            End Get
            Set(ByVal value As Boolean)
                Me._ResetData = value
            End Set
        End Property

        Private _AddNewRecord As Integer = 0
        Public Property AddNewRecord() As Integer
            Get
                Return Me._AddNewRecord
            End Get
            Set(ByVal value As Integer)
                Me._AddNewRecord = value
            End Set
        End Property

        
        Private _CurrentSortOrder As OrderBy = Nothing
        Public Property CurrentSortOrder() As OrderBy
            Get
                Return Me._CurrentSortOrder
            End Get
            Set(ByVal value As BaseClasses.Data.OrderBy)
                Me._CurrentSortOrder = value
            End Set
        End Property
        
        Private _DataSource() As View_MaxPersonalEducationRecord = Nothing
        Public Property DataSource() As View_MaxPersonalEducationRecord ()
            Get
                Return Me._DataSource
            End Get
            Set(ByVal value() As View_MaxPersonalEducationRecord)
                Me._DataSource = value
            End Set
        End Property
       
#Region "Helper Properties"
        
        Public ReadOnly Property CountryLabel() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "CountryLabel"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property CourseAbbrFilter() As System.Web.UI.WebControls.DropDownList
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "CourseAbbrFilter"), System.Web.UI.WebControls.DropDownList)
            End Get
        End Property
        
        Public ReadOnly Property CourseAbbrLabel() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "CourseAbbrLabel"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property CourseAbbrLabel1() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "CourseAbbrLabel1"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property CourseLabel() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "CourseLabel"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property EdYearLabel() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "EdYearLabel"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property FacultryFilter() As System.Web.UI.WebControls.DropDownList
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "FacultryFilter"), System.Web.UI.WebControls.DropDownList)
            End Get
        End Property
        
        Public ReadOnly Property FacultryLabel() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "FacultryLabel"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property FacultryLabel1() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "FacultryLabel1"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property InstitueLabel() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "InstitueLabel"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property LevelFilter() As System.Web.UI.WebControls.DropDownList
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "LevelFilter"), System.Web.UI.WebControls.DropDownList)
            End Get
        End Property
        
        Public ReadOnly Property LevelLabel() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "LevelLabel"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property LevelLabel1() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "LevelLabel1"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property PersonalNameLabel() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "PersonalNameLabel"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property RankLevelFromFilter() As System.Web.UI.WebControls.DropDownList
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "RankLevelFromFilter"), System.Web.UI.WebControls.DropDownList)
            End Get
        End Property
        
        Public ReadOnly Property RankLevelLabel() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "RankLevelLabel"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property SectionAbbvrNameFilter() As System.Web.UI.WebControls.DropDownList
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "SectionAbbvrNameFilter"), System.Web.UI.WebControls.DropDownList)
            End Get
        End Property
        
        Public ReadOnly Property SectionAbbvrNameLabel() As System.Web.UI.WebControls.LinkButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "SectionAbbvrNameLabel"), System.Web.UI.WebControls.LinkButton)
            End Get
        End Property
        
        Public ReadOnly Property SectionAbbvrNameLabel1() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "SectionAbbvrNameLabel1"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property View_MaxPersonalEducationExportCSVButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationExportCSVButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property View_MaxPersonalEducationExportExcelButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationExportExcelButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property View_MaxPersonalEducationPagination() As Persons.UI.IPagination
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationPagination"), Persons.UI.IPagination)
          End Get
          End Property
        
        Public ReadOnly Property View_MaxPersonalEducationPDFButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationPDFButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property View_MaxPersonalEducationRefreshButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationRefreshButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property View_MaxPersonalEducationResetButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationResetButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property View_MaxPersonalEducationSearch1() As System.Web.UI.WebControls.TextBox
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationSearch1"), System.Web.UI.WebControls.TextBox)
            End Get
        End Property
        
        Public ReadOnly Property View_MaxPersonalEducationSearchButton1() As Persons.UI.IThemeButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationSearchButton1"), Persons.UI.IThemeButton)
          End Get
          End Property
        
        Public ReadOnly Property View_MaxPersonalEducationTableControlCollapsibleRegion() As System.Web.UI.WebControls.Panel
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationTableControlCollapsibleRegion"), System.Web.UI.WebControls.Panel)
            End Get
        End Property
        
        Public ReadOnly Property View_MaxPersonalEducationTableControlIcon() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationTableControlIcon"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property View_MaxPersonalEducationTableControlPanelExtender() As AjaxControlToolkit.CollapsiblePanelExtender
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationTableControlPanelExtender"), AjaxControlToolkit.CollapsiblePanelExtender)
            End Get
        End Property
        
        Public ReadOnly Property View_MaxPersonalEducationTitle() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationTitle"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property View_MaxPersonalEducationWordButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "View_MaxPersonalEducationWordButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
#End Region

#Region "Helper Functions"
        
        Public Overrides Overloads Function ModifyRedirectUrl(url As String, arg As String, ByVal bEncrypt As Boolean) As String
            Return Me.Page.EvaluateExpressions(url, arg, bEncrypt, Me)
        End Function
      
        Public Overrides Overloads Function EvaluateExpressions(url As String, arg As String, ByVal bEncrypt As Boolean) As String
            Dim needToProcess As Boolean = AreAnyUrlParametersForMe(url, arg)
            If (needToProcess) Then
                Dim recCtl As View_MaxPersonalEducationTableControlRow = Me.GetSelectedRecordControl()
                If recCtl Is Nothing AndAlso url.IndexOf("{") >= 0 Then
                    ' Localization.
                    Throw New Exception(Page.GetResourceValue("Err:NoRecSelected", "Persons"))
                End If
                Dim rec As View_MaxPersonalEducationRecord = Nothing     
                If recCtl IsNot Nothing Then
                    rec = recCtl.GetRecord()
                End If
                Return EvaluateExpressions(url, arg, rec, bEncrypt)
            End If
            Return url
        End Function
          
        Public Overridable Function GetSelectedRecordControl() As View_MaxPersonalEducationTableControlRow
            Return Nothing
          
        End Function

        Public Overridable Function GetSelectedRecordControls() As View_MaxPersonalEducationTableControlRow()
        
            Return DirectCast((new ArrayList()).ToArray(GetType(View_MaxPersonalEducationTableControlRow)), View_MaxPersonalEducationTableControlRow())
          
        End Function

        Public Overridable Sub DeleteSelectedRecords(ByVal deferDeletion As Boolean)
            Dim recList() As View_MaxPersonalEducationTableControlRow = Me.GetSelectedRecordControls()
            If recList.Length = 0 Then
                ' Localization.
                Throw New Exception(Page.GetResourceValue("Err:NoRecSelected", "Persons"))
            End If
            
            Dim recCtl As View_MaxPersonalEducationTableControlRow
            For Each recCtl In recList
                If deferDeletion Then
                    If Not recCtl.IsNewRecord Then
                
                        Me.AddToDeletedRecordIds(recCtl)
                  
                    End If
                    recCtl.Visible = False
                
                Else
                
                    recCtl.Delete()
                    
                    ' Setting the DataChanged to True results in the page being refreshed with
                    ' the most recent data from the database.  This happens in PreRender event
                    ' based on the current sort, search and filter criteria.
                    Me.DataChanged = True
                    Me.ResetData = True
                  
                End If
            Next
        End Sub

        Public Function GetRecordControls() As View_MaxPersonalEducationTableControlRow()
            Dim recList As ArrayList = New ArrayList()
            Dim rep As System.Web.UI.WebControls.Repeater = CType(Me.FindControl("View_MaxPersonalEducationTableControlRepeater"), System.Web.UI.WebControls.Repeater)
            If rep Is Nothing Then Return Nothing
            Dim repItem As System.Web.UI.WebControls.RepeaterItem

            For Each repItem In rep.Items
            
                Dim recControl As View_MaxPersonalEducationTableControlRow = DirectCast(repItem.FindControl("View_MaxPersonalEducationTableControlRow"), View_MaxPersonalEducationTableControlRow)
                recList.Add(recControl)
              
            Next

            Return DirectCast(recList.ToArray(GetType(View_MaxPersonalEducationTableControlRow)), View_MaxPersonalEducationTableControlRow())
        End Function

        Public Shadows ReadOnly Property Page() As BaseApplicationPage
            Get
                Return DirectCast(MyBase.Page, BaseApplicationPage)
            End Get
        End Property

#End Region

    

End Class

  

#End Region
    
  
End Namespace

  